package org.rcisoft.business.excelimport.common;

import lombok.NoArgsConstructor;
import org.rcisoft.business.jzmessage.common.DictionaryMap;

@NoArgsConstructor
public enum BaseTitleHead {
    // tableHead的枚举类 tableType为其对应的数据字典的type--------------！！！
    TABLE_HEAD_JZ_CODE("基站号", null),
    TABLE_HEAD_JZ_NAME("基站名",null),
    TABLE_HEAD_JZ_EVM("基站二维码", null),
    TABLE_HEAD_PROJECT_ID("项目编号", null),
    TABLE_HEAD_TASK_LINE("业务线", DictionaryMap.jzYwx),
    TABLE_HEAD_QY("区域", DictionaryMap.jzLocation),
    TABLE_HEAD_PROJECT_STATUS("项目地址", null),
    TABLE_HEAD_CURRENT_MAN("阶段负责人", null),
    TABLE_HEAD_PROJECT_MAN("项目负责人", null),
    TABLE_HEAD_UP_USER("上游客户", null),
    TABLE_HEAD_UP_TTUSER("上游铁塔客户", DictionaryMap.jzTtUpper),
    TABLE_HEAD_UP_YDUSER("上游移动客户", DictionaryMap.jzYdUpper),
    TABLE_HEAD_OPERATOR("运营商", null),
    TABLE_HEAD_OPERATOR_DJ("0", DictionaryMap.jzDjYys), //代缴
    TABLE_HEAD_OPERATOR_YD("1", DictionaryMap.jzYdYys), //移动
    TABLE_HEAD_OPERATOR_TT("2", DictionaryMap.jzTtYys), //铁塔

    TABLE_HEAD_DEMAN_ID("需求号", null),
    TABLE_HEAD_BUILD_WAY("建设方式", DictionaryMap.jzBuild),
    TABLE_HEAD_MOBILE_RELATION("移动关系", null),
    TABLE_HEAD_MOBILE_CONTACT("移动联系方式", null),
    TABLE_HEAD_LONGITUDE("经度", null),
    TABLE_HEAD_DIMENSION("纬度", null),
    TABLE_HEAD_MAP_LINK("地图链接", null),
    TABLE_HEAD_CREATE_DATE("基站创建日期(yyyy-MM-dd)", null)

    ;


    private String tableHead;
    private String tableType;
    BaseTitleHead(String tableHead, String tableType) {
        this.tableType = tableType;
        this.tableHead = tableHead;
    }

    public String getStatus() {
        return tableHead;
    }

    public void setStatus(String tableHead) {
        this.tableHead = tableHead;
    }

    public String getTableType() {
        return tableType;
    }

    public void setTableType(String tableType) {
        this.tableType = tableType;
    }

}
