package org.rcisoft.business.excelimport.tbexcelinfo.service;

import org.rcisoft.business.excelimport.tbexcelinfo.entity.TbExcelInfo;
import org.rcisoft.core.model.CyPersistModel;
import org.rcisoft.core.aop.CyPageUtil;

import java.util.List;

/**
 * Created by zyj on 2019-8-3 0:55:38.
 */
public interface TbExcelInfoService {

    /**
    * 保存 
    * @param tbExcelInfo
    * @return
    */
    CyPersistModel save(TbExcelInfo tbExcelInfo);

    /**
    * 删除 
    * @param tbExcelInfo
    * @return
    */
    CyPersistModel remove(TbExcelInfo tbExcelInfo);
    /**
    * 逻辑删除 
    * @param tbExcelInfo
    * @return
    */
    CyPersistModel removeLogical(TbExcelInfo tbExcelInfo);
    /**
    * 修改 
    * @param tbExcelInfo
    * @return
    */
    CyPersistModel merge(TbExcelInfo tbExcelInfo);

    /**
    * 根据id查询 
    * @param id
    * @return
    */
    TbExcelInfo findById(String id);

    /**
    * 分页查询 
    * @param tbExcelInfo
    * @return
    */
    List<TbExcelInfo> findAllByPagination(CyPageUtil<TbExcelInfo> paginationUtility,
                                          TbExcelInfo tbExcelInfo);


    /**
    * 查询list 
    * @param tbExcelInfo
    * @return
    */
    List<TbExcelInfo> findAll(TbExcelInfo tbExcelInfo);

    /**
     * 根据userId查询
     * @param id
     * @return
     */
    List<TbExcelInfo> findByUserId(String id);

}
