package org.rcisoft.business.excelimport.tbexceljzmessageimport.controller;


/*固定导入*/
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import javafx.util.Pair;
import lombok.extern.slf4j.Slf4j;
import org.apache.ibatis.annotations.Param;
import org.rcisoft.business.excelimport.importMethod.PoiMethod;
import org.springframework.security.authentication.UsernamePasswordAuthenticationToken;
import org.springframework.security.core.context.SecurityContextHolder;
import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.security.core.userdetails.UserDetailsService;
import org.springframework.security.web.authentication.WebAuthenticationDetailsSource;
import org.springframework.validation.BindingResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import org.rcisoft.core.result.CyResult;
import org.rcisoft.core.util.CyResultGenUtil;
import org.rcisoft.core.model.CyPersistModel;
import org.rcisoft.core.constant.CyMessCons;
import org.rcisoft.core.controller.CyPaginationController;
import org.rcisoft.core.util.CyUserUtil;
import org.rcisoft.core.model.CyGridModel;
import org.rcisoft.core.exception.CyServiceException;
import javax.validation.Valid;
import javax.websocket.server.PathParam;


import org.rcisoft.business.excelimport.tbexceljzmessageimport.entity.TbExcelJzMessageImport;
import org.rcisoft.business.excelimport.tbexceljzmessageimport.service.TbExcelJzMessageImportService;
import org.springframework.web.multipart.MultipartFile;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
* Created by zyj on 2019-8-3 0:55:39.
*/
@RestController
@Slf4j
@RequestMapping("/tbexceljzmessageimport")
public class TbExcelJzMessageImportController extends CyPaginationController<TbExcelJzMessageImport> {

    @Autowired
    private TbExcelJzMessageImportService tbExcelJzMessageImportServiceImpl;

    @ApiOperation(value="添加", notes="添加")
    //@ApiImplicitParams({@ApiImplicitParam(name = "businessId", value = "businessId", required = false, dataType = "varchar")})
    @PostMapping(value = "/add")
    public CyResult add(@Valid TbExcelJzMessageImport tbExcelJzMessageImport, BindingResult bindingResult) {
        CyPersistModel data = tbExcelJzMessageImportServiceImpl.save(tbExcelJzMessageImport);
        return CyResultGenUtil.builder(data,
            CyMessCons.MESSAGE_ALERT_SUCCESS,
            CyMessCons.MESSAGE_ALERT_ERROR,
        tbExcelJzMessageImport);
    }
    @ApiOperation(value="逻辑删除", notes="逻辑删除")
    @ApiImplicitParams({@ApiImplicitParam(name = "businessId", value = "businessId", required = true, dataType = "varchar")})
    @DeleteMapping("/deleteLogical/{businessId:\\w+}")
    public CyResult deleteLogical(@PathVariable String businessId,TbExcelJzMessageImport tbExcelJzMessageImport) {
        tbExcelJzMessageImport.setBusinessId(businessId);
        CyPersistModel data = tbExcelJzMessageImportServiceImpl.removeLogical(tbExcelJzMessageImport);
        return CyResultGenUtil.builder(data,
            CyMessCons.MESSAGE_ALERT_SUCCESS,
            CyMessCons.MESSAGE_ALERT_ERROR,
        businessId);
    }

    @ApiOperation(value="删除", notes="删除")
    @ApiImplicitParams({@ApiImplicitParam(name = "businessId", value = "businessId", required = true, dataType = "varchar")})
    @DeleteMapping("/delete/{businessId:\\w+}")
    public CyResult delete(@PathVariable String businessId,TbExcelJzMessageImport tbExcelJzMessageImport) {
        tbExcelJzMessageImport.setBusinessId(businessId);
        CyPersistModel data = tbExcelJzMessageImportServiceImpl.remove(tbExcelJzMessageImport);
        return CyResultGenUtil.builder(data,
            CyMessCons.MESSAGE_ALERT_SUCCESS,
            CyMessCons.MESSAGE_ALERT_ERROR,
        businessId);
    }

    @ApiOperation(value="修改", notes="修改")
    @ApiImplicitParams({@ApiImplicitParam(name = "businessId", value = "businessId", required = false, dataType = "varchar")})
    @PutMapping("/update/{businessId:\\w+}")
    public CyResult update(@PathVariable String businessId, @Valid TbExcelJzMessageImport tbExcelJzMessageImport, BindingResult bindingResult) {
        tbExcelJzMessageImport.setBusinessId(businessId);
        CyPersistModel data = tbExcelJzMessageImportServiceImpl.merge(tbExcelJzMessageImport);
        return CyResultGenUtil.builder(data,
            CyMessCons.MESSAGE_ALERT_SUCCESS,
            CyMessCons.MESSAGE_ALERT_ERROR,
        tbExcelJzMessageImport);
    }

    @ApiOperation(value="查询单一", notes="查询单一")
    @ApiImplicitParams({@ApiImplicitParam(name = "businessId", value = "businessId", required = true, dataType = "varchar")})
    @GetMapping("/detail/{businessId:\\w+}")
    public CyResult detail(@PathVariable String businessId) {
        return CyResultGenUtil.builder(new CyPersistModel(1),
            CyMessCons.MESSAGE_ALERT_SUCCESS,
            CyMessCons.MESSAGE_ALERT_ERROR,
        tbExcelJzMessageImportServiceImpl.findById(businessId));
    }

    @ApiOperation(value="查询集合", notes="查询集合")
    @GetMapping(value = "/queryTbExcelJzMessageImports")
    public CyResult queryTbExcelJzMessageImports(TbExcelJzMessageImport tbExcelJzMessageImport) {
        return CyResultGenUtil.builder(new CyPersistModel(1),
            CyMessCons.MESSAGE_ALERT_SUCCESS,
            CyMessCons.MESSAGE_ALERT_ERROR,
            tbExcelJzMessageImportServiceImpl.findAll(tbExcelJzMessageImport));
    }

    @ApiOperation(value="分页查询集合", notes="分页查询集合")
    @GetMapping(value = "/queryTbExcelJzMessageImportByPagination")
    public CyGridModel listByPagination(TbExcelJzMessageImport tbExcelJzMessageImport) {
        tbExcelJzMessageImportServiceImpl.findAllByPagination(getPaginationUtility(), tbExcelJzMessageImport);
        return getGridModelResponse();
    }

    //excel导入的要求： 字间不能有空格！！！！！ 前后空格已用 String.trim() 删除
    @ApiOperation(value="导入Excel", notes="导入Excel")
    @PostMapping(value = "/importExcel")
    //file 为前台不必传的数据， excelId， excel excelType excelList 为必传字段 若没有数据请传 ""
    public CyResult importExcel(@RequestParam(value = "file", required = false) MultipartFile file, @RequestParam("type") String excelType, @RequestParam("excelId") String excelId, @RequestParam("excelList") String excelList) {
        //将json字符串转换为list------------------------------------------------
        //Map的value不能为String, 因为含有BigDecimal的字段，（String）BigDecimal不能强转！！！！！！
        List<Map<String, Object>> parseObject = new ArrayList<>();
        if (!"".equals(excelList)) {
            parseObject  = (List<Map<String, Object>>) JSON.parseObject(excelList,List.class);
        }
        else {
            parseObject = null;
        }
        //----------------------------------------------------------------------
        Pair<List<TbExcelJzMessageImport>, List<Pair<Integer, Integer>>> result = tbExcelJzMessageImportServiceImpl.importExcel(file, excelType, excelId, parseObject);
        //最终要传的东西，若表头错误则传null， 若完全成功则 result.getKey()为null，若部分成功则result.getKey()有数据
        Pair<List<TbExcelJzMessageImport>, String> ans = null;
        if (result == null) {
            ans = null;
        } else if(result.getKey() == null){
            return CyResultGenUtil.builder(new CyPersistModel(0),
                    CyMessCons.MESSAGE_ALERT_SUCCESS,
                    CyMessCons.MESSAGE_ALERT_ERROR,
                    ans);
        } else {
            ans = new Pair<List<TbExcelJzMessageImport>, String> (result.getKey(), excelType);
        }
        return CyResultGenUtil.builder(new CyPersistModel(1),
                CyMessCons.MESSAGE_ALERT_SUCCESS,
                CyMessCons.MESSAGE_ALERT_ERROR,
                ans);
    }
}
