package org.rcisoft.business.excelimport.tbexceljzmessageimport.dao;

import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.Param;
import org.rcisoft.business.jzmessage.entity.JzMessage;
import org.rcisoft.core.base.CyBaseMapper;
import org.rcisoft.business.excelimport.tbexceljzmessageimport.entity.TbExcelJzMessageImport;
import org.apache.ibatis.annotations.ResultMap;
import org.apache.ibatis.annotations.Select;
import org.springframework.stereotype.Repository;


import java.util.List;

/**
* Created with zyj on 2019-8-3 0:55:39.
*/
@Repository
public interface TbExcelJzMessageImportRepository extends CyBaseMapper<TbExcelJzMessageImport> {

    /**
    * 分页查询 tbExcelJzMessageImport
    *
    */
    @Select("<script>select * from tb_excel_jz_message_import where 1=1 "
            + "<if test=\"delFlag !=null and delFlag != '' \">and del_flag = #{delFlag} </if> "
            + "<if test=\"flag !=null and flag != '' \">and flag = #{flag} </if> "
            + "</script>")
    @ResultMap(value = "BaseResultMap" )
    List<TbExcelJzMessageImport> queryTbExcelJzMessageImports(TbExcelJzMessageImport tbExcelJzMessageImport);

    /**
     * 批量插入信息
     */
    /**
     * 批量插入信息
     */
    @Insert("<script> insert into tb_excel_jz_message_import (business_id, " +
            "create_by, " +
            "create_date, " +
            "update_by, " +
            "update_date, " +
            "del_flag, " +
            "flag, " +
            "remarks, " +
            "jz_code, " +
            "jz_name, " +
            "jz_ewm, " +
            "project_code, " +
            "business_line, " +
            "jz_yys, " +
            "jz_qy, " +
            "project_address, " +
            "jz_pro_state, " +
            "jz_state, " +
            "jz_type, " +
            "jz_create_date, " +
            "jz_init_user, " +
            "jz_init_dept, " +
            "jz_cur_user, " +
            "jz_cur_dept, " +
            "jz_up_custom, " +
            "jz_require, " +
            "jz_construct, " +
            "jz_mobile_name, " +
            "jz_mobile_phone, " +
            "jz_longitude, " +
            "jz_latitude, " +
            "jz_version, " +
            "jz_xgid, " +
            "jz_jd_date, " +
            "jz_jd_waring, " +
            "jz_prospectlist_name, " +
            "jz_prospectlist_path, " +
            "jz_designdrawing_name, " +
            "jz_designdrawing_path, " +
            "jz_elementlist_name, " +
            "jz_elementlist_path, " +
            "jz_outboundlist_name, " +
            "jz_outboundlist_path, " +
            "jz_operatoracceptlist_name, " +
            "jz_operatoracceptlist_path, " +
            "jz_routedrawing_name, " +
            "jz_routedrawing_path, " +
            "jz_completedacceptlist_name, " +
            "jz_completedacceptlist_path, " +
            "jz_uppermachineroomplace, " +
            "jz_ne_id, " +
            "jz_opendrawing_name, " +
            "jz_opendrawing_path, " +
            "jz_propertycode, " +
            "jz_isconnectwithowner, " +
            "jz_propertyname, " +
            "jz_ownercontactinfo, " +
            "jz_budgetofelectic_name, " +
            "jz_budgetofelectic_path, " +
            "jz_matterlist_name, " +
            "jz_matterlist_path, " +
            "jz_openrepory_name, " +
            "jz_openrepory_path, " +
            "jz_constructprocept_name, " +
            "jz_constructprocept_path, " +
            "jz_completedreport_name,"+
            "jz_completedreport_path,"+
            "jz_completedphoto_name,"+
            "jz_completedphoto_path,"+
            "jz_rentdrawing_name, " +
            "jz_rentdrawing_path, " +
            "jz_project_id, " +
            "jz_project_owner, " +
            "jz_ewm_drawing, " +
            "jz_mobile_relation, " +
            "jz_map_link, " +
            "excel_id ) values " +
            "<foreach collection =\"jzMessageList\" item=\"item\"  separator=\",\" > " +
            "(" +
            "#{item.businessId}, " +
            "#{item.createBy}, " +
            "#{item.createDate}, " +
            "#{item.updateBy}, " +
            "#{item.updateDate}, " +
            "#{item.delFlag}, " +
            "#{item.flag}, " +
            "#{item.remarks}, " +
            "#{item.jzCode}, " +
            "#{item.jzName}, " +
            "#{item.jzEwm}, " +
            "#{item.projectCode}, " +
            "#{item.businessLine}, " +
            "#{item.jzYys}, " +
            "#{item.jzQy}, " +
            "#{item.projectAddress}, " +
            "#{item.jzProState}, " +
            "#{item.jzState}, " +
            "#{item.jzType}, " +
            "#{item.jzCreateDate}, " +
            "#{item.jzInitUser}, " +
            "#{item.jzInitDept}, " +
            "#{item.jzCurUser}, " +
            "#{item.jzCurDept}, " +
            "#{item.jzUpCustom}, " +
            "#{item.jzRequire}, " +
            "#{item.jzConstruct}, " +
            "#{item.jzMobileName}, " +
            "#{item.jzMobilePhone}, " +
            "#{item.jzLongitude}, " +
            "#{item.jzLatitude}, " +
            "#{item.jzVersion}, " +
            "#{item.jzXgid}, " +
            "#{item.jzJdDate}, " +
            "#{item.jzJdWaring}, " +
            "#{item.jzProspectlistName}, " +
            "#{item.jzProspectlistPath}, " +
            "#{item.jzDesigndrawingName}, " +
            "#{item.jzDesigndrawingPath}, " +
            "#{item.jzElementlistName}, " +
            "#{item.jzElementlistPath}, " +
            "#{item.jzOutboundlistName}, " +
            "#{item.jzOutboundlistPath}, " +
            "#{item.jzOperatoracceptlistName}, " +
            "#{item.jzOperatoracceptlistPath}, " +
            "#{item.jzRoutedrawingName}, " +
            "#{item.jzRoutedrawingPath}, " +
            "#{item.jzCompletedacceptlistName}, " +
            "#{item.jzCompletedacceptlistPath}, " +
            "#{item.jzUppermachineroomplace}, " +
            "#{item.jzNeId}, " +
            "#{item.jzOpendrawingName}, " +
            "#{item.jzOpendrawingPath}, " +
            "#{item.jzPropertycode}, " +
            "#{item.jzIsconnectwithowner}, " +
            "#{item.jzPropertyname}, " +
            "#{item.jzOwnercontactinfo}, " +
            "#{item.jzBudgetofelecticName}, " +
            "#{item.jzBudgetofelecticPath}, " +
            "#{item.jzMatterlistName}, " +
            "#{item.jzMatterlistPath}, " +
            "#{item.jzOpenreporyName}, " +
            "#{item.jzOpenreporyPath}, " +
            "#{item.jzConstructproceptName}, " +
            "#{item.jzConstructproceptPath}, " +
            "#{item.jzCompletedreportName}, " +
            "#{item.jzCompletedreportPath}, " +
            "#{item.jzCompletedphotoName}, " +
            "#{item.jzCompletedphotoPath}, " +
            "#{item.jzRentdrawingName}, " +
            "#{item.jzRentdrawingPath}, " +
            "#{item.jzProjectId}, " +
            "#{item.jzProjectOwner}, " +
            "#{item.jzEwmDrawing}, " +
            "#{item.jzMobileRelation}, " +
            "#{item.jzMapLink},"+
            "#{item.excelId}" +
            ")" +
            "</foreach>" +
            "</script>")
    @ResultMap(value = "BaseResultMap" )
    int batchInsert(@Param("jzMessageList") List<TbExcelJzMessageImport> jzMessageList);

    /**
     * 联表查询完成的任务
      */
    @Select("<script>select tejmi.* from tb_excel_jz_message_import AS tejmi " +
            "JOIN tb_excel_info AS tei " +
            "ON tei.business_id = tejmi.excel_id " +
            "where 1=1 " +
            "AND tei.excel_status = '0' " +
            "AND tei.user_id = #{userId} "
            + "<if test=\"item.delFlag !=null and item.delFlag != '' \">and tejmi.del_flag = #{item.delFlag} and tei.del_flag = #{item.delFlag} </if> "
            + "<if test=\"item.flag !=null and item.flag != '' \">and tejmi.flag = #{item.flag} and tei.flag = #{item.flag} </if> "
            + "</script>")
    @ResultMap(value = "BaseResultMapJzMessage" )
    List<JzMessage> queryCompelteTask(@Param("item") TbExcelJzMessageImport tbExcelJzMessageImport, @Param("userId") String userId);

    /**
     * 通过项目编号去查询
     */
    @Select("<script> select * from tb_excel_jz_message_import where " +
            "project_code = #{projectCode} and excel_id = #{excelId} "+
            "</script>")
    @ResultMap(value = "BaseResultMap")
    TbExcelJzMessageImport queryProjectCodeExcel(@Param("projectCode") String projectCode, @Param("excelId") String excelId);
}

