package org.rcisoft.business.excelimport.tbexceljzmessageimport.service;

import javafx.util.Pair;
import org.rcisoft.business.excelimport.tbexceljzmessageimport.entity.TbExcelJzMessageImport;
import org.rcisoft.core.model.CyPersistModel;
import org.rcisoft.core.aop.CyPageUtil;
import org.springframework.web.multipart.MultipartFile;

import java.util.List;
import java.util.Map;

/**
 * Created by zyj on 2019-8-3 0:55:39.
 */
public interface TbExcelJzMessageImportService {

    /**
    * 保存 
    * @param tbExcelJzMessageImport
    * @return
    */
    CyPersistModel save(TbExcelJzMessageImport tbExcelJzMessageImport);

    /**
    * 删除 
    * @param tbExcelJzMessageImport
    * @return
    */
    CyPersistModel remove(TbExcelJzMessageImport tbExcelJzMessageImport);
    /**
    * 逻辑删除 
    * @param tbExcelJzMessageImport
    * @return
    */
    CyPersistModel removeLogical(TbExcelJzMessageImport tbExcelJzMessageImport);
    /**
    * 修改 
    * @param tbExcelJzMessageImport
    * @return
    */
    CyPersistModel merge(TbExcelJzMessageImport tbExcelJzMessageImport);

    /**
    * 根据id查询 
    * @param id
    * @return
    */
    TbExcelJzMessageImport findById(String id);

    /**
    * 分页查询 
    * @param tbExcelJzMessageImport
    * @return
    */
    List<TbExcelJzMessageImport> findAllByPagination(CyPageUtil<TbExcelJzMessageImport> paginationUtility,
                                                     TbExcelJzMessageImport tbExcelJzMessageImport);


    /**
    * 查询list 
    * @param tbExcelJzMessageImport
    * @return
    */
    List<TbExcelJzMessageImport> findAll(TbExcelJzMessageImport tbExcelJzMessageImport);

    /**
     * 导入excel
     * @param file
     * @param excelType
     * @return
     */
    Pair<List<TbExcelJzMessageImport>, List<Pair<Integer, Integer>>> importExcel(MultipartFile file, String excelType, String excelId, List<Map<String, Object> > excelList);

    /**
     * 批量查入
     * @param tbExcelJzMessageImports
     * @return
     */
    CyPersistModel batchSave(List<TbExcelJzMessageImport> tbExcelJzMessageImports);
}
