package org.rcisoft.business.excelimport.tbexceljzmessageimport.service.impl;

import javafx.util.Pair;
import org.rcisoft.business.excelimport.importMethod.NewPair;
import org.rcisoft.business.excelimport.importMethod.PoiMethod;
import org.rcisoft.business.excelimport.tbexcelinfo.entity.TbExcelInfo;
import org.rcisoft.business.excelimport.tbexcelinfo.service.TbExcelInfoService;
import org.rcisoft.business.jzmessage.entity.JzMessage;
import org.rcisoft.business.jzmessage.service.impl.JzMessageServiceImpl;
import org.rcisoft.core.exception.CyServiceException;
import org.rcisoft.core.util.CyUserUtil;
import org.rcisoft.core.aop.CyPageUtil;
import org.rcisoft.core.model.CyPersistModel;
import org.rcisoft.business.excelimport.tbexceljzmessageimport.dao.TbExcelJzMessageImportRepository;
import org.rcisoft.business.excelimport.tbexceljzmessageimport.entity.TbExcelJzMessageImport;
import org.rcisoft.business.excelimport.tbexceljzmessageimport.service.TbExcelJzMessageImportService;
import org.rcisoft.core.service.CyBaseService;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.core.parameters.P;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Isolation;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;


import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import lombok.extern.slf4j.Slf4j;
import org.springframework.web.multipart.MultipartFile;

/**
 * Created by zyj on 2019-8-3 0:55:39.
 */
@Service
@Transactional(readOnly = true,propagation = Propagation.NOT_SUPPORTED)
@Slf4j
public class TbExcelJzMessageImportServiceImpl extends CyBaseService  implements TbExcelJzMessageImportService {

    @Autowired
    private TbExcelJzMessageImportRepository tbExcelJzMessageImportRepository;
    @Autowired
    private TbExcelInfoService tbExcelInfoServiceImpl;
    @Autowired
    private JzMessageServiceImpl jzMessageService;

    /**
    * 保存 
    * @param tbExcelJzMessageImport
    * @return
    */
    @Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT)
    @Override
    public CyPersistModel save(TbExcelJzMessageImport tbExcelJzMessageImport){
        //增加操作
        CyUserUtil.setCurrentPersistOperation(tbExcelJzMessageImport);
        int line = tbExcelJzMessageImportRepository.insertSelective(tbExcelJzMessageImport);
        this.dbInfo(CyUserUtil.getAuthenUsername()+"新增了ID为"+
tbExcelJzMessageImport.getBusinessId()+"的信息","新增");
        log.info(CyUserUtil.getAuthenUsername()+"新增了ID为"+
            tbExcelJzMessageImport.getBusinessId()+"的信息");
        return new CyPersistModel(line);
    }

    /**
    * 删除 
    * @param tbExcelJzMessageImport
    * @return
    */
    @Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT)
    @Override
    public CyPersistModel remove(TbExcelJzMessageImport tbExcelJzMessageImport){
        int line = tbExcelJzMessageImportRepository.deleteByPrimaryKey(tbExcelJzMessageImport.getBusinessId());
        this.dbInfo(CyUserUtil.getAuthenUsername()+"删除了ID为"+
tbExcelJzMessageImport.getBusinessId()+"的信息","删除");
        log.info(CyUserUtil.getAuthenUsername()+"删除了ID为"+
            tbExcelJzMessageImport.getBusinessId()+"的信息");
        return new CyPersistModel(line);
    }
    /**
    * 逻辑删除 
    * @param tbExcelJzMessageImport
    * @return
    */
    @Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT)
    @Override
    public CyPersistModel removeLogical(TbExcelJzMessageImport tbExcelJzMessageImport){
        CyUserUtil.setCurrentMergeOperation(tbExcelJzMessageImport);
        tbExcelJzMessageImport.setDeleted();
        int line = tbExcelJzMessageImportRepository.logicalDelete(tbExcelJzMessageImport);
        this.dbInfo(CyUserUtil.getAuthenUsername()+"逻辑删除了ID为"+
tbExcelJzMessageImport.getBusinessId()+"的信息","逻辑删除");
        log.info(CyUserUtil.getAuthenUsername()+"逻辑删除了ID为"+
            tbExcelJzMessageImport.getBusinessId()+"的信息");

        return new CyPersistModel(line);
    }
    /**
    * 修改 
    * @param tbExcelJzMessageImport
    * @return
    */
    @Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT)
    @Override
    public CyPersistModel merge(TbExcelJzMessageImport tbExcelJzMessageImport){
        CyUserUtil.setCurrentMergeOperation(tbExcelJzMessageImport);
        int line = tbExcelJzMessageImportRepository.updateByPrimaryKeySelective(tbExcelJzMessageImport);
        this.dbInfo(CyUserUtil.getAuthenUsername()+"修改了ID为"+
tbExcelJzMessageImport.getBusinessId()+"的信息","修改");
        log.info(CyUserUtil.getAuthenUsername()+"修改了ID为"+
            tbExcelJzMessageImport.getBusinessId()+"的信息");
        return new CyPersistModel(line);
    }

    /**
    * 根据id查询 
    * @param id
    * @return
    */
    @Override
    public TbExcelJzMessageImport findById(String id){
        return tbExcelJzMessageImportRepository.selectByPrimaryKey(id);
    }

    /**
    * 分页查询 
    * @param tbExcelJzMessageImport
    * @return
    */
    @Override
    public List<TbExcelJzMessageImport> findAllByPagination(CyPageUtil<TbExcelJzMessageImport> paginationUtility,
        TbExcelJzMessageImport tbExcelJzMessageImport){
        tbExcelJzMessageImport.setNormal();
        return tbExcelJzMessageImportRepository.queryTbExcelJzMessageImports(tbExcelJzMessageImport);
    }
    /**
    * 查询list 
    * @param tbExcelJzMessageImport
    * @return
    */
    @Override
    public List<TbExcelJzMessageImport> findAll(TbExcelJzMessageImport tbExcelJzMessageImport){
        tbExcelJzMessageImport.setNormal();
        return tbExcelJzMessageImportRepository.queryTbExcelJzMessageImports(tbExcelJzMessageImport);
    }

    /**
     * 批量插入
     *
     */
    @Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT)
    @Override
    public CyPersistModel batchSave(List<TbExcelJzMessageImport> jzMessagesList){
        List<String> businessIdList = new ArrayList<>();
        for(TbExcelJzMessageImport item:jzMessagesList){
            if(item.getJzType().equals("0")){
                item.setJzState("2");
            }else{
                item.setJzState("3");
                item.setJzProState("0");
            }
            item.setJzJdWaring("0");
            CyUserUtil.setCurrentPersistOperation(item);
            businessIdList.add(item.getBusinessId());
        }
        log.info(jzMessagesList.toString());
        int line = tbExcelJzMessageImportRepository.batchInsert(jzMessagesList);
        this.dbInfo(CyUserUtil.getAuthenUsername()+"新增了ID为"+
                businessIdList.toString()+"的信息","新增");
        return new CyPersistModel(line);
    }

    /**
     * 导入excel
     * @param file
     * @param excelType
     * @return
     */
    @Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT)
    @Override
    public Pair<List<TbExcelJzMessageImport>, List<Pair<Integer, Integer>>> importExcel(MultipartFile file, String excelType, String excelId, List<Map<String, Object>> excelList) {
        //判断此用户是否之前插入过还没有操作完的excel
        String userId = CyUserUtil.getAuthenBusinessId();
        //若没有登录用户则抛出异常
        if (userId == null) {
            throw new CyServiceException("没有登录用户！！！！！！！！");
        }
        //TbExcelInfo checkUser = tbExcelInfoServiceImpl.findByUserId("1"); //测试用"1"
        List<TbExcelInfo> checkUser = tbExcelInfoServiceImpl.findByUserId(userId);

        //如果之前插入过，则将其表中的数据改为2:未正常完成
        if (checkUser != null && "".equals(excelId)) { //用"",无法传递null
            for (TbExcelInfo user : checkUser) {
                user.setExcelStatus("2");
                tbExcelInfoServiceImpl.merge(user);
            }
        }

        TbExcelInfo tbExcelInfo = new TbExcelInfo();
        if ("".equals(excelId)) { //判断是否是由错误页面传来的 //用"",无法传递null
            //设置状态为未完成
            tbExcelInfo.setExcelStatus("0");
            tbExcelInfo.setUserId(userId);
            //tbExcelInfo.setUserId("1"); //测试用"1"
            tbExcelInfoServiceImpl.save(tbExcelInfo);
        } else {
            tbExcelInfo = tbExcelInfoServiceImpl.findById(excelId);
        }
        PoiMethod impExc = new PoiMethod();
        try {
            int check = impExc.excelReadList(file, excelType, tbExcelInfo.getBusinessId(), excelList);
            if (check == 0) { //表头错误
                //不存入excel的信息表中，故删除
                tbExcelInfoServiceImpl.remove(tbExcelInfo);
                return null;
            } else if (check == 1) { //数据完全正确
                //往excelJZmessageImport中批量添加
                if (impExc.correctData.size() > 0) {
                    batchSave(impExc.correctData);
                }
                //获取表中全部正确的数据
                TbExcelJzMessageImport tbExcelJzMessageImport = new TbExcelJzMessageImport();
                tbExcelJzMessageImport.setNormal();
                tbExcelJzMessageImport.setExcelId(tbExcelInfo.getBusinessId());
                List<JzMessage> allCorrectData = tbExcelJzMessageImportRepository.queryCompelteTask(tbExcelJzMessageImport, CyUserUtil.getAuthenBusinessId());
                //往jzMessage表中批量插入
                if (allCorrectData.size() > 0) {
                    jzMessageService.batchSave(allCorrectData);
                }
                //修改excelInfo状态为 1 ：正常完成
                tbExcelInfo.setExcelStatus("1");
                tbExcelInfoServiceImpl.merge(tbExcelInfo);
                //用于区别是表头错误还是数据完全正确
                return new Pair <List<TbExcelJzMessageImport>, List<Pair<Integer, Integer>>>(impExc.errorData, null);//null原为impExc.errorPos 已不用
            } else if (check == 2) { //含有错误数据
                //往excelJZmessageImport中批量添加正确数据
                if (impExc.correctData.size() > 0) {
                    batchSave(impExc.correctData);
                }
                //返回错误数据
                return new Pair <List<TbExcelJzMessageImport>, List<Pair<Integer, Integer>>>(impExc.errorData, null);//null原为impExc.errorPos 已不用
            } else if(check == 3){
                return new Pair <List<TbExcelJzMessageImport>, List<Pair<Integer, Integer>>>(null, null);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }
}
