package org.rcisoft.business.exportexclemodel.service.impl;

import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.ClassUtils;
import org.apache.ibatis.jdbc.Null;
import org.rcisoft.business.exportexclemodel.service.ExcleModelService;
import org.rcisoft.business.exportexclemodel.util.ExcelDownload;
import org.rcisoft.business.exportexclemodel.util.FindInfo;
import org.rcisoft.business.jzmessage.common.DictionaryMap;
import org.rcisoft.business.sdictionary.dao.SDictionaryRepository;
import org.rcisoft.business.sdictionary.entity.SDictionary;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.ArrayList;
import java.util.List;

@Service
@Slf4j
public class ExcleModelServiceImpl  implements ExcleModelService  {

    @Autowired
    FindInfo findInfo;

    @Override
    public void getExcleModel(String id,HttpServletRequest request, HttpServletResponse response){//id 0 代缴 1 移动 2 铁塔
        String fileName = "基站信息表.xlsx"; //模板名称
        List<String[]> handers =  new ArrayList();
        String[] h1 ={"基站号","基站名","运营商","基站二维码","项目编号","业务线","区域","项目地址","阶段负责人","项目负责人","基站创建日期(yyyy-MM-dd)"};
        handers.add(h1); //代缴站列标题
        String[] h2 ={"上游客户","运营商","需求号","建设方式","基站名","区域","移动关系","移动联系方式","经度","纬度","阶段负责人","项目负责人","基站创建日期(yyyy-MM-dd)"};
        handers.add(h2); //移动列标题
        String[] h3 ={"上游客户","运营商","需求号","建设方式","基站名","区域","经度","纬度","阶段负责人","项目负责人","基站创建日期(yyyy-MM-dd)"};
        handers.add(h3); //自建站铁塔列标题

        List<String[]> downData ;//下拉框数据
        downData = findInfo.getInfo(id);//查询数据字典获得下拉框的值
        int Iid = Integer.valueOf(id);//前台返回0，1，2分别为代缴，移动，铁塔
        List<String[]> downRows = new ArrayList();
        String[] h4 ={"2","5","6"}; //下拉的列序号数组(序号从0开始)
        String[] h5 ={"0","1","3","5"}; //下拉的列序号数组(序号从0开始)
        downRows.add(h4);
        downRows.add(h5);
        downRows.add(h5);
        //下面是是网上的代码
        ExcelDownload.getExcelTemplate(fileName, handers.get(Iid), downData, downRows.get(Iid), request, response);
    }
}
