package org.rcisoft.business.exportexclemodel.util;

import org.rcisoft.business.sdictionary.entity.SDictionary;
import org.rcisoft.business.sdictionary.service.SDictionaryService;
import org.rcisoft.common.ResultServiceExceptionEnums;
import org.rcisoft.core.exception.CyServiceException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.List;

@Component
public class FindInfo {

    @Autowired
    SDictionaryService sDictionaryServiceImpl;


    private String[] ListToString(List<SDictionary> infoList) {

        String[] str = new String[infoList.size()];
        int i = 0;
        for(i = 0;i<infoList.size();i ++){
            str[i] = infoList.get(i).getName();
        }
        return str;
    }

    public List<String[]> getInfo (String id){
        List<String[]> downData = new ArrayList();
        SDictionary sDictionary = new SDictionary();
        sDictionary.setNormal();

        if(id.equals("0")){//代缴
            //代缴运营商 可优化
            List<SDictionary> ysName = sDictionaryServiceImpl.selectDjYsByType(sDictionary);//代缴运营商
            if(ysName.isEmpty()){//非空判断
                throw new CyServiceException(ResultServiceExceptionEnums.SDictionary_NULL_ERROR);
            }
            downData.add(ListToString(ysName));
            // 业务线 可优化
          List<SDictionary> ywxName = sDictionaryServiceImpl.selectYWXByType(sDictionary);//业务线
            if(ywxName.isEmpty()){
                throw new CyServiceException(ResultServiceExceptionEnums.SDictionary_NULL_ERROR);
            }
            downData.add(ListToString(ywxName));
            List<SDictionary> qyName = sDictionaryServiceImpl.selectQYByType(sDictionary);//区域
            if(qyName.isEmpty()){
                throw new CyServiceException(ResultServiceExceptionEnums.SDictionary_NULL_ERROR);
            }
            downData.add(ListToString(qyName));
        }else{
            if (id.equals("1")){//移动
                //移动上游客户 可优化
                List<SDictionary> upperName = sDictionaryServiceImpl.selectYdUpperByType(sDictionary);//上游客户
                if(upperName.isEmpty()){
                    throw new CyServiceException(ResultServiceExceptionEnums.SDictionary_NULL_ERROR);
                }
                downData.add(ListToString(upperName));
                //移动运营商 可优化
                List<SDictionary> ysName = sDictionaryServiceImpl.selectYdYsByType(sDictionary);//移动运营商
                if(ysName.isEmpty()){
                    throw new CyServiceException(ResultServiceExceptionEnums.SDictionary_NULL_ERROR);
                }
                downData.add(ListToString(ysName));
            }
            if (id.equals("2")){//铁塔
                // 铁塔上游客户 可优化
                List<SDictionary> upperName = sDictionaryServiceImpl.selectTtUpperByType(sDictionary);//铁塔上游客户
                if(upperName.isEmpty()){
                    throw new CyServiceException(ResultServiceExceptionEnums.SDictionary_NULL_ERROR);
                }
                downData.add(ListToString(upperName));
                List<SDictionary> ysName = sDictionaryServiceImpl.selectTtYsByType(sDictionary);//铁塔运营商
                if(ysName.isEmpty()){
                    throw new CyServiceException(ResultServiceExceptionEnums.SDictionary_NULL_ERROR);
                }
                downData.add(ListToString(ysName));
            }
            //建设方式
            List<SDictionary> buildName = sDictionaryServiceImpl.selectBuildByType(sDictionary);//建设方式（移动和铁塔的）
            if(buildName.isEmpty()){
                throw new CyServiceException(ResultServiceExceptionEnums.SDictionary_NULL_ERROR);
            }
            downData.add(ListToString(buildName));
            //区域优化
            List<SDictionary> qyName = sDictionaryServiceImpl.selectQYByType(sDictionary);//区域（移动和铁塔的）
            if(qyName.isEmpty()){
                throw new CyServiceException(ResultServiceExceptionEnums.SDictionary_NULL_ERROR);
            }
            downData.add(ListToString(qyName));
        }
        return downData;
    }

}
