package org.rcisoft.business.hijzmessage.dao;

import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.ResultMap;
import org.apache.ibatis.annotations.Select;
import org.rcisoft.business.hijzmessage.entity.HiJzMessage;
import org.rcisoft.core.base.CyBaseMapper;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

/**
* Created with lpy on 2019-7-26 15:45:51.
*/
@Repository
public interface HiJzMessageRepository extends CyBaseMapper<HiJzMessage> {

    /**
    * 分页查询 hiJzMessage
    *
    */
    @Select("<script>select * from hi_jz_message where 1=1 "
            + "<if test= \"delFlag !=null and delFlag != '' \">and del_flag = #{delFlag} </if> "
            + "<if test= \"flag !=null and flag != '' \">and flag = #{flag} </if> "
            + "</script>")
    @ResultMap(value = "BaseResultMap" )
    List<HiJzMessage> queryHiJzMessages(HiJzMessage hiJzMessage);
    /**
     * 批量插入信息
     */
    @Insert("<script> insert into hi_jz_message " +
            "(" +
            "business_id, " +
            "create_by, " +
            "create_date, " +
            "update_by, " +
            "update_date, " +
            "del_flag, " +
            "flag, " +
            "remarks, " +
            "jz_code, " +
            "jz_name, " +
            "jz_ewm, " +
            "project_code, " +
            "business_line, " +
            "jz_yys, " +
            "jz_qy, " +
            "project_address, " +
            "jz_pro_state, " +
            "jz_state, " +
            "jz_type, " +
            "jz_create_date, " +
            "jz_init_user, " +
            "jz_init_dept, " +
            "jz_cur_user, " +
            "jz_cur_dept, " +
            "jz_up_custom, " +
            "jz_require, " +
            "jz_construct, " +
            "jz_mobile_name, " +
            "jz_mobile_phone, " +
            "jz_longitude, " +
            "jz_latitude, " +
            "jz_version, " +
            "jz_xgid, " +
            "jz_jd_date, " +
            "jz_jd_waring, " +
            "jz_prospectlist_name, " +
            "jz_prospectlist_path, " +
            "jz_designdrawing_name, " +
            "jz_designdrawing_path, " +
            "jz_elementlist_name, " +
            "jz_elementlist_path, " +
            "jz_outboundlist_name, " +
            "jz_outboundlist_path, " +
            "jz_operatoracceptlist_name, " +
            "jz_operatoracceptlist_path, " +
            "jz_routedrawing_name, " +
            "jz_routedrawing_path, " +
            "jz_completedacceptlist_name, " +
            "jz_completedacceptlist_path, " +
            "jz_uppermachineroomplace, " +
            "jz_ne_id, " +
            "jz_opendrawing_name, " +
            "jz_opendrawing_path, " +
            "jz_propertycode, " +
            "jz_isconnectwithowner, " +
            "jz_propertyname, " +
            "jz_ownercontactinfo, " +
            "jz_budgetofelectic_name, " +
            "jz_budgetofelectic_path, " +
            "jz_matterlist_name, " +
            "jz_matterlist_path, " +
            "jz_openrepory_name, " +
            "jz_openrepory_path, " +
            "jz_constructprocept_name, " +
            "jz_constructprocept_path, " +
            "jz_completedreport_name,"+
            "jz_completedreport_path,"+
            "jz_completedphoto_name,"+
            "jz_completedphoto_path,"+
            "jz_rentdrawing_name, " +
            "jz_rentdrawing_path, " +
            "jz_project_id, " +
            "jz_project_owner, " +
            "jz_ewm_drawing, " +
            "jz_wait_reason, " +
            "jz_id, " +
            "jz_mobile_relation, " +
            "jz_map_link) " +
            "values " +
            "<foreach collection =\"hiJzMessageList\" item=\"item\"  separator=\",\" >" +
            "(#{item.businessId}, " +
            "#{item.createBy}, " +
            "#{item.createDate}, " +
            "#{item.updateBy}, " +
            "#{item.updateDate}, " +
            "#{item.delFlag}, " +
            "#{item.flag}, " +
            "#{item.remarks}, " +
            "#{item.jzCode}, " +
            "#{item.jzName}, " +
            "#{item.jzEwm}, " +
            "#{item.projectCode}, " +
            "#{item.businessLine}, " +
            "#{item.jzYys}, " +
            "#{item.jzQy}, " +
            "#{item.projectAddress}, " +
            "#{item.jzProState}, " +
            "#{item.jzState}, " +
            "#{item.jzType}, " +
            "#{item.jzCreateDate}, " +
            "#{item.jzInitUser}, " +
            "#{item.jzInitDept}, " +
            "#{item.jzCurUser}, " +
            "#{item.jzCurDept}, " +
            "#{item.jzUpCustom}, " +
            "#{item.jzRequire}, " +
            "#{item.jzConstruct}, " +
            "#{item.jzMobileName}, " +
            "#{item.jzMobilePhone}, " +
            "#{item.jzLongitude}, " +
            "#{item.jzLatitude}, " +
            "#{item.jzVersion}, " +
            "#{item.jzXgid}, " +
            "#{item.jzJdDate}, " +
            "#{item.jzJdWaring}, " +
            "#{item.jzProspectlistName}, " +
            "#{item.jzProspectlistPath}, " +
            "#{item.jzDesigndrawingName}, " +
            "#{item.jzDesigndrawingPath}, " +
            "#{item.jzElementlistName}, " +
            "#{item.jzElementlistPath}, " +
            "#{item.jzOutboundlistName}, " +
            "#{item.jzOutboundlistPath}, " +
            "#{item.jzOperatoracceptlistName}, " +
            "#{item.jzOperatoracceptlistPath}, " +
            "#{item.jzRoutedrawingName}, " +
            "#{item.jzRoutedrawingPath}, " +
            "#{item.jzCompletedacceptlistName}, " +
            "#{item.jzCompletedacceptlistPath}, " +
            "#{item.jzUppermachineroomplace}, " +
            "#{item.jzNeId}, " +
            "#{item.jzOpendrawingName}, " +
            "#{item.jzOpendrawingPath}, " +
            "#{item.jzPropertycode}, " +
            "#{item.jzIsconnectwithowner}, " +
            "#{item.jzPropertyname}, " +
            "#{item.jzOwnercontactinfo}, " +
            "#{item.jzBudgetofelecticName}, " +
            "#{item.jzBudgetofelecticPath}, " +
            "#{item.jzMatterlistName}, " +
            "#{item.jzMatterlistPath}, " +
            "#{item.jzOpenreporyName}, " +
            "#{item.jzOpenreporyPath}, " +
            "#{item.jzConstructproceptName}, " +
            "#{item.jzConstructproceptPath}, " +
            "#{item.jzCompletedreportName}, " +
            "#{item.jzCompletedreportPath}, " +
            "#{item.jzCompletedphotoName}, " +
            "#{item.jzCompletedphotoPath}, " +
            "#{item.jzRentdrawingName}, " +
            "#{item.jzRentdrawingPath}, " +
            "#{item.jzProjectId}, " +
            "#{item.jzProjectOwner}, " +
            "#{item.jzEwmDrawing}, " +
            "#{item.jzWaitReason}, " +
            "#{item.jzId}, " +
            "#{item.jzMobileRelation}," +
            "#{item.jzMapLink})</foreach>" +
            "</script>")
    @ResultMap(value = "BaseResultMap" )
    int batchInsert(@Param("hiJzMessageList") List<HiJzMessage> hiJzMessageList);

    @Select("<script>select jz.*," +
            "sde1. NAME AS curDeptName, " +
            "su1. NAME AS curUserName, " +
            "su3. NAME AS projectOwner, " +
            "sdi2. NAME AS yysName, " +
            "sdi. NAME jzLocationName, " +
            "sdi3. NAME AS ywxName, " +
            "su4.NAME AS updateName, " +
            "su5.NAME AS initUserName" +
            " from hi_jz_message jz " +
            "left join s_user su4 on jz.update_by = su4.BUSINESS_ID" +
            " left join s_dept sde1 on jz.jz_cur_dept = sde1.BUSINESS_ID" +
            " left join s_user su1 on jz.jz_cur_user = su1.BUSINESS_ID" +
            " left join s_user su5 on jz.jz_init_user = su5.BUSINESS_ID" +
            " left join s_user su3 on jz.jz_project_owner = su3.BUSINESS_ID" +
            " left join s_dictionary sdi on jz.jz_qy = sdi.`value` and sdi.type = 'JZ_QY'" +
            " left join s_dictionary sdi3 on jz.business_line = sdi3.`value` and sdi3.type = 'JZ_YWX'" +
            " left join s_dictionary sdi2 on jz.jz_yys = sdi2.`value` and sdi2.type = 'JZ_YYS'" +
            " where jz.jz_id = #{jzMessageId} " +
            " ORDER BY jz.update_date DESC" +
            "</script>")
    @ResultMap(value = "BaseResultMap")
    List<HiJzMessage> getHijzMessageByjzMessageId(@Param("jzMessageId") String jzMessageId);

    @Select("<script>select max(jz_version) jzVersion from hi_jz_message where 1=1  " +
             "<if test= \"delFlag !=null and delFlag != '' \">and del_flag = #{delFlag} </if> " +
             "<if test= \"flag !=null and flag != '' \">and flag = #{flag} </if> "+
            " and jz_id = #{jzId} </script>")
    Map getMaxVersionByJzId(HiJzMessage hiJzMessage);
}

