package org.rcisoft.business.hijzmessage.entity;

import io.swagger.annotations.ApiModelProperty;
import lombok.*;

import org.rcisoft.core.entity.CyIdEntity;
import javax.persistence.*;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.io.Serializable;
import java.util.Date;
import java.util.List;

/**
* Created with Ryan on 2019-8-1 11:39:17.
*/
@Entity
@Data
@NoArgsConstructor
@AllArgsConstructor
@Table(name = "hi_jz_message")
public class HiJzMessage  extends CyIdEntity<HiJzMessage> {



     /**
     * @desc 基站号
     * @column jz_code
     * @default 
     */
     private String jzCode;

     /**
     * @desc 基站名
     * @column jz_name
     * @default 
     */
     private String jzName;

     /**
     * @desc 基站二维码
     * @column jz_ewm
     * @default 
     */
     private String jzEwm;

     /**
     * @desc 项目编号（唯一键）
     * @column project_code
     * @default 
     */
     private String projectCode;

     /**
     * @desc 业务线     飞箱选址 0  铁塔选址 1 小站选址 2 电费代缴 3
     * @column business_line
     * @default 
     */
     private String businessLine;

     /**
     * @desc 运营商     移动 0
            运营商     移动 0
     * @column jz_yys
     * @default 
     */
     private String jzYys;

     /**
     * @desc 区域   数据字典 jz_qy对应的value
     * @column jz_qy
     * @default 
     */
     private String jzQy;

     /**
     * @desc 项目地址
     * @column project_address
     * @default 
     */
     private String projectAddress;

     /**
     * @desc 流程状态 0 待审批  1 通过  2 驳回
     * @column jz_pro_state
     * @default 
     */
     private String jzProState;

     /**
     * @desc 基站状态 （代缴站） 2 已开通
     * @column jz_state
     * @default 
     */
     private String jzState;

     /**
     * @desc 基站类型 0 代缴站 1 铁通(移动)  2 航数(铁塔)
     * @column jz_type
     * @default 
     */
     private String jzType;

     /**
     * @desc 基站创建时间  日期框
     * @column jz_create_date
     * @default 
     */
     private Date jzCreateDate;

     /**
     * @desc 初始业务员id
     * @column jz_init_user
     * @default 
     */
     private String jzInitUser;

     /**
     * @desc 初始部门id
     * @column jz_init_dept
     * @default 
     */
     private String jzInitDept;

     /**
     * @desc 当前业务员id
     * @column jz_cur_user
     * @default 
     */
     private String jzCurUser;

     /**
     * @desc 当前部门id
     * @column jz_cur_dept
     * @default 
     */
     private String jzCurDept;

     /**
     * @desc 0 铁通 1 铁塔
     * @column jz_up_custom
     * @default 
     */
     private String jzUpCustom;

     /**
     * @desc 需求号
     * @column jz_require
     * @default 
     */
     private String jzRequire;

     /**
     * @desc 0 飞箱 1 微站
     * @column jz_construct
     * @default 
     */
     private String jzConstruct;

     /**
     * @desc 移动的项目经理姓名
     * @column jz_mobile_name
     * @default 
     */
     private String jzMobileName;

     /**
     * @desc 移动的项目经理手机号
     * @column jz_mobile_phone
     * @default 
     */
     private String jzMobilePhone;

     /**
     * @desc 经度
     * @column jz_longitude
     * @default 
     */
     private BigDecimal jzLongitude;

     /**
     * @desc 纬度
     * @column jz_latitude
     * @default 
     */
     private BigDecimal jzLatitude;

     /**
     * @desc 信息版本
     * @column jz_version
     * @default 
     */
     private Integer jzVersion;

     /**
     * @desc 修改id
     * @column jz_xgid
     * @default 
     */

     private String jzXgid;

     /**
     * @desc 基站进度日期
     * @column jz_jd_date
     * @default 
     */
     private Date jzJdDate;

     /**
     * @desc 基站进度预警 0预警 1不预警
     * @column jz_jd_waring
     * @default 
     */
     private String jzJdWaring;

     /**
     * @desc 勘察单名称
     * @column jz_prospectlist_name
     * @default 
     */
     private String jzProspectlistName;

     /**
     * @desc 勘察单路径
     * @column jz_prospectlist_path
     * @default 
     */
     private String jzProspectlistPath;

     /**
     * @desc 设计图名称
     * @column jz_designdrawing_name
     * @default 
     */
     private String jzDesigndrawingName;

     /**
     * @desc 设计图路径
     * @column jz_designdrawing_path
     * @default 
     */
     private String jzDesigndrawingPath;

     /**
     * @desc 要素表名称
     * @column jz_elementlist_name
     * @default 
     */
     private String jzElementlistName;

     /**
     * @desc 要素表路径
     * @column jz_elementlist_path
     * @default 
     */
     private String jzElementlistPath;

     /**
     * @desc 出库单名称
     * @column jz_outboundlist_name
     * @default 
     */
     private String jzOutboundlistName;

     /**
     * @desc 出库单路径
     * @column jz_outboundlist_path
     * @default 
     */
     private String jzOutboundlistPath;

     /**
     * @desc 运营商验收单名称
     * @column jz_operatoracceptlist_name
     * @default 
     */
     private String jzOperatoracceptlistName;

     /**
     * @desc 运营商验收单路径
     * @column jz_operatoracceptlist_path
     * @default 
     */
     private String jzOperatoracceptlistPath;

     /**
     * @desc 路由图名称
     * @column jz_routedrawing_name
     * @default 
     */
     private String jzRoutedrawingName;

     /**
     * @desc 路由图路径
     * @column jz_routedrawing_path
     * @default 
     */
     private String jzRoutedrawingPath;

     /**
     * @desc 竣工验收单名称
     * @column jz_completedacceptlist_name
     * @default 
     */
     private String jzCompletedacceptlistName;

     /**
     * @desc 竣工验收单路径
     * @column jz_completedacceptlist_path
     * @default 
     */
     private String jzCompletedacceptlistPath;

     /**
     * @desc 上联机房位置
     * @column jz_uppermachineroomplace
     * @default 
     */
     private String jzUppermachineroomplace;

     /**
     * @desc 网元ID
     * @column jz_ne_id
     * @default 
     */
     private String jzNeId;

     /**
     * @desc 开通截图名称
     * @column jz_opendrawing_name
     * @default 
     */
     private String jzOpendrawingName;

     /**
     * @desc 开通截图路径
     * @column jz_opendrawing_path
     * @default 
     */
     private String jzOpendrawingPath;

     /**
     * @desc 资产编码
     * @column jz_propertycode
     * @default 
     */
     private String jzPropertycode;

     /**
     * @desc 是否与业主交接
     * @column jz_isconnectwithowner
     * @default 
     */
     private String jzIsconnectwithowner;

     /**
     * @desc 接维物业名称
     * @column jz_propertyname
     * @default 
     */
     private String jzPropertyname;

     /**
     * @desc 业主联系方式
     * @column jz_ownercontactinfo
     * @default 
     */
     private String jzOwnercontactinfo;

     /**
     * @desc 电力预算名称
     * @column jz_budgetofelectic_name
     * @default 
     */
     private String jzBudgetofelecticName;

     /**
     * @desc 电力预算路径
     * @column jz_budgetofelectic_path
     * @default 
     */
     private String jzBudgetofelecticPath;

     /**
     * @desc 立项物质清单名称
     * @column jz_matterlist_name
     * @default 
     */
     private String jzMatterlistName;

     /**
     * @desc 立项物资清单路径
     * @column jz_matterlist_path
     * @default 
     */
     private String jzMatterlistPath;

     /**
     * @desc 开工报告名称
     * @column jz_openrepory_name
     * @default 
     */
     private String jzOpenreporyName;

     /**
     * @desc 开工报告路径
     * @column jz_openrepory_path
     * @default 
     */
     private String jzOpenreporyPath;

     /**
     * @desc 施工组织方案名称
     * @column jz_constructprocept_name
     * @default 
     */
     private String jzConstructproceptName;

     /**
     * @desc 施工组织方案路径
     * @column jz_constructprocept_path
     * @default 
     */
     private String jzConstructproceptPath;

     /**
      * @desc 完工报告名称
      * @column jz_completedreport_name
      * @default
      */
     private String jzCompletedreportName;

     /**
      * @desc 完工报告路径
      * @column jz_completedreport_path
      * @default
      */
     private String jzCompletedreportPath;

     /**
      * @desc 完工照片名称
      * @column jz_completedphoto_name
      * @default
      */
     private String jzCompletedphotoName;

     /**
      * @desc 完工照片路径
      * @column jz_completedphoto_path
      * @default
      */
     private String jzCompletedphotoPath;

     /**
     * @desc 起租截图名称
     * @column jz_rentdrawing_name
     * @default 
     */
     private String jzRentdrawingName;

     /**
     * @desc 起租截图路径
     * @column jz_rentdrawing_path
     * @default 
     */
     private String jzRentdrawingPath;
     /**
      * @desc 项目ID
      * @column jz_project_ID
      * @default
      */
     @ApiModelProperty(value = "项目ID",dataType = "String")
     private String jzProjectId;

     /**
      * @desc 项目负责人
      * @column jz_project_owner
      * @default
      */
     @ApiModelProperty(value = "项目负责人",dataType = "String")
     private String jzProjectOwner;
     /**
      * @desc 二维码图片路径
      * @column jz_ewm_drawing
      * @default
      */
     @ApiModelProperty(value = "二维码图片路径",dataType = "String")
     private String jzEwmDrawing;
     /**
      * @desc 修改id
      * @column xg_id
      * @default
      */
/*     private String xgId;*/
     /**
      * @desc 基站信息Id
      * @column jz_id
      * @default
      */
     private String jzId;
     /**
      * @desc 基站信息Id
      * @column jz_id
      * @default
      */
     private String jzMobileRelation;
     /**
      * @desc 插入历史表原因
      * @column jz_wait_reason
      * @default
      */
     private String jzWaitReason;

     /**
      * @desc 当前部门名字
      * @column jz_init_user
      * @default
      */
     @Transient
     @ApiModelProperty(value = "当前部门名字",dataType = "String")
     private String curDeptName;

    /**
      * @desc 当前业务员名字
      * @column jz_init_user
      * @default
      */
     @Transient
     @ApiModelProperty(value = "当前业务员名字",dataType = "String")
     private String curUserName;

     @Transient
     @ApiModelProperty(value = "初始业务员姓名",dataType = "String")
     private String initUserName;

     @ApiModelProperty(value = "项目负责人姓名",dataType = "String")
     @Transient
     private String projectOwner;

     /**
      * 运营商名称，对应s_dictionary表中name字段
      */
     @ApiModelProperty(value = "运营商名称",dataType = "String")
     @Transient
     private String yysName;

     /**
      * 对应数据字典表中的name
      */
     @ApiModelProperty(value = "对应数据字典表中数据区域name",dataType = "String")
     @Transient
     private String jzLocationName;

     /**
      * 业务线名称
      */
    @Transient
     private String ywxName;
     /**
      * 地图链接
      */
     private String jzMapLink;

     //修改人姓名
     @Transient
     private String updateName;

     @ApiModelProperty(value = "当前选址",dataType = "String")
     @Transient
     private String select;
     /**
      * 按钮信息
      */
     @Transient
     private String transition;
     /**
      * 传值json字符串
      */
     @Transient
     private String jsonStrs;
     /**
      * 前台备注
      */
     @Transient
     private String msgRemarks;
     /**
      *流程json字符串
      */
     @Transient
     private String flowJsonStr;
     /**
      * 流程id
      */
     @Transient
     private String processId;
     /**
      * typeTemplate
      */
     @Transient
     private String typeTemplate;
     /**
      * 序号
      */
     @Transient
     private int number;





}

