package org.rcisoft.business.jzmessage.common;

import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.lang3.StringUtils;
import org.rcisoft.business.jzmessage.entity.JzMessage;
import org.rcisoft.business.sdictionary.service.impl.SDictionaryServiceImpl;
import org.rcisoft.business.userwarning.dao.UserWarningRepository;
import org.rcisoft.business.userwarning.entity.UserWarning;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.List;
@Component
public class OptimizeQuery {

    @Autowired
    private UserWarningRepository userWarningRepository;

    /**
     * 解析数据字典 区域 运营商 上游客户 建设方式 基站类型 预警状态
     * @param jzMessage
     * @param export
     */

    public  void helpOptimizeQuery(List<JzMessage> jzMessage,String export){
        for (JzMessage message : jzMessage) {
            //区域
            for (String qy : SDictionaryServiceImpl.optimizeJzQy.keySet()) {
                if (qy.equals(message.getJzQy())){
                    message.setJzLocationName(SDictionaryServiceImpl.optimizeJzQy.get(qy));
                }
            }
            //业务线
            for (String ywx : SDictionaryServiceImpl.optimizeJzYwx.keySet()) {
                if(ywx.equals(message.getBusinessLine())){
                    message.setYwxName(SDictionaryServiceImpl.optimizeJzYwx.get(ywx));
                }
            }
            //建设方式
            for (String build : SDictionaryServiceImpl.optimizeJzBuild.keySet()) {
                if (build.equals(message.getJzConstruct())){
                    message.setJzBuildName(SDictionaryServiceImpl.optimizeJzBuild.get(build));
                }
            }
            //代缴
            if (message.getJzType().equals("0")){
                message.setTypeName(TypeEnum.DJ.getname()); //设置基站名称
                //代缴运营商
                for (String djYys : SDictionaryServiceImpl.optimizeJzDjYys.keySet()) {
                    if (djYys.equals(message.getJzYys())){
                        message.setYysName(SDictionaryServiceImpl.optimizeJzDjYys.get(djYys));
                    }
                }
            }
            //移动
            else if (message.getJzType().equals("1")){
                message.setTypeName(TypeEnum.YD.getname());
                for (String ydYys : SDictionaryServiceImpl.optimizeJzYdYys.keySet()) {
                    if (ydYys.equals(message.getJzYys())){
                        message.setYysName(SDictionaryServiceImpl.optimizeJzYdYys.get(ydYys));
                    }
                }
                for (String ydUpper : SDictionaryServiceImpl.optimizeJzYdUpper.keySet()) {
                    if (ydUpper.equals(message.getJzUpCustom())){
                        message.setUpperName(SDictionaryServiceImpl.optimizeJzYdUpper.get(ydUpper));
                    }
                }
            }
            //铁塔
            else if (message.getJzType().equals("2")){
                message.setTypeName(TypeEnum.TT.getname());
                for (String ttYys : SDictionaryServiceImpl.optimizeJzTtYys.keySet()) {
                    if (ttYys.equals(message.getJzYys())){
                        message.setYysName(SDictionaryServiceImpl.optimizeJzTtYys.get(ttYys));
                    }
                }
                for (String ttUpper : SDictionaryServiceImpl.optimizeJzTtUpper.keySet()) {
                    if (ttUpper.equals(message.getJzUpCustom())){
                        message.setUpperName(SDictionaryServiceImpl.optimizeJzTtUpper.get(ttUpper));
                    }
                }
            }

            //判断是否是导入还是查询全部
            if (export.equals("0")){
                isWaring(message);
            }
        }
    }

    public void isWaring(JzMessage message){
        //判断是否为预警状态
        UserWarning userWarning = new UserWarning();
        userWarning.setNormal();
        userWarning.setJzId(message.getBusinessId());
        userWarning.setUserId(message.getJzCurUser());
        List<UserWarning> userWarnings =  userWarningRepository.queryIsWaring(userWarning);
        //如果预警表为空,说明该基站未预警
        if (CollectionUtils.isEmpty(userWarnings)){
            message.setIsWaring("0");
        }else{
            message.setIsWaring("1");
        }
        for (UserWarning warning : userWarnings) {
            message.setUwType(warning.getType());
            message.setJzStatus(warning.getJzStatus());
        }
    }
}
