package org.rcisoft.business.jzmessage.common;

import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.rcisoft.business.jzmessage.entity.JzMessage;
import org.rcisoft.business.jzmessage.util.FindSon;
import org.rcisoft.business.sdictionary.service.impl.SDictionaryServiceImpl;
import org.rcisoft.core.util.CyUserUtil;
import org.rcisoft.sys.dept.entity.SysDept;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

import static org.rcisoft.business.sdictionary.service.impl.SDictionaryServiceImpl.*;

//关联表分页
@Slf4j
@Component
public class Relevance {

    public  JzMessage helpPagination(JzMessage jzMessage,List<SysDept> deptList){
        Boolean isNotSpecialRole = true;//不是特殊角色
        Boolean isNotSpecialDept = true;//不是特殊部门
        Boolean isSalesman = false;//是不是业务员
        List<String> deptIdList = new ArrayList<>();
        String roleStr = CyUserUtil.getAuthenRoleStr();//获取当前登录人角色
        String userId = CyUserUtil.getAuthenBusinessId();//获取当前登录人id
        String userCode = CyUserUtil.getAuthenBusinessId();//获取当前登录人id
        HashMap<String,List<String>> crossDeptList =  new HashMap<>();
        String parentsId = null;
        //字符数组转list
        List<String> roleIdList =null;
        if (roleStr!=null){
            roleIdList  = Arrays.asList(roleStr.split(","));
        }

        String deptCode = CyUserUtil.getAuthenDeptCode();//获取部门编号
        String deptId = CyUserUtil.getAuthenDept();//获取部门id

        for(SysDept item : deptList){ //遍历部门列表
            if(item.getCode().equals(deptCode)){//查询当前部门信息
                parentsId = item.getParentId();//上级部门id
                break;
            }
        }
        if (roleIdList!=null){
            for (String roleId : roleIdList){//判断是不是特殊角色
                if(specialRole.values().contains(roleId)){
                    isNotSpecialRole = false;
                }
                if(salesman.values().contains(roleId)){
                    isSalesman = true;
                }
            }
        }
        //判断是不是特殊部门
        if(specialDept.values().contains(deptCode)){
            isNotSpecialDept = false;
        }
        //解析当前业务员姓名
        String curUserName = jzMessage.getCurUserName(); //获取当前业务员姓名字符串
        String[] names = new String[5];
        if (curUserName != null && curUserName != ""){
            String[] temp = curUserName.split(" ");
            //只取前五个字符串
            if (temp.length>5){
                for (int i = 0; i <5; i++){
                    names[i] = temp[i];
                }
            }else {
                names = temp;
            }
            jzMessage.setCurUserNames(names);
        }
        //解析当前选择基站id
        String tempBusinessIds = jzMessage.getBusinessId();
        if (tempBusinessIds!=null){
            jzMessage.setBusinessIds(tempBusinessIds.split(","));
        }
        jzMessage = tranFiledFront(jzMessage);
        //设置数据字典jzQy关联
        jzMessage.setJzLocation(DictionaryMap.jzLocation);
        jzMessage.setNormal();
        //部门在数据字典companyDept中，可以查看本公司所有数据，合规部可以查看所属部门下的所有部门数据
        if (companyDept.containsValue(deptId)){
            //查找出当前登录人所属（部门）分公司
            String companyId = FindSon.FindCompany(deptId,deptId,deptList);
            if (SDictionaryServiceImpl.deptForGswl.containsValue(companyId)){
                for (String s : SDictionaryServiceImpl.deptForGswl.keySet()) {
                    deptIdList.addAll(FindSon.FindSons(SDictionaryServiceImpl.deptForGswl.get(s), deptList));
                    deptIdList.add(SDictionaryServiceImpl.deptForGswl.get(s));
                }
            }else{
                deptIdList.addAll(FindSon.FindSons(companyId,deptList));
                //放入当前部门
                deptIdList.add(companyId);
            }
        }
        //如果是合规部，那么就可以查看其所属部门下的所有基站信息
        if (hgb.containsValue(deptId)){
            deptIdList.addAll(FindSon.FindSons(parentsId,deptList));
        }
        //数据字典取值为 (371:13,54）371为用户businessId，13,54为用户跨部门查看的部门id
        //解析value
        for (String value : rallyManager.values()) {
            String[] v = value.split(":");
            List<String> temp = Arrays.asList(v[1].split(","));
            crossDeptList.put(v[0],temp);
        }
        for (String s : crossDeptList.keySet()) {
            if (s.equals(userId)){
                for (String dept : crossDeptList.get(s)) {
                        deptIdList.addAll(FindSon.FindSons(dept,deptList));
                        deptIdList.add(dept);
                }
            }
        }
        deptIdList.addAll(FindSon.FindSons(deptId,deptList));//递归查询子部门
        deptIdList.add(deptId);//添加当前部门id
        jzMessage.setDeptIdList(deptIdList);
        jzMessage.setNotSpecialRole(isNotSpecialRole);
        jzMessage.setNotSpecialDept(isNotSpecialDept);
        jzMessage.setIsSalesMan(isSalesman);
        return jzMessage;
    }
    //解析前台特殊格式数据
    public JzMessage tranFiledFront(JzMessage jzMessage){
        //解析当前选择运营商 运行商格式  JZ_DJ_YYS,1
        String[] jzYys = new String[3];
        String[] jzUpCustom = new String[3];
        String[] jzState = new String[3];
        if (StringUtils.isNotEmpty(jzMessage.getJzYys())){
            jzYys = jzMessage.getJzYys().split(",");
            jzMessage.setSDicYysType(jzYys[1]); //数据字典类型
            jzMessage.setJzYys(jzYys[2]);//数据字典属性
        }
        //解析当前选择上游客户 JZ_YD_UPPER,1
        if (StringUtils.isNotEmpty(jzMessage.getJzUpCustom())){
            jzUpCustom = jzMessage.getJzUpCustom().split(",");
            jzMessage.setSDicUpperType(jzUpCustom[1]); //数据字典类型
            jzMessage.setJzUpCustom(jzUpCustom[2]);//数据字典属性
        }
        //解析基站状态 1,3 (1代表基站类型jz_type 3代表基站状态 jz_state)
        if (StringUtils.isNotEmpty(jzMessage.getJzState())&&StringUtils.isEmpty(jzMessage.getJzType())){
            jzState = jzMessage.getJzState().split(",");
            jzMessage.setJzState(jzState[1]);
        }else if(StringUtils.isNotEmpty(jzMessage.getJzType())){
            List<String> listJzState = Arrays.asList(jzMessage.getJzState().split(","));
            jzMessage.setListJzState(listJzState);
        }

        if (StringUtils.isNotEmpty(jzMessage.getJzState())&&StringUtils.isEmpty(jzMessage.getJzType())){
            jzMessage.setJzType(jzState[0]);
        }else if (StringUtils.isNotEmpty(jzMessage.getJzUpCustom())&&StringUtils.isEmpty(jzMessage.getJzType())){
            jzMessage.setJzType(jzUpCustom[0]);//基站类型
        }else if (StringUtils.isNotEmpty(jzMessage.getJzYys())&&StringUtils.isEmpty(jzMessage.getJzType())){
            jzMessage.setJzType(jzYys[0]);//基站类型
        }

        //设置数据字典关联
        return jzMessage;
    }
}
