package org.rcisoft.business.jzmessage.controller;

import lombok.extern.slf4j.Slf4j;
import org.rcisoft.business.exportexclemodel.util.ExcelDownload;
import org.rcisoft.business.jzmessage.entity.FileUpload;
import org.rcisoft.business.jzmessage.entity.JzMessage;
import org.rcisoft.core.constant.CyMessCons;
import org.rcisoft.core.controller.CyFileController;
import org.rcisoft.core.model.CyPersistModel;
import org.rcisoft.core.result.CyResult;
import org.rcisoft.core.util.CyResultGenUtil;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

@RestController
@RequestMapping("/file")
@Slf4j
public class JzFileController extends CyFileController {
    public final static String RIGHTSEPARATOR = "/";
    public final static String LEFTONESEPARATOR = "\\";
    public final static String LEFTSEPARATOR = "\\\\";
    @Value("${global.path.base_upload_location}")
    public  String BASE_UPLOAD_LOCATION;
    @Value("${global.path.temp_location}")
    public  String TEMP_LOCATION;
    @Value("${global.path.jz_location}")
    public  String JZ_LOCATION;

    @PostMapping("/upload")
    public CyResult fileUpload(@RequestParam("file") MultipartFile multipartFile, JzMessage jzMessage) {
        String businessId = jzMessage.getBusinessId();
        String originalName = multipartFile.getOriginalFilename();//获取文件名字
        String absolutePath = BASE_UPLOAD_LOCATION + JZ_LOCATION + businessId;//文件绝对路径
        String tempPath = super.globalCommonFileUpload(multipartFile, CyFileController.SAVING_PATTERN_UUID, absolutePath);
        log.debug("路径：" + tempPath);
        List<String> middlePath = new ArrayList<>();
        if (tempPath.contains(LEFTONESEPARATOR)){
            middlePath = Arrays.asList(tempPath.split(LEFTSEPARATOR));
        }else{
            middlePath = Arrays.asList(tempPath.split(RIGHTSEPARATOR));
        }
        String newOriginalName = "";
        for (String s : middlePath) {
            if (s.contains(".")) {
                newOriginalName = s;
            }
        }
        //拼接新的资源路径
        String finallyPath = JZ_LOCATION + businessId + "/" + newOriginalName;
        FileUpload fileUpload = new FileUpload();
        fileUpload.setFileName(originalName);
        fileUpload.setFilePath(finallyPath);
        return CyResultGenUtil.builder(new CyPersistModel(1),
                CyMessCons.MESSAGE_ALERT_SUCCESS,
                CyMessCons.MESSAGE_ALERT_ERROR,
                fileUpload);
    }

    @GetMapping("/download")
    public CyResult fileDownload(@RequestParam("fileName") String fileName,@RequestParam("filePath") String filePath, HttpServletResponse response, HttpServletRequest request) {
       // filePath = filePath.substring(1,filePath.length()-1);
       //  fileName = fileName.substring(1,fileName.length()- 1);
        String absolutePath = BASE_UPLOAD_LOCATION + filePath;
        ExcelDownload.getExcel(absolutePath,fileName,response,request);
        return CyResultGenUtil.builder(new CyPersistModel(1),
                CyMessCons.MESSAGE_ALERT_SUCCESS,
                CyMessCons.MESSAGE_ALERT_ERROR,
                null);
    }
}
