package org.rcisoft.business.jzmessage.util;

import com.alibaba.fastjson.JSONObject;
import lombok.extern.slf4j.Slf4j;
import org.rcisoft.business.jzmessage.entity.JzMessage;
import org.rcisoft.common.ProcessMapBpmn;
import org.rcisoft.common.RegionEnum;
import org.springframework.stereotype.Component;
import org.springframework.util.StringUtils;

import java.math.BigDecimal;
import java.util.Map;
@Slf4j
@Component
public class CommonMethod {
    private static final String JZXGID = "xid"; //修改id
    //移动会审
    private static final String JZCODE = "jzCode";//移动基站编号
    private static final String JZNAME = "jzName";//基站名称
    private static final String PROJECTCODE = "projectCode";//项目编号
    private static final String PROJECTADDRESS = "projectAddress";//项目地址
    private static final String BUSINESSLINE = "businessLine";//业务线
    private static final String JZLONGITUDE = "jzLongitude";//经度
    private static final String JZLATITUDE = "jzLatitude";//纬度
    //铁塔立项
    private static final String JZPROJECTID = "jzProjectId";//项目id
    private static final String JZCURUSER = "jzCurUser";//阶段负责人
    private static final String JZREQUIRE = "jzRequire";//需求号

    //解析静态资源字符串
    public static JzMessage jsonToData(JzMessage jzMessage) {
        String regionJson = jzMessage.getFlowJsonStr();
        if (!StringUtils.isEmpty(regionJson)) {
            JSONObject obj = null;
            try{
                //
                obj = JSONObject.parseObject(regionJson);
            }catch(Exception e){
                log.error("region_str ...........解析错误" + jzMessage.getFlowJsonStr());
                return null;
            }
            for (Map.Entry<String, Object> entry : obj.entrySet()) {
                //勘察单
                if (RegionEnum.JZPROSPECTLIST.getKey().equals(entry.getKey())) {
                    JSONObject object = JSONObject.parseObject(obj.getString(entry.getKey()));
                    for (Map.Entry<String, Object> objectEntry : object.entrySet()) {
                        if (RegionEnum.JZPROSPECTLIST.getName().equals(objectEntry.getKey())) {
                            log.debug("资源：" + objectEntry.getValue().toString());
                            jzMessage.setJzProspectlistName(objectEntry.getValue().toString());
                        }
                        if (RegionEnum.JZPROSPECTLIST.getPath().equals(objectEntry.getKey())) {
                            log.debug("资源：" + objectEntry.getValue().toString());
                            jzMessage.setJzProspectlistPath(objectEntry.getValue().toString());
                        }
                    }
                    //移动铁塔勘察原因
                    jzMessage.setJzWaitReason(RegionEnum.JZPROSPECTLIST.getReason());
                }
                //设计图
                if (RegionEnum.JZDESIGNDRAWING.getKey().equals(entry.getKey())) {
                    JSONObject object = JSONObject.parseObject(obj.getString(entry.getKey()));
                    for (Map.Entry<String, Object> objectEntry : object.entrySet()) {
                        if (RegionEnum.JZDESIGNDRAWING.getName().equals(objectEntry.getKey())) {
                            jzMessage.setJzDesigndrawingName(objectEntry.getValue().toString());
                        }
                        if (RegionEnum.JZDESIGNDRAWING.getPath().equals(objectEntry.getKey())) {
                            jzMessage.setJzDesigndrawingPath(objectEntry.getValue().toString());
                        }
                    }
                    //当select为M004时，设置移动会审原因
                    if (ProcessMapBpmn.MC_JOINT_HEARING.getCode().equals(jzMessage.getSelect())){
                        jzMessage.setJzWaitReason(RegionEnum.JZDESIGNDRAWING.getReason());
                    }
                }
                //要素表
                if (RegionEnum.JZELEMENTLIST.getKey().equals(entry.getKey())) {
                    JSONObject object = JSONObject.parseObject(obj.getString(entry.getKey()));
                    for (Map.Entry<String, Object> objectEntry : object.entrySet()) {
                        if (RegionEnum.JZELEMENTLIST.getName().equals(objectEntry.getKey())) {
                            jzMessage.setJzElementlistName(objectEntry.getValue().toString());
                        }
                        if (RegionEnum.JZELEMENTLIST.getPath().equals(objectEntry.getKey())) {
                            jzMessage.setJzElementlistPath(objectEntry.getValue().toString());
                        }
                    }
                }
                //出库单
                if (RegionEnum.JZOUTBOUNDLIST.getKey().equals(entry.getKey())) {
                    JSONObject object = JSONObject.parseObject(obj.getString(entry.getKey()));
                    for (Map.Entry<String, Object> objectEntry : object.entrySet()) {
                        if (RegionEnum.JZOUTBOUNDLIST.getName().equals(objectEntry.getKey())) {
                            jzMessage.setJzOutboundlistName(objectEntry.getValue().toString());
                        }
                        if (RegionEnum.JZOUTBOUNDLIST.getPath().equals(objectEntry.getKey())) {
                            jzMessage.setJzOutboundlistPath(objectEntry.getValue().toString());
                        }
                    }
                    //移动铁塔领料阶段原因
                    jzMessage.setJzWaitReason(RegionEnum.JZOUTBOUNDLIST.getReason());
                }
                //运营商验收单
                if (RegionEnum.JZOPERATORACCEPTLIST.getKey().equals(entry.getKey())) {
                    JSONObject object = JSONObject.parseObject(obj.getString(entry.getKey()));
                    for (Map.Entry<String, Object> objectEntry : object.entrySet()) {
                        if (RegionEnum.JZOPERATORACCEPTLIST.getName().equals(objectEntry.getKey())) {
                            jzMessage.setJzOperatoracceptlistName(objectEntry.getValue().toString());
                        }
                        if (RegionEnum.JZOPERATORACCEPTLIST.getPath().equals(objectEntry.getKey())) {
                            jzMessage.setJzOperatoracceptlistPath(objectEntry.getValue().toString());
                        }
                    }
                    //移动施工验收原因
                    jzMessage.setJzWaitReason(RegionEnum.JZOPERATORACCEPTLIST.getReason());
                }
                //路由图
                if (RegionEnum.JZROUTEDRAWING.getKey().equals(entry.getKey())) {
                    JSONObject object = JSONObject.parseObject(obj.getString(entry.getKey()));
                    for (Map.Entry<String, Object> objectEntry : object.entrySet()) {
                        if (RegionEnum.JZROUTEDRAWING.getName().equals(objectEntry.getKey())) {
                            jzMessage.setJzRoutedrawingName(objectEntry.getValue().toString());
                        }
                        if (RegionEnum.JZROUTEDRAWING.getPath().equals(objectEntry.getKey())) {
                            jzMessage.setJzRoutedrawingPath(objectEntry.getValue().toString());
                        }
                    }
                }
                //竣工单
                if (RegionEnum.JZCOMPLETEDACCEPTLIST.getKey().equals(entry.getKey())) {
                    JSONObject object = JSONObject.parseObject(obj.getString(entry.getKey()));
                    for (Map.Entry<String, Object> objectEntry : object.entrySet()) {
                        if (RegionEnum.JZCOMPLETEDACCEPTLIST.getName().equals(objectEntry.getKey())) {
                            jzMessage.setJzCompletedacceptlistName(objectEntry.getValue().toString());
                        }
                        if (RegionEnum.JZCOMPLETEDACCEPTLIST.getPath().equals(objectEntry.getKey())) {
                            jzMessage.setJzCompletedacceptlistPath(objectEntry.getValue().toString());
                        }
                    }
                }
                //上联机房位置
                if (RegionEnum.JZUPPERMACHINEROOMPLACE.getKey().equals(entry.getKey())) {
                    jzMessage.setJzUppermachineroomplace(entry.getValue().toString());
                }
                //网元id
                if (RegionEnum.JZNEID.getKey().equals(entry.getKey())) {
                    jzMessage.setJzNeId(entry.getValue().toString());
                }
                //移动开通截图
                if (RegionEnum.JZOPENDRAWING.getKey().equals(entry.getKey())) {
                    JSONObject object = JSONObject.parseObject(obj.getString(entry.getKey()));
                    for (Map.Entry<String, Object> objectEntry : object.entrySet()) {
                        if (RegionEnum.JZOPENDRAWING.getName().equals(objectEntry.getKey())) {
                            jzMessage.setJzOpendrawingName(objectEntry.getValue().toString());
                        }
                        if (RegionEnum.JZOPENDRAWING.getPath().equals(objectEntry.getKey())) {
                            jzMessage.setJzOpendrawingPath(objectEntry.getValue().toString());
                        }
                    }
                    jzMessage.setJzWaitReason(RegionEnum.JZOPENDRAWING.getReason());
                }
                //资产编码
                if (RegionEnum.JZPROPERTYCODE.getKey().equals(entry.getKey())) {
                    jzMessage.setJzPropertycode(entry.getValue().toString());
                    jzMessage.setJzWaitReason(RegionEnum.JZPROPERTYCODE.getReason());
                }
                //是否与业主交接
                if (RegionEnum.JZISCONNECTWITHOWNER.getKey().equals(entry.getKey())) {
                    jzMessage.setJzIsconnectwithowner(entry.getValue().toString());
                    jzMessage.setJzWaitReason(RegionEnum.JZISCONNECTWITHOWNER.getReason()); //交维原因
                }
                //接维物业名称
                if (RegionEnum.JZPROPERTYNAME.getKey().equals(entry.getKey())) {
                    jzMessage.setJzPropertyname(entry.getValue().toString());
                }
                //业主联系方式
                if (RegionEnum.JZOWNERCONTACTINFO.getKey().equals(entry.getKey())) {
                    jzMessage.setJzOwnercontactinfo(entry.getValue().toString());
                }
                //交维人员
                if (RegionEnum.JZMAINTAIN.getKey().equals(entry.getKey())) {
                    JSONObject object = JSONObject.parseObject(obj.getString(entry.getKey()));
                    for (Map.Entry<String, Object> objectEntry : object.entrySet()) {
                        if (RegionEnum.JZMAINTAIN.getName().equals(objectEntry.getKey())) {
                            jzMessage.setJzCurUser(objectEntry.getValue().toString());
                        }
                        if (RegionEnum.JZMAINTAIN.getPath().equals(objectEntry.getKey())) {
                            jzMessage.setJzCurDept(objectEntry.getValue().toString());
                        }
                    }
                }
                //电力预算
                if (RegionEnum.JZBUDGETOFELECTIC.getKey().equals(entry.getKey())) {
                    JSONObject object = JSONObject.parseObject(obj.getString(entry.getKey()));
                    for (Map.Entry<String, Object> objectEntry : object.entrySet()) {
                        if (RegionEnum.JZBUDGETOFELECTIC.getName().equals(objectEntry.getKey())) {
                            jzMessage.setJzBudgetofelecticName(objectEntry.getValue().toString());
                        }
                        if (RegionEnum.JZBUDGETOFELECTIC.getPath().equals(objectEntry.getKey())) {
                            jzMessage.setJzBudgetofelecticPath(objectEntry.getValue().toString());
                        }
                    }
                    //当基站类型为TOO5时，设置立项原因
                    if (ProcessMapBpmn.IT_PROJECT_APPROVAL.getCode().equals(jzMessage.getSelect())){
                        jzMessage.setJzWaitReason(RegionEnum.JZBUDGETOFELECTIC.getReason());
                    }
                }
                //立项物质清单
                if (RegionEnum.JZMATTERLIST.getKey().equals(entry.getKey())) {
                    JSONObject object = JSONObject.parseObject(obj.getString(entry.getKey()));
                    for (Map.Entry<String, Object> objectEntry : object.entrySet()) {
                        if (RegionEnum.JZMATTERLIST.getName().equals(objectEntry.getKey())) {
                            jzMessage.setJzMatterlistName(objectEntry.getValue().toString());
                        }
                        if (RegionEnum.JZMATTERLIST.getPath().equals(objectEntry.getKey())) {
                            jzMessage.setJzMatterlistPath(objectEntry.getValue().toString());
                        }
                    }
                }
                //开工报告
                if (RegionEnum.JZOPENREPORY.getKey().equals(entry.getKey())) {
                    JSONObject object = JSONObject.parseObject(obj.getString(entry.getKey()));
                    for (Map.Entry<String, Object> objectEntry : object.entrySet()) {
                        if (RegionEnum.JZOPENREPORY.getName().equals(objectEntry.getKey())) {
                            jzMessage.setJzOpenreporyName(objectEntry.getValue().toString());
                        }
                        if (RegionEnum.JZOPENREPORY.getPath().equals(objectEntry.getKey())) {
                            jzMessage.setJzOpenreporyPath(objectEntry.getValue().toString());
                        }
                    }
                    jzMessage.setJzWaitReason(RegionEnum.JZOPENREPORY.getReason());
                }
                //施工组织方案
                if (RegionEnum.JZCONSTRUCTPROCEPT.getKey().equals(entry.getKey())) {
                    JSONObject object = JSONObject.parseObject(obj.getString(entry.getKey()));
                    for (Map.Entry<String, Object> objectEntry : object.entrySet()) {
                        if (RegionEnum.JZCONSTRUCTPROCEPT.getName().equals(objectEntry.getKey())) {
                            jzMessage.setJzConstructproceptName(objectEntry.getValue().toString());
                        }
                        if (RegionEnum.JZCONSTRUCTPROCEPT.getPath().equals(objectEntry.getKey())) {
                            jzMessage.setJzConstructproceptPath(objectEntry.getValue().toString());
                        }
                    }
                }
                //完工报告
                if (RegionEnum.JZCOMPLETEDREPORT.getKey().equals(entry.getKey())) {
                    JSONObject object = JSONObject.parseObject(obj.getString(entry.getKey()));
                    for (Map.Entry<String, Object> objectEntry : object.entrySet()) {
                        if (RegionEnum.JZCOMPLETEDREPORT.getName().equals(objectEntry.getKey())) {
                            jzMessage.setJzCompletedreportName(objectEntry.getValue().toString());
                        }
                        if (RegionEnum.JZCOMPLETEDREPORT.getPath().equals(objectEntry.getKey())) {
                            jzMessage.setJzCompletedreportPath(objectEntry.getValue().toString());
                        }
                    }
                    jzMessage.setJzWaitReason(RegionEnum.JZCOMPLETEDREPORT.getReason());
                }
                //完工照片
                if (RegionEnum.JZCOMPLETEDPHOTO.getKey().equals(entry.getKey())) {
                    JSONObject object = JSONObject.parseObject(obj.getString(entry.getKey()));
                    for (Map.Entry<String, Object> objectEntry : object.entrySet()) {
                        if (RegionEnum.JZCOMPLETEDPHOTO.getName().equals(objectEntry.getKey())) {
                            jzMessage.setJzCompletedphotoName(objectEntry.getValue().toString());
                        }
                        if (RegionEnum.JZCOMPLETEDPHOTO.getPath().equals(objectEntry.getKey())) {
                            jzMessage.setJzCompletedphotoPath(objectEntry.getValue().toString());
                        }
                    }
                }
                //起租截图
                if (RegionEnum.JZRENTDRAWING.getKey().equals(entry.getKey())) {
                    JSONObject object = JSONObject.parseObject(obj.getString(entry.getKey()));
                    for (Map.Entry<String, Object> objectEntry : object.entrySet()) {
                        if (RegionEnum.JZRENTDRAWING.getName().equals(objectEntry.getKey())) {
                            jzMessage.setJzRentdrawingName(objectEntry.getValue().toString());
                        }
                        if (RegionEnum.JZRENTDRAWING.getPath().equals(objectEntry.getKey())) {
                            jzMessage.setJzRentdrawingPath(objectEntry.getValue().toString());
                        }
                    }
                    jzMessage.setJzWaitReason(RegionEnum.JZRENTDRAWING.getReason());
                }
                //更换业务员
                if (RegionEnum.CHANGESALESMAN.getKey().equals(entry.getKey())) {
                    //修改当前部门id
                    jzMessage.setJzCurUser(entry.getValue().toString());
                    jzMessage.setJzWaitReason(RegionEnum.CHANGESALESMAN.getReason());
                }
                //修改id
                if (JZXGID.equals(entry.getKey())){
                    jzMessage.setJzXgid(entry.getValue().toString());
                }
                //基站号
                if (JZCODE.equals(entry.getKey())){
                    jzMessage.setJzCode(entry.getValue().toString());
                }
                //基站名
                if (JZNAME.equals(entry.getKey())){
                    jzMessage.setJzName(entry.getValue().toString());
                }
                //项目编号
                if (PROJECTCODE.equals(entry.getKey())){
                    jzMessage.setProjectCode(entry.getValue().toString());
                }
                //业务线
                if (BUSINESSLINE.equals(entry.getKey())){
                    jzMessage.setBusinessLine(entry.getValue().toString());
                }
                //设置项目地址
                if (PROJECTADDRESS.equals(entry.getKey())){
                    jzMessage.setProjectAddress(entry.getValue().toString());
                }
                //经度
                if (JZLONGITUDE.equals(entry.getKey())){
                    jzMessage.setJzLongitude(BigDecimal.valueOf(Double.parseDouble(entry.getValue().toString())));
                }
                //纬度
                if (JZLATITUDE.equals(entry.getKey())){
                    jzMessage.setJzLatitude(BigDecimal.valueOf(Double.parseDouble(entry.getValue().toString())));
                }
                //阶段负责人
                if (JZCURUSER.equals(entry.getKey())){
                    jzMessage.setJzCurUser(entry.getValue().toString());
                }
                //项目id
                if (JZPROJECTID.equals(entry.getKey())){
                    jzMessage.setJzProjectId(entry.getValue().toString());
                }
                //需求号
               if (JZREQUIRE.equals(entry.getKey())){
                   jzMessage.setJzRequire(entry.getValue().toString());
               }

            }

        }
        return jzMessage;
    }
}
