package org.rcisoft.business.jzmessage.util;

import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.rcisoft.sys.dept.entity.SysDept;

import java.util.ArrayList;
import java.util.List;
@Slf4j
public class FindSon {

    /**
     * 查找当前节点下  多级子部门
     * @param fatherId
     * @param idList
     * @return
     */
    public  static List<String > FindSons(String fatherId, List<SysDept> idList){
        List<String> sonList = new ArrayList<>();
        for(SysDept id:idList){
            if(id.getParentId() != null && id.getParentId().equals(fatherId)){
                sonList.add(id.getBusinessId());
                sonList.addAll(FindSon.FindSons(id.getBusinessId(),idList));
            }
        }
        return sonList;
    }

    /**
     * 查找节点  -> 公司id
     * @param cuRid  当前id
     * @param sysDepts 部门结合
     * @return
     */
    public static String FindCompany(String cuRid,String child,List<SysDept> sysDepts) {
        boolean flag = false;
        for(SysDept dept:sysDepts){
            //当前部门
            if(cuRid.equals(dept.getBusinessId())){
                //父节点 null  -> 公司节点
                if(StringUtils.isEmpty(dept.getParentId())){
                    flag = true;
                }
                else {
                    child = cuRid;
                    cuRid = dept.getParentId();
                }
                break;
            }
        }
        if(flag)
            return child;
        else
            return FindCompany(cuRid, child, sysDepts);
    }
}
