package org.rcisoft.business.kingdee.service;

/**
 * @Author: jiangpengpeng
 * @Description:
 * @Date: Created in 11:17  2019/9/11
 * @Modified By:
 */

import org.rcisoft.business.jzmessage.entity.JzMessage;
import org.rcisoft.core.model.CyPersistModel;
import org.rcisoft.core.result.CyResult;

import java.util.List;
import java.util.Map;

/**
 * @Description: 金蝶接口服务
 * @date 2019/1/4 14:09
 */
public interface KingdeeService {

    /**
     * @param url     接口地址
     * @param content 查询参数
     * @Description: 金蝶登录接口
     * @date 2019/1/4 14:12
     */
    CyResult login(String url, String content);


    /**
     * @param cookie  登录cookie
     * @param content 查询参数
     * @Description: 金蝶查询接口
     * @date 2019/1/7 17:21
     */
    CyResult view(String url, String cookie, String content);

    /**
     * @param url     接口地址
     * @param cookie  登录cookie
     * @param content json格式参数
     * @Description: 保存接口
     * @date 2019/1/4 14:18
     */
    CyResult save(String url, String cookie, String content);

    /**
     * @param url     接口地址
     * @param cookie  登录cookie
     * @param content json格式参数
     * @Description: 获取编号接口
     * @date 2019/1/4 14:18
     */
    CyResult getNum(String url, String cookie, Map content);

}

