package org.rcisoft.business.kingdee.service.impl;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.lang3.StringUtils;
import org.rcisoft.business.jzmessage.dao.JzMessageRepository;
import org.rcisoft.business.jzmessage.entity.JzMessage;
import org.rcisoft.business.kingdee.commom.K3CloundConfig;
import org.rcisoft.business.kingdee.service.KingDeeMyselfPorCodeService;
import org.rcisoft.business.kingdee.service.KingdeeService;
import org.rcisoft.business.kingdee.until.BaseUtil;
import org.rcisoft.business.kingdee.until.PropertiesUtils;
import org.rcisoft.core.model.CyPersistModel;
import org.rcisoft.core.result.CyResult;
import org.rcisoft.core.service.CyBaseService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

/**
 * @Author: jiangpengpeng
 * @Description:
 * @Date: Created in 17:49  2019/9/18
 * @Modified By:
 */
@Slf4j
@Service
public class KingDeeMyselfProCodeServiceImpl extends CyBaseService implements KingDeeMyselfPorCodeService {

    @Autowired
    K3CloundConfig k3CloundConfig;
    @Autowired
    KingdeeService kingdeeService;
    @Autowired
    JzMessageRepository jzMessageRepository;

    private static final String projectCodeSaveError = "组织内编码唯一";
    private static final String formid = "PAEZ_ProjectNo";


    @Override
    public CyPersistModel kingDeeProCode(String cookie) {
        //查询项目编号未录入的数据
        JzMessage jzMessage1 = new JzMessage();
        jzMessage1.setNormal();
        jzMessage1.setProjectCodeImport(0);
        List<JzMessage> jzMessages = jzMessageRepository.queryJzMessageByProjectCodeImport(jzMessage1);
        if (jzMessages.size()>100) {
            jzMessages = jzMessages.subList(0, 100);
        }
        if (CollectionUtils.isEmpty(jzMessages)){
            log.debug("未检测到数据");
            return new CyPersistModel(1,"未检测到保存数据");
        }for (JzMessage jzMessage : jzMessages) {
            if (KingDeeProjectNum(jzMessage.getProjectCode(), cookie) != null) {
                JSONArray jsonArray = JSONArray.parseArray(KingDeeProjectNum(jzMessage.getProjectCode(), cookie).toString());
                if(jsonArray.size()>0) {
                    for (int i = 0; i < jsonArray.size(); i++) {
                        JSONObject job = jsonArray.getJSONObject(i);  // 遍历 jsonarray 数组，把每一个对象转成 json 对象
                        jzMessage.setProjectCodeNumber(job.get("fnumber").toString());
                        jzMessage.setProjectCodeId(job.get("fid").toString());
                    }
                }
                jzMessage.setProjectCodeStatus("2");
                jzMessageRepository.updateByPrimaryKeySelective(jzMessage);
                this.dbInfo("项目编号为："+jzMessage.getProjectCode()+"的项目编码已存在执行修改");
            }
            if (StringUtils.isNotEmpty(jzMessage.getProjectCodeId()) && StringUtils.isNotEmpty(jzMessage.getProjectCodeNumber())) {
                if ("0".equals(jzMessage.getProjectCodeStatus()) || "1".equals(jzMessage.getProjectCodeStatus()) || "2".equals(jzMessage.getProjectCodeStatus())) {
                    //修改
                    CyResult cyResult = this.KingdeeProCodeSava(jzMessage, cookie);
                    if ("true".equals(PropertiesUtils.getResultStaus(cyResult))) {
                        Map data = (Map) JSON.parse(cyResult.getData().toString());
                        jzMessage.setProjectCodeNumber(data.get("Number").toString());
                        jzMessageRepository.updateByPrimaryKeySelective(jzMessage);
                        this.dbInfo("执行修改接口成功 项目编号状态为"+jzMessage.getProjectCodeStatus()+"FId："+jzMessage.getProjectCodeId()+"FNumber:"+jzMessage.getProjectCodeNumber()+"项目编号："+jzMessage.getProjectCode());
                        if ("0".equals(jzMessage.getProjectCodeStatus()) || "1".equals(jzMessage.getProjectCodeStatus())) {
                            if ("0".equals(jzMessage.getProjectCodeStatus())) {
                                //提交
                                CyResult cyResult1 = this.KingdeeProCodeSubmit(data.get("Number").toString(), cookie);
                                if ("true".equals(PropertiesUtils.getResultStaus(cyResult1))) {
                                    jzMessage.setProjectCodeStatus("1");
                                    this.dbInfo("执行提交接口成功 项目编号状态为"+jzMessage.getProjectCodeStatus()+"FId："+jzMessage.getProjectCodeId()+"FNumber:"+jzMessage.getProjectCodeNumber()+"项目编号："+jzMessage.getProjectCode());
                                } else {
                                    this.dbError("执行提交接口失败 项目编号状态为"+jzMessage.getProjectCodeStatus()+"FId："+jzMessage.getProjectCodeId()+"FNumber:"+jzMessage.getProjectCodeNumber()+"项目编号："+jzMessage.getProjectCode());
                                    continue;
                                }
                            }
                            //审核
                            CyResult cyResult2 = this.KingdeeProCodeAudit(data.get("Number").toString(), cookie);
                            if ("true".equals(PropertiesUtils.getResultStaus(cyResult2))) {
                                jzMessage.setProjectCodeStatus("2");
                                jzMessage.setProjectCodeImport(1);
                                jzMessageRepository.updateByPrimaryKeySelective(jzMessage);
                                this.dbError("执行审核接口成功 项目编号状态为"+jzMessage.getProjectCodeStatus()+"FId："+jzMessage.getProjectCodeId()+"FNumber:"+jzMessage.getProjectCodeNumber()+"项目编号："+jzMessage.getProjectCode());
                                continue;
                            } else {
                                jzMessageRepository.updateByPrimaryKeySelective(jzMessage);
                                this.dbError("执行审核接口失败 项目编号状态为"+jzMessage.getProjectCodeStatus()+"FId："+jzMessage.getProjectCodeId()+"FNumber:"+jzMessage.getProjectCodeNumber()+"项目编号："+jzMessage.getProjectCode());
                                continue;
                            }
                        }else {
                            jzMessage.setProjectCodeImport(1);
                            jzMessageRepository.updateByPrimaryKeySelective(jzMessage);
                        }
                    } else {
                        this.dbError("执行修改接口失败 项目编号状态为"+jzMessage.getProjectCodeStatus()+"FId："+jzMessage.getProjectCodeId()+"FNumber:"+jzMessage.getProjectCodeNumber()+"项目编号："+jzMessage.getProjectCode());
                        continue;
                    }

                }
            } else {
                CyResult cyResult = this.KingdeeProCodeSava(jzMessage, cookie);
                if ("true".equals(PropertiesUtils.getResultStaus(cyResult))) {
                    Map data = (Map) JSON.parse(cyResult.getData().toString());
                    jzMessage.setProjectCodeStatus("0");
                    jzMessage.setProjectCodeId(data.get("Id").toString());
                    jzMessage.setProjectCodeNumber(data.get("Number").toString());
                    this.dbInfo("执行保存接口成功 项目编号状态为"+jzMessage.getProjectCodeStatus()+"FId："+jzMessage.getProjectCodeId()+"FNumber:"+jzMessage.getProjectCodeNumber()+"项目编号："+jzMessage.getProjectCode());
                    //提交
                    CyResult cyResult1 = this.KingdeeProCodeSubmit(data.get("Number").toString(), cookie);
                    if ("true".equals(PropertiesUtils.getResultStaus(cyResult1))){
                        jzMessage.setProjectCodeStatus("1");
                        this.dbInfo("执行提交接口成功 项目编号状态为"+jzMessage.getProjectCodeStatus()+"FId："+jzMessage.getProjectCodeId()+"FNumber:"+jzMessage.getProjectCodeNumber()+"项目编号："+jzMessage.getProjectCode());
                        //审核
                        CyResult cyResult2 = this.KingdeeProCodeAudit(data.get("Number").toString(), cookie);
                        if ("true".equals(PropertiesUtils.getResultStaus(cyResult2))){
                            jzMessage.setProjectCodeStatus("2");
                            jzMessage.setProjectCodeImport(1);
                            jzMessageRepository.updateByPrimaryKeySelective(jzMessage);
                            this.dbInfo("执行审核接口成功 项目编号状态为"+jzMessage.getProjectCodeStatus()+"FId："+jzMessage.getProjectCodeId()+"FNumber:"+jzMessage.getProjectCodeNumber()+"项目编号："+jzMessage.getProjectCode());
                            continue;
                        }else {
                            jzMessageRepository.updateByPrimaryKeySelective(jzMessage);
                            this.dbError("执行审核接口失败 项目编号状态为"+jzMessage.getProjectCodeStatus()+"FId："+jzMessage.getProjectCodeId()+"FNumber:"+jzMessage.getProjectCodeNumber()+"项目编号："+jzMessage.getProjectCode());
                            continue;
                        }
                    }else {
                        jzMessageRepository.updateByPrimaryKeySelective(jzMessage);
                        this.dbError("执行提交接口失败 项目编号状态为"+jzMessage.getProjectCodeStatus()+"FId："+jzMessage.getProjectCodeId()+"FNumber:"+jzMessage.getProjectCodeNumber()+"项目编号："+jzMessage.getProjectCode());
                        continue;
                    }

                } else {
                    this.dbError("执行保存接口失败 项目编号状态为"+jzMessage.getProjectCodeStatus()+"FId："+jzMessage.getProjectCodeId()+"FNumber:"+jzMessage.getProjectCodeNumber()+"项目编号："+jzMessage.getProjectCode());
                    continue;
                }
            }
        }
        return new CyPersistModel(1);
    }

    //保存
    public CyResult KingdeeProCodeSava(JzMessage jzMessage, String sessionId) {
        String template = PropertiesUtils.readJsonFile("projectSave.json");
        String PAEZ_ProjectNo = BaseUtil.buildProjectCode(template, jzMessage, formid);
        CyResult save = kingdeeService.save(k3CloundConfig.getUrl() + k3CloundConfig.getSave(), sessionId, PAEZ_ProjectNo);
        if (save.getCode() == 400) {
            log.debug("【保存出错】：{}", save);
            this.dbError("基站编号：" + jzMessage.getBusinessId() + "message:" + save.getMessage());
            return save;
        }
        log.debug("【保存成功】：{}", save);
        return save;
    }

    //提交
    public CyResult KingdeeProCodeSubmit(String num, String sessionId) {
        String paez_001 = BaseUtil.buildParam(formid, num, null);
        CyResult submit = kingdeeService.save(k3CloundConfig.getUrl() + k3CloundConfig.getSubmit(), sessionId, paez_001);
        if (submit.getCode() == 400) {
            log.debug("【提交出错】：{}", submit);
            this.dbError("Message"+submit.getMessage());
            return submit;
        }
        log.debug("【提交成功】：{}", submit);
        return submit;
    }

    //审核
    public CyResult KingdeeProCodeAudit(String num, String sessionId) {
        String PAEZ_ProjectNo = BaseUtil.buildParam(formid, num, "true");
        CyResult Audit = kingdeeService.save(k3CloundConfig.getUrl() + k3CloundConfig.getAudit(), sessionId, PAEZ_ProjectNo);
        if (Audit.getCode() == 400) {
            log.debug("【审核出错】：{}", Audit);
            this.dbError("Message"+Audit.getMessage());
            return Audit;
        }
        log.debug("【审核成功】：{}", Audit);
        return Audit;
    }

    //获取项目编号列表信息
    public Object KingDeeProjectNum(String projectCode, String sessionId) {
        Map paez_001 = BaseUtil.buileContract(projectCode, formid);
        CyResult num = kingdeeService.getNum("http://36.110.39.213:8989/Home/Index/getProNumber", sessionId, paez_001);
        if (num.getCode() == 200) {
            Object data = num.getData();
            log.error("【项目编号已存在】：{}", num);
            return data;
        }
        return null;
    }

}
