package org.rcisoft.business.kingdee.service.impl;

import org.apache.commons.lang3.StringUtils;
import org.rcisoft.business.jzmessage.common.TypeEnum;
import org.rcisoft.business.jzmessage.dao.JzMessageRepository;
import org.rcisoft.business.jzmessage.entity.JzMessage;
import org.rcisoft.business.kingdee.entity.KingDeeJzMessageDTO;
import org.rcisoft.business.kingdee.service.KingDeeRecallService;
import org.rcisoft.business.kingdee.until.KingdeeStatusMap;
import org.rcisoft.business.sdictionary.service.impl.SDictionaryServiceImpl;
import org.rcisoft.common.BaseStationStatus;
import org.rcisoft.core.constant.CyMessCons;
import org.rcisoft.core.model.CyPersistModel;
import org.rcisoft.core.result.CyResult;
import org.rcisoft.core.service.CyBaseService;
import org.rcisoft.core.util.CyResultGenUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * @Author: jiangpengpeng
 * @Description:
 * @Date: Created in 16:40  2019/9/23
 * @Modified By:
 */
@Service
public class KingDeeRecallServiceImpl extends CyBaseService implements KingDeeRecallService {

    @Autowired
    JzMessageRepository jzMessageRepository;
    @Transactional
    @Override
    public CyResult KingDeeRecall(KingDeeJzMessageDTO kingDeeJzMessageDTO) {
        BaseStationStatus[] values = BaseStationStatus.values();
        List<BaseStationStatus> list = new ArrayList<>();
        for (int i = 0;i<values.length;i++){
            list.add(values[i]);
        }
        //获取基站业务线的value-name
        Set<String> optimizeJzYwxSet = SDictionaryServiceImpl.optimizeJzYwx.keySet();
        //获取区域的value-name
        Set<String> optimizeJzQySet = SDictionaryServiceImpl.optimizeJzQy.keySet();
        //获取所有用户的value-name
        Set<String> userSet = SDictionaryServiceImpl.optimizekingDeeUserMap.keySet();
        //获取所有的部门的value-name
        Set<String> deptSet = SDictionaryServiceImpl.optimizekingDeeDeptMap.keySet();
        //项目单据
        if (StringUtils.isEmpty(kingDeeJzMessageDTO.getKingNumber())) {
            return CyResultGenUtil.genFailResult("项目单据编码为空");
        }
        List<JzMessage> jzMessagess= jzMessageRepository.selectJztypeByKingNumber(kingDeeJzMessageDTO.getKingNumber());
       if(jzMessagess.size()==0){
           return CyResultGenUtil.genFailResult("未找到该数据");
       }
        Map<String, Object> jzState = KingdeeStatusMap.KingDeeStatus(jzMessagess.get(0).getJzType());
        //判断状态
        if (StringUtils.isNotEmpty(kingDeeJzMessageDTO.getJzState())) {
            for (Map.Entry<String,Object> m:jzState.entrySet()) {
                if(!jzState.values().contains(kingDeeJzMessageDTO.getJzState())){
                    return CyResultGenUtil.genFailResult("基站状态不存在");
                } else if (m.getValue().equals(kingDeeJzMessageDTO.getJzState())){
                    kingDeeJzMessageDTO.setJzState(m.getKey());
                    break;
                }
            }

        }else if (StringUtils.isEmpty(kingDeeJzMessageDTO.getJzState())){
            return CyResultGenUtil.genFailResult("基站状态未传值");
        }

        //判断区域
        if (StringUtils.isEmpty(kingDeeJzMessageDTO.getJzQy()) || !optimizeJzQySet.contains(kingDeeJzMessageDTO.getJzQy())) {
            return CyResultGenUtil.genFailResult("该区域不存在或者传值为空");
        }
       /* //========================================设置区域
        kingDeeJzMessageDTO.setJzQy(SDictionaryServiceImpl.optimizeJzQy.get(kingDeeJzMessageDTO.getJzQy()));*/
        //部门和组织

        if (StringUtils.isEmpty(kingDeeJzMessageDTO.getJzCurDept())
                ||StringUtils.isEmpty(kingDeeJzMessageDTO.getDxmorgId())
                ||!deptSet.contains(kingDeeJzMessageDTO.getDxmorgId()+","+kingDeeJzMessageDTO.getJzCurDept())){
            return CyResultGenUtil.genFailResult("该部门不存在或者组织或部门传值为空");
        }
        //========================================设置部门
        kingDeeJzMessageDTO.setJzCurDept(SDictionaryServiceImpl.optimizekingDeeDeptMap.get(kingDeeJzMessageDTO.getDxmorgId()+","+kingDeeJzMessageDTO.getJzCurDept()));
        //判断业务线
        if (StringUtils.isEmpty(kingDeeJzMessageDTO.getJzYWX()) || !optimizeJzYwxSet.contains(kingDeeJzMessageDTO.getJzYWX())) {
            return CyResultGenUtil.genFailResult("业务线不存在或者传值为空");
        }
        /*//========================================设置业务线
        kingDeeJzMessageDTO.setJzYWX(SDictionaryServiceImpl.optimizeJzYwx.get(kingDeeJzMessageDTO.getJzYWX()));*/
       //修改时间
            kingDeeJzMessageDTO.setUpdateTime(new Date());



        //项目编号
        if (StringUtils.isEmpty(kingDeeJzMessageDTO.getProjectCode())) {
            return CyResultGenUtil.genFailResult("项目编号传值为空");
        }
        //基站地址
        if (StringUtils.isEmpty(kingDeeJzMessageDTO.getProjectAddress())) {
            return CyResultGenUtil.genFailResult("基站地址传值为空");
        }
        //基站名
        if (StringUtils.isEmpty(kingDeeJzMessageDTO.getJzName())) {
            return CyResultGenUtil.genFailResult("基站名传值为空");
        }
        //基站号
        if (StringUtils.isEmpty(kingDeeJzMessageDTO.getJzCode())) {
            return CyResultGenUtil.genFailResult("基站号传值为空");
        }
        //业务员
        if (StringUtils.isEmpty(kingDeeJzMessageDTO.getJzcurUser()) || !userSet.contains(kingDeeJzMessageDTO.getJzcurUser())) {
            return CyResultGenUtil.genFailResult("业务员1不存在或者传值为空");
        }
        //=================================设置业务员
        kingDeeJzMessageDTO.setJzcurUser(SDictionaryServiceImpl.optimizekingDeeUserMap.get(kingDeeJzMessageDTO.getJzcurUser()));
        //项目负责人
        if (StringUtils.isEmpty(kingDeeJzMessageDTO.getJzProjectOwner()) || !userSet.contains(kingDeeJzMessageDTO.getJzProjectOwner())) {
            return CyResultGenUtil.genFailResult("三级经理不存在或者传值为空");
        }
        //=================================设置项目负责人
        kingDeeJzMessageDTO.setJzProjectOwner(SDictionaryServiceImpl.optimizekingDeeUserMap.get(kingDeeJzMessageDTO.getJzProjectOwner()));

        int i = jzMessageRepository.updateJzMEssageByKingDee(kingDeeJzMessageDTO);
        if (i == 0){
            return CyResultGenUtil.genFailResult("未找到该条数据");
        }
       // this.dbInfo("---12231231321312321132321321123231231123321-------测试----------");
        this.dbInfo("金蝶调用修改接口：修改了单据编号="+kingDeeJzMessageDTO.getKingNumber()+"\t原基站状态："+jzMessagess.get(0).getJzState()+"\t改为基站状态："+kingDeeJzMessageDTO.getJzState()+
        "\t原区域:"+jzMessagess.get(0).getJzQy()+"\t改为区域："+kingDeeJzMessageDTO.getJzQy()+"\t原部门："+jzMessagess.get(0).getJzCurDept()+"改为部门："+kingDeeJzMessageDTO.getJzCurDept()+
        "\n原业务线："+jzMessagess.get(0).getBusinessLine()+"\t改为业务线："+kingDeeJzMessageDTO.getJzYWX()+"\t原项目编号："+jzMessagess.get(0).getProjectCode()+"\t改为项目编号："+kingDeeJzMessageDTO.getProjectCode()+
        "\n原基站地址传值："+jzMessagess.get(0).getProjectAddress()+"\t改为基站地址："+kingDeeJzMessageDTO.getProjectAddress()+"\t原基站名："+jzMessagess.get(0).getJzName()+"\t改为基站名："+kingDeeJzMessageDTO.getJzName()+
        "\n原基站号："+jzMessagess.get(0).getJzCode()+"\t改为基站号："+kingDeeJzMessageDTO.getJzCode()+"\t原业务员："+jzMessagess.get(0).getJzCurUser()+"\t改为业务员："+kingDeeJzMessageDTO.getJzcurUser()+
        "\n原三级经理："+jzMessagess.get(0).getJzProjectOwner()+"\t改为三级经理："+kingDeeJzMessageDTO.getJzProjectOwner());
        return CyResultGenUtil.genSuccessResult("修改成功");
    }
}