package org.rcisoft.business.kingdee.service.impl;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import io.swagger.models.auth.In;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.lang3.StringUtils;
import org.omg.PortableInterceptor.INACTIVE;
import org.rcisoft.business.jzmessage.dao.JzMessageRepository;
import org.rcisoft.business.jzmessage.entity.JzMessage;
import org.rcisoft.business.kingdee.commom.K3CloundConfig;
import org.rcisoft.business.kingdee.control.KingdeeControl;
import org.rcisoft.business.kingdee.service.KingdeeMyselfService;
import org.rcisoft.business.kingdee.service.KingdeeService;
import org.rcisoft.business.kingdee.until.BaseUtil;
import org.rcisoft.business.kingdee.until.HttpUtil;
//import org.rcisoft.business.kingdee.until.KingdeeStatusMap;
import org.rcisoft.business.kingdee.until.PropertiesUtils;
import org.rcisoft.core.model.CyPersistModel;
import org.rcisoft.core.result.CyResult;
import org.rcisoft.core.service.CyBaseService;
import org.rcisoft.core.util.CyResultGenUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.core.io.ResourceLoader;
import org.springframework.stereotype.Service;

import java.io.IOException;
import java.io.InputStream;
import java.util.*;

/**
 * @Author: jiangpengpeng
 * @Description:
 * @Date: Created in 10:57  2019/9/12
 * @Modified By:
 */
@Service
@Slf4j
public class KingdeeMyselfServiceImpl extends CyBaseService implements KingdeeMyselfService {

    @Autowired
    K3CloundConfig k3CloundConfig;
    @Autowired
    KingdeeService kingdeeService;
    @Autowired
    JzMessageRepository jzMessageRepository;
    private static final String formid = "PAEZ_001";

    /**
     * @param
     * @return
     * @author: jiangpengpeng
     * @description: 保存测试
     * @date: 2019/9/12 11:03
     */
    public CyPersistModel Kingdee(String sessionId) {
        //查询项目编号已录入 并且不为空的数据前100条
        JzMessage jzMessage1 = new JzMessage();
        jzMessage1.setNormal();
        jzMessage1.setIsImport(0);
        jzMessage1.setProjectCodeImport(1);
        List<JzMessage> jzMessages = jzMessageRepository.queryJzMessageByIsImport(jzMessage1);
        if (jzMessages.size() > 100) {
            jzMessages = jzMessages.subList(0, 100);
        }
        if (CollectionUtils.isEmpty(jzMessages)) {
            log.debug("未检测到数jzMessages据");
            return new CyPersistModel(1, "未检测到保存数据");
        }
        for (JzMessage jzMessage : jzMessages) {
            if (KingDeeNum(jzMessage.getProjectCode(), sessionId) != null) {
                JSONArray jsonArray = JSONArray.parseArray(KingDeeNum(jzMessage.getProjectCode(), sessionId).toString());
                if(jsonArray.size()>0) {
                    for (int i = 0; i < jsonArray.size(); i++) {
                        JSONObject job = jsonArray.getJSONObject(i);  // 遍历 jsonarray 数组，把每一个对象转成 json 对象
                        jzMessage.setKingNumber(job.get("fbillno").toString());
                        jzMessage.setKingId(job.get("fid").toString());
                    }
                }
                jzMessage.setKingStatus("2");
                jzMessageRepository.updateByPrimaryKeySelective(jzMessage);
                this.dbInfo("项目编号为："+jzMessage.getProjectCode()+"的大台帐已存在执行修改");
            }
            if (StringUtils.isNotEmpty(jzMessage.getKingId()) && StringUtils.isNotEmpty(jzMessage.getKingNumber())) {
                if ("0".equals(jzMessage.getKingStatus()) || "1".equals(jzMessage.getKingStatus()) || "2".equals(jzMessage.getKingStatus())) {
                    //修改
                    CyResult cyResult = this.KingdeeSava(jzMessage, sessionId);
                    if ("true".equals(PropertiesUtils.getResultStaus(cyResult))) {
                        Map data = (Map) JSON.parse(cyResult.getData().toString());
                        this.dbInfo("执行修改接口成功 金蝶状态为" + jzMessage.getKingStatus() + "FId：" + jzMessage.getKingId() + "FNumber:" + jzMessage.getKingNumber() + "项目编号：" + jzMessage.getProjectCode());
                        if ("0".equals(jzMessage.getKingStatus()) || "1".equals(jzMessage.getKingStatus())) {
                            if ("0".equals(jzMessage.getKingStatus())) {
                                //提交
                                CyResult cyResult1 = this.KingdeeSubmit(data.get("Number").toString(), sessionId);
                                if ("true".equals(PropertiesUtils.getResultStaus(cyResult1))) {
                                    jzMessage.setKingStatus("1");
                                    this.dbInfo("执行提交接口成功 金蝶状态为" + jzMessage.getKingStatus() + "FId：" + jzMessage.getKingId() + "FNumber:" + jzMessage.getKingNumber() + "项目编号：" + jzMessage.getProjectCode());
                                } else {
                                    this.dbError("执行提交接口失败 金蝶状态为" + jzMessage.getKingStatus() + "FId：" + jzMessage.getKingId() + "FNumber:" + jzMessage.getKingNumber() + "项目编号：" + jzMessage.getProjectCode());
                                    continue;
                                }
                            }
                            //审核
                            CyResult cyResult2 = this.KingdeeAudit(data.get("Number").toString(), sessionId);
                            if ("true".equals(PropertiesUtils.getResultStaus(cyResult2))) {
                                jzMessage.setKingStatus("2");
                                jzMessage.setIsImport(1);
                                jzMessageRepository.updateByPrimaryKeySelective(jzMessage);
                                this.dbError("执行审核接口成功 金蝶状态为" + jzMessage.getKingStatus() + "FId：" + jzMessage.getKingId() + "FNumber:" + jzMessage.getKingNumber() + "项目编号：" + jzMessage.getProjectCode());
                                continue;
                            } else {
                                jzMessageRepository.updateByPrimaryKeySelective(jzMessage);
                                this.dbError("执行审核接口失败 金蝶状态为" + jzMessage.getKingStatus() + "FId：" + jzMessage.getKingId() + "FNumber:" + jzMessage.getKingNumber() + "项目编号：" + jzMessage.getProjectCode());
                                continue;
                            }
                        } else {
                            jzMessage.setIsImport(1);
                            jzMessageRepository.updateByPrimaryKeySelective(jzMessage);
                        }
                    } else {
                        this.dbError("执行修改接口失败 金蝶状态为" + jzMessage.getKingStatus() + "FId：" + jzMessage.getKingId() + "FNumber:" + jzMessage.getKingNumber() + "项目编号：" + jzMessage.getProjectCode());
                        continue;
                    }

                }
            } else {
                CyResult cyResult = this.KingdeeSava(jzMessage, sessionId);
                if ("true".equals(PropertiesUtils.getResultStaus(cyResult))) {
                    Map data = (Map) JSON.parse(cyResult.getData().toString());
                    jzMessage.setKingStatus("0");
                    jzMessage.setKingId(data.get("Id").toString());
                    jzMessage.setKingNumber(data.get("Number").toString());
                    this.dbInfo("执行保存接口成功 金蝶状态为" + jzMessage.getKingStatus() + "FId：" + jzMessage.getKingId() + "FNumber:" + jzMessage.getKingNumber() + "项目编号：" + jzMessage.getProjectCode());
                    //提交
                    CyResult cyResult1 = this.KingdeeSubmit(data.get("Number").toString(), sessionId);
                    if ("true".equals(PropertiesUtils.getResultStaus(cyResult1))) {
                        jzMessage.setKingStatus("1");
                        this.dbInfo("执行提交接口成功 金蝶状态为" + jzMessage.getKingStatus() + "FId：" + jzMessage.getKingId() + "FNumber:" + jzMessage.getKingNumber() + "项目编号：" + jzMessage.getProjectCode());
                        //审核
                        CyResult cyResult2 = this.KingdeeAudit(data.get("Number").toString(), sessionId);
                        if ("true".equals(PropertiesUtils.getResultStaus(cyResult2))) {
                            jzMessage.setKingStatus("2");
                            jzMessage.setIsImport(1);
                            jzMessageRepository.updateByPrimaryKeySelective(jzMessage);
                            this.dbInfo("执行审核接口成功 金蝶状态为" + jzMessage.getKingStatus() + "FId：" + jzMessage.getKingId() + "FNumber:" + jzMessage.getKingNumber() + "项目编号：" + jzMessage.getProjectCode());
                            continue;
                        } else {
                            jzMessageRepository.updateByPrimaryKeySelective(jzMessage);
                            this.dbError("执行审核接口失败 金蝶状态为" + jzMessage.getKingStatus() + "FId：" + jzMessage.getKingId() + "FNumber:" + jzMessage.getKingNumber() + "项目编号：" + jzMessage.getProjectCode());
                            continue;
                        }
                    } else {
                        jzMessageRepository.updateByPrimaryKeySelective(jzMessage);
                        this.dbError("执行提交接口失败 金蝶状态为" + jzMessage.getKingStatus() + "FId：" + jzMessage.getKingId() + "FNumber:" + jzMessage.getKingNumber() + "项目编号：" + jzMessage.getProjectCode());
                        continue;
                    }

                } else {
                    this.dbError("执行保存接口失败 金蝶状态为" + jzMessage.getKingStatus() + "FId：" + jzMessage.getKingId() + "FNumber:" + jzMessage.getKingNumber() + "项目编号：" + jzMessage.getProjectCode());
                    continue;
                }
            }
        }
        return new CyPersistModel(1);
    }


    //保存
    public CyResult KingdeeSava(JzMessage jzMessage, String sessionId) {
        String template = PropertiesUtils.readJsonFile("save.json");
        String paez_001 = BaseUtil.buildMaterial(template, jzMessage, formid);
        CyResult save = kingdeeService.save(k3CloundConfig.getUrl() + k3CloundConfig.getSave(), sessionId, paez_001);
        if (save.getCode() == 400) {
            log.debug("【保存出错】：{}", save);
            this.dbError("基站编号：" + jzMessage.getBusinessId() + "message:" + save.getMessage());
            return save;
        }
        log.debug("【保存成功】：{}", save);
        return save;
    }

    //提交
    public CyResult KingdeeSubmit(String num, String sessionId) {
        String paez_001 = BaseUtil.buildParam(formid, num, null);
        CyResult submit = kingdeeService.save(k3CloundConfig.getUrl() + k3CloundConfig.getSubmit(), sessionId, paez_001);
        if (submit.getCode() == 400) {
            log.debug("【提交出错】：{}", submit);
            this.dbError("message:" + submit.getMessage());
            return submit;
        }
        log.debug("【提交成功】：{}", submit);
        return submit;
    }

    //审核
    public CyResult KingdeeAudit(String num, String sessionId) {
        String paez_001 = BaseUtil.buildParam(formid, num, "true");
        CyResult Audit = kingdeeService.save(k3CloundConfig.getUrl() + k3CloundConfig.getAudit(), sessionId, paez_001);
        if (Audit.getCode() == 400) {
            log.debug("【审核出错】：{}", Audit);
            this.dbError("message:" + Audit.getMessage());
            return Audit;
        }
        log.debug("【审核成功】：{}", Audit);
        return Audit;
    }

    //获取台账单据编号
    public Object KingDeeNum(String projectCode, String sessionId) {
        Map paez_001 = BaseUtil.buileContract(projectCode, formid);
        CyResult num = kingdeeService.getNum("http://36.110.39.213:8989/Home/Index/getContractNumber", sessionId, paez_001);
        if (num.getCode() == 200) {
            Object data = num.getData();
            log.error("【项目已存在】：{}", num);
            return data;
        }
        return null;
    }

    //获取合同编号
    public CyResult KingDeeContractNum(String projectCode, String sessionId) {
        Map paez_001 = BaseUtil.buileContract(projectCode, formid);
        CyResult num = kingdeeService.getNum("http://36.110.39.213:8989/Home/Index/getContractNumber", sessionId, paez_001);
        if (num.getCode() == 200) {
            return num;
        }
        log.error("【获取合同编号出错】：{}", num);
        return num;
    }

    //获取出库单编号
    public CyResult KingDeeHouseNum(String projectCode, String sessionId) {
        Map paez_001 = BaseUtil.buileContract(projectCode, formid);
        CyResult num = kingdeeService.getNum("http://36.110.39.213:8989/Home/Index/getDocumentNumber", sessionId, paez_001);
        if (num.getCode() == 200) {
            return num;
        }
        log.error("【获取出库单编号出错】：{}", num);
        return num;
    }

    //获取合同信息
    public CyResult kingDeeContractMes(String contractCode, String sessionId) {
        String paez_001 = BaseUtil.buildParam(formid, contractCode, null);
        CyResult view = kingdeeService.view(k3CloundConfig.getUrl() + k3CloundConfig.getView(), sessionId, paez_001);
        if (view.getCode() == 400) {
            log.error("【审核出错】：{}", view);
            return view;
        }
        return view;
    }

    //获取物料信息
    public CyResult kingDeeHouseMes(String houseCode, String sessionId) {
        String paez_001 = BaseUtil.buildParam(formid, houseCode, null);
        CyResult view = kingdeeService.view(k3CloundConfig.getUrl() + k3CloundConfig.getView(), sessionId, paez_001);
        if (view.getCode() == 400) {
            log.error("【审核出错】：{}", view);
            return view;
        }
        return view;
    }
}
