package org.rcisoft.business.kingdee.service.impl;

/**
 * @Author: jiangpengpeng
 * @Description:
 * @Date: Created in 11:19  2019/9/11
 * @Modified By:
 */

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import lombok.extern.slf4j.Slf4j;
import org.apache.http.HttpEntity;
import org.apache.http.NameValuePair;
import org.apache.http.client.config.RequestConfig;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClientBuilder;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.util.EntityUtils;
import org.rcisoft.business.excelimport.tbexcelinfo.entity.TbExcelInfo;
import org.rcisoft.business.jzmessage.entity.JzMessage;
import org.rcisoft.business.kingdee.commom.K3CloundConfig;
import org.rcisoft.business.kingdee.commom.KingDee;
import org.rcisoft.business.kingdee.control.KingdeeControl;
import org.rcisoft.business.kingdee.service.KingdeeService;
import org.rcisoft.business.kingdee.until.BaseUtil;
import org.rcisoft.business.kingdee.until.HttpUtil;
import org.rcisoft.business.suser.entity.SDept;
import org.rcisoft.common.BaseStationStatus;
import org.rcisoft.core.model.CyPersistModel;
import org.rcisoft.core.result.CyResult;
import org.rcisoft.core.service.CyBaseService;
import org.rcisoft.core.util.CyResultGenUtil;
import org.rcisoft.core.util.CyUserUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.xml.crypto.dsig.keyinfo.KeyInfo;
import java.io.IOException;
import java.util.*;

/**
 * @Description: 金蝶物料接口实现类
 * @date 2019/1/4 14:24
 */
@Transactional
@Service
@Slf4j
public class KingdeeServiceImpl extends CyBaseService implements KingdeeService {


    @Override
    public CyResult login(String url, String content) {
        log.debug("------------------------enter----login------");
        log.debug("--------" + url + "---");
        log.debug("--------" + content + "---");
        ResponseEntity<String> responseEntity = HttpUtil.httpPost(url, content);
        log.debug("------------------------enter----login----end------");
        //获取登录cookie
        if (responseEntity.getStatusCode() == HttpStatus.OK) {
            String login_cookie = "";
            Set<String> keys = responseEntity.getHeaders().keySet();
            for (String key : keys) {
                if (key.equalsIgnoreCase("Set-Cookie")) {
                    List<String> cookies = responseEntity.getHeaders().get(key);
                    for (String cookie : cookies) {
                        if (cookie.startsWith("kdservice-sessionid")) {
                            login_cookie = cookie;
                            break;
                        }
                    }
                }
            }
            Map<String, Object> map = new HashMap<>();
            map.put("cookie", login_cookie);
            return CyResultGenUtil.genSuccessResult(map);
        }

        Map<String, Object> result = JSON.parseObject(responseEntity.getBody());
        this.dbError("登录失败" + result);
        return CyResultGenUtil.genFailResult(result.get("Message").toString());
    }


    @Override
    public CyResult view(String url, String cookie, String content) {
        Map<String, Object> header = new HashMap<>();
        header.put("Cookie", cookie);
        String result = HttpUtil.httpPost(url, header, content);
        JSONObject jsonObject = JSON.parseObject(result);
        Map<String, Object> map = (Map<String, Object>) jsonObject.get("Result");
        return CyResultGenUtil.genSuccessResult(JSON.toJSONString(map));

    }

    @Override
    public CyResult save(String url, String cookie, String content) {
        //保存
        Map<String, Object> header = new HashMap<>();
        header.put("Cookie", cookie);
        String result = HttpUtil.httpPost(url, header, content);
        JSONObject jsonObject = JSON.parseObject(result);
        Map<String, Object> map = (Map<String, Object>) jsonObject.get("Result");
        Map<String, Object> responseStatus = (Map<String, Object>) map.get("ResponseStatus");
        Boolean isSuccess = (Boolean) responseStatus.get("IsSuccess");
        if (isSuccess) {
            return CyResultGenUtil.genSuccessResult(JSON.toJSONString(map));
        } else {
            List<Map<String, Object>> errors = (List<Map<String, Object>>) responseStatus.get("Errors");
            return CyResultGenUtil.genFailResult(JSON.toJSONString(errors));
        }
    }

    //获取编号
    public CyResult getNum(String url, String cookie, Map content) {
        Map<String, Object> header = new HashMap<>();
        header.put("Cookie", cookie);
        String result = HttpUtil.httpGet(url, header, content);
        JSONObject jsonObject = JSON.parseObject(result);
        Map<String, Object> map = (Map<String, Object>) jsonObject;
        Object code = map.get("code");
        if ("200".equals(code)) {
            return CyResultGenUtil.genSuccessResult(JSON.toJSONString(map.get("data")));
        } else {
            return CyResultGenUtil.genFailResult(JSON.toJSONString(map));
        }
    }
}

