package org.rcisoft.business.kingdee.until;

import lombok.extern.slf4j.Slf4j;
import org.rcisoft.business.kingdee.commom.KingDee;
import org.rcisoft.common.BaseStationStatus;

import java.util.HashMap;
import java.util.Map;

@Slf4j
public class KingdeeStatusMap {
    //金蝶基站状态对应的map
    /**
     * @author: jiangpengpeng
     * @description: TODO
     * @date: 2019/9/19 10:39
     * @param jzType
     * @return
     */
    public static Map<String,Object> KingDeeStatus(String jzType){
        Map<String,Object> map = new HashMap<>();
        if ("0".equals(jzType)){
         log.debug("代缴站状态Map");
            //插入开通状态
            map.put(BaseStationStatus.DJ_HAVE_OPEN.getCode(),KingDee.KING_DEE_DJ_YKT.getCode());
              //拆站
            map.put(BaseStationStatus.BS_HAVE_STANDOWN.getCode(),KingDee.KING_DEE_DJ_CZ.getCode());

        }else if ("1".equals(jzType)){
            log.debug("移动状态");
           /* //选址
            map.put(BaseStationStatus.MC_WAIT_LOCATION.getCode(),KingDee.KIGNDEE_XZZ.getCode());
            //勘察
            map.put(BaseStationStatus.MC_WAIT_PROSPECT.getCode(),KingDee.KINGDEE_DKC.getCode());
            //过会
            map.put(BaseStationStatus.MC_WAIT_TRIAGE.getCode(),KingDee.KINGDEE_KC.getCode());*/
            //交底
            map.put(BaseStationStatus.MC_WAIT_DISCLOSURE.getCode(),KingDee.KING_DEE_FX_GH.getCode());
            //领料
            map.put(BaseStationStatus.MC_WAIT_PACKING.getCode(),KingDee.KING_DEE_FX_JD.getCode());
            //施工验收
            map.put(BaseStationStatus.MC_WAIT_EXECUTION.getCode(),KingDee.King_DEE_FX_LL.getCode());
            //开通
            map.put(BaseStationStatus.MC_WAIT_OPEN.getCode(),KingDee.KING_DEE_FX_SG.getCode());
            //交资
            map.put(BaseStationStatus.MC_WAIT_CAPITAL.getCode(),KingDee.KING_DEE_FX_KT.getCode());
            //交维
            map.put(BaseStationStatus.MC_WAIT_MAINTAIN.getCode(),KingDee.KING_DEE_FX_JZ.getCode());
            //已经交维
            map.put(BaseStationStatus.BS_HAVE_MAINTAIN.getCode(),KingDee.KING_DEE_FX_JW.getCode());
            //拆站
            map.put(BaseStationStatus.BS_HAVE_STANDOWN.getCode(),KingDee.KING_DEE_FX_CZ.getCode());
            //需求取消
            map.put(BaseStationStatus.BS_HAVE_CANCLE.getCode(),KingDee.KING_DEE_FX_XQ.getCode());
        }else if ("2".equals(jzType)){
            log.debug("铁塔状态");
       /*    //选址
            map.put(BaseStationStatus.IT_WAIT_LOCATION.getCode(),KingDee.KIGNDEE_XZZ.getCode());
            //勘察
            map.put(BaseStationStatus.IT_WAIT_PROSPECT.getCode(),KingDee.KINGDEE_DKC.getCode());
            //过会
            map.put(BaseStationStatus.IT_WAIT_TRIAGE.getCode(),KingDee.KINGDEE_KC.getCode());*/
            //立项
            map.put(BaseStationStatus.IT_WAIT_APPROVAL.getCode(),KingDee.KING_DEE_TT_GH.getCode());
            //领料
            map.put(BaseStationStatus.MC_WAIT_PACKING.getCode(),KingDee.KING_DEE_TT_LX.getCode());
            //施工
            map.put(BaseStationStatus.IT_WAIT_EXECUTION.getCode(),KingDee.KING_DEE_TT_LL.getCode());
            //完工
            map.put(BaseStationStatus.IT_WAIT_COMPLETION.getCode(),KingDee.KING_DEE_TT_SG.getCode());
            //交付
            map.put(BaseStationStatus.IT_WAIT_DELIVERY.getCode(),KingDee.KING_DEE_TT_WG.getCode());
            //起租
            map.put(BaseStationStatus.IT_WAIT_ONHIRE.getCode(),KingDee.KING_DEE_TT_JF.getCode());
            //交维
            map.put(BaseStationStatus.IT_WAIT_MAINTAIN.getCode(),KingDee.KING_DEE_TT_QZ.getCode());
            //已交维
            map.put(BaseStationStatus.BS_HAVE_MAINTAIN.getCode(),KingDee.KING_DEE_TT_JW.getCode());
            //拆站
            map.put(BaseStationStatus.BS_HAVE_STANDOWN.getCode(),KingDee.KING_DEE_TT_CZ.getCode());
            //需求取消
            map.put(BaseStationStatus.BS_HAVE_CANCLE.getCode(),KingDee.KING_DEE_TT_XQ.getCode());

        }else {
            log.debug("未知基站类型！！！！！！");
            return map;
        }

        return map;
    }
}
