package org.rcisoft.business.kingdee.until;

/**
 * @Author: jiangpengpeng
 * @Description:
 * @Date: Created in 11:00  2019/9/16
 * @Modified By:
 */

import com.alibaba.fastjson.JSON;
import org.rcisoft.core.result.CyResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.core.io.ClassPathResource;
import org.springframework.util.ResourceUtils;
import org.springframework.util.StringUtils;

import java.io.*;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Map;

/**
 * 配置文件工具类
 *
 * @author yule
 * @date 2018/9/28 16:26
 */
public class PropertiesUtils {

    private static final Logger logger = LoggerFactory.getLogger(PropertiesUtils.class);

    /**
     * 读取json文件，返回json字符串
     *
     * @param fileName
     * @return
     */
    public static String readJsonFile(String fileName) {
        FileReader fileReader = null;
        Reader reader = null;
        try {
            ClassPathResource classPathResource = new ClassPathResource(fileName);
           /*File jsonFile = ResourceUtils.getFile("classpath:" + fileName);
            fileReader = new FileReader(jsonFile);
            reader = new InputStreamReader(new FileInputStream(jsonFile), "utf-8");*/
            reader = new InputStreamReader(classPathResource.getInputStream(), "UTF-8");
            int ch;
            StringBuffer sb = new StringBuffer();
            while ((ch = reader.read()) != -1) {
                sb.append((char) ch);
            }
            reader.close();
            String jsonStr = sb.toString();
            return jsonStr;
        } catch (IOException e) {
            e.printStackTrace();
            logger.error("读取文件报错", e);
        } finally {
            if (reader != null) {
                try {
                    reader.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }
        return null;
    }

    /**
     * 时间格式转换
     *
     * @param date
     * @return
     */
    public static String kingDeeTime(Date date) {
        String timeFormat=null;
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        if (date == null) {
             timeFormat = sdf.format(new Date());
        }else {
             timeFormat = sdf.format(date);
        }
        return timeFormat;

    }

    /**
     * @param cyResult
     * @return
     * @author: jiangpengpeng
     * @description: 返回值状态
     * @date: 2019/9/18 14:31
     */
    public static String getResultStaus(CyResult cyResult) {
        if (cyResult.getCode()==400){
            return "false";
        }
        Map data = (Map) JSON.parse(cyResult.getData().toString());
        Map responseStatus = (Map) data.get("ResponseStatus");
        return responseStatus.get("IsSuccess").toString();
    }

    ;
}
