package org.rcisoft.business.processDesign.controller;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import io.swagger.annotations.ApiOperation;
import org.apache.poi.ss.formula.functions.T;
import org.rcisoft.business.jzmessage.entity.JzMessage;
import org.rcisoft.business.processDesign.entity.WorkflowTaskData;
import org.rcisoft.business.processDesign.entity.WorkflowTaskDateMes;
import org.rcisoft.business.processDesign.service.AllMesssageService;
import org.rcisoft.core.constant.CyMessCons;
import org.rcisoft.core.model.CyPersistModel;
import org.rcisoft.core.result.CyResult;
import org.rcisoft.core.util.CyResultGenUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;
import java.lang.reflect.Method;
import java.util.List;

/**
 * @Author: jiangpengpeng
 * @Description:
 * @Date: Created in 20:20  2019/8/5
 * @Modified By:
 */
@RestController
@RequestMapping("/message")
public class MessageControl {

    @Autowired
    private AllMesssageService allMesssageService;

    //获取当前的基站信息及模板信息
    @ApiOperation(value = "当前基站信息", notes = "当前基站信息")
    @GetMapping("/getMessageJZTem")
    public CyResult getMessageJZTem(@RequestParam("businessId") String jzMessageId) {
        return CyResultGenUtil.builder(new CyPersistModel(1),
                CyMessCons.MESSAGE_ALERT_SUCCESS,
                CyMessCons.MESSAGE_ALERT_ERROR,
                allMesssageService.getMessageJZTem(jzMessageId));
    }

    //获取当前的基站信息及模板信息
    @ApiOperation(value = "项目编号获取当前基站信息", notes = "项目编号获取当前基站信息")
    @GetMapping("/getMessageJZTemByProjectCode")
    public CyResult getMessageJZTemByProjectCode(@RequestParam("projectCode") String projectCode) {
        return CyResultGenUtil.builder(new CyPersistModel(1),
                CyMessCons.MESSAGE_ALERT_SUCCESS,
                CyMessCons.MESSAGE_ALERT_ERROR,
                allMesssageService.getMessageJZTemByProjectCode(projectCode));
    }
    //根据部门id查询当前部门负责人

    //获取历史的基站信息
    @ApiOperation(value = "历史基站信息", notes = "历史基站信息")
    @GetMapping("/getAllMessageHi")
    public CyResult getAllMessageHi(@RequestParam("businessId") String jzMessageId) {
        return CyResultGenUtil.builder(new CyPersistModel(1),
                CyMessCons.MESSAGE_ALERT_SUCCESS,
                CyMessCons.MESSAGE_ALERT_ERROR,
                allMesssageService.getMessageHi(jzMessageId));
    }

    //修改当前表单信息
    @ApiOperation(value = "管理员修改表单信息", notes = "管理员修改表单信息")
    @PostMapping("/updateMes")
    public CyResult updateMes(WorkflowTaskDateMes workflowTaskDateMes) {
        return CyResultGenUtil.builder(allMesssageService.updateMes(workflowTaskDateMes),
                CyMessCons.MESSAGE_ALERT_SUCCESS,
                CyMessCons.MESSAGE_ALERT_ERROR,
                workflowTaskDateMes);
    }

    //管理员修改当前基站信息
    @ApiOperation(value = "管理员修改基站信息", notes = "管理员修改基站信息")
    @PostMapping(value = "/updateJZMes")
    public CyResult updateMes(@RequestParam("JzMessage") String JzMessage) {
        JSONObject object = JSONObject.parseObject(JzMessage);
        org.rcisoft.business.jzmessage.entity.JzMessage jzMessage = JSONObject.toJavaObject(object, org.rcisoft.business.jzmessage.entity.JzMessage.class);
        return CyResultGenUtil.builder(allMesssageService.updateJZMes(jzMessage),
                CyMessCons.MESSAGE_ALERT_SUCCESS,
                CyMessCons.MESSAGE_ALERT_ERROR,
                jzMessage);
    }

   /*//业务员提交数据到xg_jz_message
    @PostMapping("/uplodeJzMes")
    public CyResult uplodeJzMes(@Valid JzMessage jzMessage){
        return CyResultGenUtil.builder(allMesssageService.uploadJzMes(jzMessage),
                CyMessCons.MESSAGE_ALERT_SUCCESS,
                CyMessCons.MESSAGE_ALERT_ERROR,
                jzMessage);

    }*/

  //修改基站信息待办信息返回
   @ApiOperation(value = "返回基站信息待办", notes = "返回基站信息待办")
    @GetMapping("alterMesByXgId")
    public CyResult alterMesByXgId(@RequestParam("xgId")String xgId,@RequestParam("taskId")String taskId ){
        return CyResultGenUtil.builder(new CyPersistModel(1),
                CyMessCons.MESSAGE_ALERT_SUCCESS,
                CyMessCons.MESSAGE_ALERT_ERROR,
                allMesssageService.alterMesByXgId(xgId,taskId));
    }
   /* //修改基站信息已办信息返回
    @GetMapping("alterMesByTaskId")
    public CyResult alterMesBytaskId(@RequestParam("xgId")String xgId,@RequestParam("taskId") String taskId){
        return CyResultGenUtil.builder(new CyPersistModel(1),
                CyMessCons.MESSAGE_ALERT_SUCCESS,
                CyMessCons.MESSAGE_ALERT_ERROR,
                allMesssageService.alterMesBytaskId(xgId,taskId));
    }*/

}
