package org.rcisoft.business.processDesign.controller;

import io.swagger.annotations.ApiOperation;
import org.rcisoft.business.processDesign.service.ProcessService;
import org.rcisoft.core.constant.CyMessCons;
import org.rcisoft.core.model.CyPersistModel;
import org.rcisoft.core.result.CyResult;
import org.rcisoft.core.util.CyResultGenUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

/**
 * @Author: jiangpengpeng
 * @Description:
 * @Date: Created in 6:54  2019/7/29
 * @Modified By:
 */
@RestController
@RequestMapping("/process")
public class ProcessControl {
    @Autowired
    ProcessService processService;

    //启动流程是通过typeTemplate匹配模板
    @ApiOperation(value = "启动流程匹配模板", notes = "启动流程匹配模板")
    @GetMapping("/start")
    public CyResult startProcess(@RequestParam("templateId") String typeTemplate) {
        return CyResultGenUtil.builder(new CyPersistModel(1),
                CyMessCons.MESSAGE_ALERT_SUCCESS,
                CyMessCons.MESSAGE_ALERT_ERROR,
                processService.startProcess(typeTemplate)
        );
    }
    //拆站启动流程匹配模板
    @ApiOperation(value = "拆站启动流程模板", notes = "拆站启动流程模板")
    @GetMapping("/czStart")
    public CyResult startProces(@RequestParam("jzMessageId") String jzMessageId){
      return CyResultGenUtil.builder(new CyPersistModel(1),
              CyMessCons.MESSAGE_ALERT_SUCCESS,
              CyMessCons.MESSAGE_ALERT_ERROR,
              processService.czStartProcess(jzMessageId));
    };
}
