package org.rcisoft.business.processDesign.controller;

import io.swagger.annotations.ApiOperation;
import org.activiti.controller.CyWfController;
import org.rcisoft.business.processDesign.dto.WorkTemplateResDTO;
import org.rcisoft.business.processDesign.entity.WorkflowTaskDateMes;
import org.rcisoft.business.processDesign.service.TaskService;
import org.rcisoft.core.constant.CyMessCons;
import org.rcisoft.core.model.CyPersistModel;
import org.rcisoft.core.result.CyResult;
import org.rcisoft.core.util.CyResultGenUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
 * @Author: jiangpengpeng
 * @Description:
 * @Date: Created in 17:36  2019/7/28
 * @Modified By:
 */
@RestController
@RequestMapping("/task")
public class TaskControl {
    @Autowired
    private TaskService taskService;
    //任务id显示模板
    @ApiOperation(value = "查看待办任务", notes = "查看待办任务")
    @GetMapping("/complateTask")
    public CyResult complateTask(String taskId) {
        return CyResultGenUtil.builder(new CyPersistModel(1),
                CyMessCons.MESSAGE_ALERT_SUCCESS,
                CyMessCons.MESSAGE_ALERT_ERROR,
                taskService.complateByTaskId(taskId));
    }
    //查看历史任务模板数据
    @ApiOperation(value = "查看已办任务", notes = "查看已办任务")
    @GetMapping("/taskedByTaskId")
    public CyResult taskedByTaskId(String taskId) {
        return CyResultGenUtil.builder(new CyPersistModel(1),
                CyMessCons.MESSAGE_ALERT_SUCCESS,
                CyMessCons.MESSAGE_ALERT_ERROR,
                taskService.taskedByTaskId(taskId));
    }
    //完成任务时向data表 data_hi date_mes表中插入数据
    @ApiOperation(value = "完成任务插入数据", notes = "完成任务插入数据")
    @PostMapping("/insertDataMesByTaskId")
    public CyResult insertDataMesByTaskId(@RequestBody WorkflowTaskDateMes workflowTaskDateMes){

   return CyResultGenUtil.builder(taskService.insertDataMesByTaskId(workflowTaskDateMes),
           CyMessCons.MESSAGE_ALERT_SUCCESS,
           CyMessCons.MESSAGE_ALERT_ERROR,
           workflowTaskDateMes);
    };
}
