package org.rcisoft.business.processDesign.dao;

import org.apache.ibatis.annotations.*;
import org.rcisoft.business.jzmessage.entity.JzMessage;
import org.rcisoft.business.processDesign.entity.ProcessMid;
import org.rcisoft.core.base.CyBaseMapper;
import org.rcisoft.core.model.CyPersistModel;
import org.springframework.stereotype.Repository;


import java.util.List;

/**
 * Created with cy on 2019-7-26 16:12:11.
 */
@Repository
public interface ProcessMidRepository extends CyBaseMapper<ProcessMid> {

    /* */

    /**
     * 分页查询 processMid
     *//*
    @Select("<script>select * from process_mid where 1=1 "
            + "</script>")
    @ResultMap(value = "BaseResultMap" )
    List<ProcessMid> queryProcessMids(ProcessMid processMid);*/
    @Insert("<script>insert into process_mid  " +
            "values(#{businessId},#{processid},#{version},#{jzMessageId},#{templateid},#{typeTemplate},#{typeProcess})" +
            "</script>")
    int insertProcessMid(ProcessMid processMid);

    @Select("<script> select Max(version) from process_mid where jz_message_id=#{jzMessageId} " +
            "        and type_process = #{typeProcess}</script>")
    String processMidByprocessMid(ProcessMid processMid);


    @Select("<script>SELECT p.template_id from process_mid AS p LEFT JOIN ACT_HI_TASKINST AS A ON p.process_id = A.PROC_INST_ID_ WHERE A.ID_=#{taskId} </script>")
    String templateIdBytaskId(String taskId);

    /**
     * 查询当前状态的流程是否已经创建实例
     */
    @Select("<script> select * from process_mid pm , " +
            " ACT_RU_EXECUTION are  " +
            " where pm.jz_message_id = are.business_key_ and pm.process_id =  are.PROC_INST_ID_ " +
            " and pm.jz_message_id = #{businessId} " +
            "<if test=\"typeTemplate !=null and typeTemplate !='' \"> and  pm.type_template = #{typeTemplate} </if>" +
            "</script>")
    @ResultMap("BaseResultMap")
    List<ProcessMid> queryCurProExist(JzMessage jzMessage);

    @Select("SELECT " +
            "* " +
            "FROM " +
            "process_mid " +
            "WHERE " +
            "process_mid.jz_message_id = #{jzMessageId} and type_process = #{typeProcess} " +
            "AND process_mid.version IN ( " +
            "SELECT " +
            "MAX(version) " +
            "FROM " +
            "process_mid " +
            "WHERE " +
            "process_mid.jz_message_id = #{jzMessageId} " +
            "GROUP BY " +
            "process_mid.type_process " +
            ")")
    @ResultMap("BaseResultMap")
    List<ProcessMid> getTemplateByjzMessageId(ProcessMid processMid);

    /**
     * 查询正在运行流程
     */
    @Select("<script> select * from process_mid pm " +
            " left join ACT_RU_EXECUTION are on pm.process_id = are.proc_inst_id_" +
            " where are.business_key_ is not null and pm.jz_message_id = #{businessId}" +
            "</script>")
    @ResultMap("BaseResultMap")
    List<ProcessMid> quryRunningProcess(JzMessage jzMessage);

    /*
     * 根据流程Id查询基站Id
     *
     * */
    @Select("<script>SELECT jz_message_id " +
            "from process_mid " +
            "where process_id = #{processId}</script>")
    List<String> jzIdByPorId(@Param("processId") String processId);

    /*
     *根局基站id判断修改流程是否结束
     */
    @Select("<script>SELECT " +
            " * " +
            "FROM " +
            " process_mid pm " +
            "LEFT JOIN ACT_HI_PROCINST ahp ON ahp.PROC_INST_ID_ = pm.process_id " +
            "WHERE " +
            " ahp.END_TIME_ IS NULL " +
            "AND pm.type_template IN ('S01', 'S06') " +
            "AND pm.jz_message_id = #{jzMessageId}</script>")
    @ResultMap("BaseResultMap")
    List<ProcessMid> selectByJzMessageId(@Param("jzMessageId") String jzMessageId);

}

