package org.rcisoft.business.processDesign.dao;

import org.apache.ibatis.annotations.*;
import org.rcisoft.business.processDesign.entity.ProcessMid;
import org.rcisoft.business.processDesign.entity.WorkflowTaskData;
import org.rcisoft.business.processDesign.entity.WorkflowTaskDataHi;
import org.rcisoft.core.base.CyBaseMapper;
import org.rcisoft.core.model.CyPersistModel;
import org.springframework.stereotype.Repository;


import java.util.List;

/**
 * Created with cy on 2019-7-25 9:18:25.
 */
@Repository
public interface WorkflowTaskDataRepository extends CyBaseMapper<WorkflowTaskData> {

    /**
     * 分页查询 workflowTaskData
     */
    @Select("<script>select * from workflow_task_data where 1=1 "
            + "</script>")
    @ResultMap(value = "BaseResultMap")
    List<WorkflowTaskData> queryWorkflowTaskDatas(WorkflowTaskData workflowTaskData);

    @Select("<script>select * from workflow_task_data where field_id in " +
            "<foreach item=\"item\" index=\"index\" collection=\"list\"\n" +
            " open=\"(\" separator=\",\" close=\")\">" +
            "#{item} </foreach>" +
            "</script>")
    @ResultMap(value = "BaseResultMap")
    List<WorkflowTaskData> dataBytaskId(List<String> list);

    @Select("<script>SELECT " +
            "workflow_task_data.*,process_mid.version AS version," +
            "process_mid.type_process AS typeProcess," +
            "process_mid.type_template AS typeTemplate," +
            "workflow_template_form_field_hi.field_tp AS fieldTp," +
            "workflow_template_form_field_hi.required AS required," +
            "workflow_template_form_field_hi.field_nm AS fieldNm," +
            "workflow_template_form_field_hi.required AS required," +
            "workflow_template_form_field_hi.field_hint AS fieldHind," +
            "workflow_template_form_field_hi.field_order AS fieldOrder," +
            "workflow_template_form_field_hi.expand AS fieldExpand," +
            "workflow_task_date_mes.region_str AS regionStr " +
            "FROM " +
            "workflow_task_data " +
            "LEFT JOIN process_mid ON process_mid.process_id = workflow_task_data.process_id " +
           /* "LEFT JOIN ACT_HI_ACTINST ON ACT_HI_ACTINST.PROC_INST_ID_ = process_mid.process_id " +*/
            "LEFT JOIN ACT_HI_PROCINST ON ACT_HI_PROCINST.PROC_INST_ID_ = process_mid.process_id " +
            "LEFT JOIN workflow_task_date_mes ON process_mid.process_id = workflow_task_date_mes.process_id " +
            "LEFT JOIN workflow_template_form_field_hi ON workflow_task_data.field_id = workflow_template_form_field_hi.id " +
            "WHERE " +
            "process_mid.process_id IN ( " +
            "SELECT " +
            "PROC_INST_ID_ " +
            "FROM " +
            "ACT_HI_PROCINST " +
            "WHERE PROC_INST_ID_ IN (" +
                // 2019-8-20 cy 修改
                "SELECT t.process_id from (" +
                    "SELECT " +
                    "process_mid.process_id, " +
                    "max(version) " +
                    "FROM  process_mid " +
                    " WHERE process_mid.jz_message_id = #{jzMessageId} " +
                    "GROUP BY process_mid.type_template" +
                "  )as t " +
            ") AND ACT_HI_PROCINST.END_TIME_ IS NOT NULL" +
            ") " +
            "order by workflow_task_date_mes.create_time desc," +
            "workflow_template_form_field_hi.field_order asc" +
            "</script>")
    @ResultMap("BaseResultMap")
    List<WorkflowTaskData> getTaskDateBytemplateId(@Param("jzMessageId") String jzMessageId);

    @Select("<script>SELECT " +
            "workflow_task_data.*,process_mid.version AS version," +
            "process_mid.type_process AS typeProcess," +
            "process_mid.type_template AS typeTemplate," +
            "workflow_template_form_field_hi.field_tp AS fieldTp," +
            "workflow_template_form_field_hi.field_nm AS fieldNm," +
            "workflow_template_form_field_hi.required AS required," +
            "workflow_template_form_field_hi.field_hint AS fieldHind," +
            "workflow_template_form_field_hi.field_order AS fieldOrder," +
            "workflow_template_form_field_hi.expand AS fieldExpand," +
            "workflow_task_date_mes.region_str AS regionStr " +
            "FROM " +
            "workflow_task_data " +
            "LEFT JOIN process_mid ON process_mid.process_id = workflow_task_data.process_id " +
            /* "LEFT JOIN ACT_HI_ACTINST ON ACT_HI_ACTINST.PROC_INST_IDrequired_ = process_mid.process_id " +*/
            "LEFT JOIN ACT_HI_PROCINST ON ACT_HI_PROCINST.PROC_INST_ID_ = process_mid.process_id " +
            "LEFT JOIN workflow_task_date_mes ON process_mid.process_id = workflow_task_date_mes.process_id " +
            "LEFT JOIN workflow_template_form_field_hi ON workflow_task_data.field_id = workflow_template_form_field_hi.id " +
            "WHERE " +
            "process_mid.process_id IN ( " +
            "SELECT " +
            "PROC_INST_ID_ " +
            "FROM " +
            "ACT_HI_PROCINST " +
            "WHERE PROC_INST_ID_ IN (" +
            // 2019-8-20 cy 修改
            "SELECT t.process_id from (" +
            "SELECT " +
            "process_mid.process_id, " +
            "max(version) " +
            "FROM  process_mid " +
            " WHERE process_mid.jz_message_id = #{jzMessageId} " +
            "GROUP BY process_mid.type_process" +
            "  )as t " +
            ") AND ACT_HI_PROCINST.END_TIME_ IS NOT NULL" +
            ") " +
            "order by workflow_task_date_mes.create_time desc," +
            "workflow_template_form_field_hi.field_order asc" +
            "</script>")
    @ResultMap("BaseResultMap")
    List<WorkflowTaskData> getTaskDateByjzMessageId(@Param("jzMessageId") String jzMessageId, @Param("processIds")List<ProcessMid> processMids);


    @Select("<script>select * from workflow_task_data where field_id = " +
            "#{fieldId} and process_id = #{processId}" +
            "</script>")
    @ResultMap(value = "BaseResultMap")
    WorkflowTaskData queryWorkTaskDataByProcessIdAndFieldId(WorkflowTaskDataHi work);

    @Update("<script>" +
            " <foreach collection =\"workflowTaskDatas\" item=\"item\"  separator=\";\" >" +
            " update workflow_task_data set  " +
            " field_value = #{item.fieldValue}, " +
            " is_first = #{item.isFirst} " +
            " WHERE field_id = #{item.fieldId} " +
            " AND process_id = #{item.processId} " +
            "</foreach></script>")
    int updateMes(@Param("workflowTaskDatas") List<WorkflowTaskData> workflowTaskData);

    /**
     * 插入list
     * @param data
     */
    @Insert("<script> insert into workflow_task_data (id, " +
            "field_id, " +
            "field_value, " +
            "process_id ) values " +
            "<foreach collection =\"data\" item=\"item\"  separator=\",\" >" +
            "(#{item.id}, " +
            "#{item.fieldId}, " +
            "#{item.fieldValue}, " +
            "#{item.processId})</foreach>" +
            "</script>")
    void insertList(@Param("data") List<WorkflowTaskData> data);

    /**
     * 修改list
     * @param data
     */
    @Update("<script>" +
            "<foreach collection=\"data\" item=\"item\"  separator=\";\">" +
            "update " +
            "workflow_task_data " +
            "set field_value = #{item.fieldValue} " +
            "where 1=1 " +
            "AND process_id = #{item.processId} " +
            "AND field_id = #{item.fieldId}" +
            "</foreach>" +
            "</script>")
    void updateListByProcessIdFileId(@Param("data") List<WorkflowTaskData> data);

}

