package org.rcisoft.business.processDesign.dao;

import org.apache.ibatis.annotations.Param;
import org.rcisoft.business.processDesign.entity.WorkflowTaskDateMes;
import org.rcisoft.core.base.CyBaseMapper;
import org.apache.ibatis.annotations.ResultMap;
import org.apache.ibatis.annotations.Select;
import org.springframework.stereotype.Repository;


import java.util.List;
import java.util.Map;

/**
 * Created with cy on 2019-7-29 14:10:55.
 */
@Repository
public interface WorkflowTaskDateMesRepository extends CyBaseMapper<WorkflowTaskDateMes> {

    /**
     * 分页查询 workflowTaskDateMes
     */
    @Select("<script>select * from workflow_task_date_mes where 1=1 "
            + "</script>")
    @ResultMap(value = "BaseResultMap")
    List<WorkflowTaskDateMes> queryWorkflowTaskDateMess(WorkflowTaskDateMes workflowTaskDateMes);

    @Select("<script>select * from workflow_task_date_mes wtm left join ACT_RU_TASK art on art.proc_inst_id_ = wtm.process_id  where art.id_ = #{taskId} order by create_time desc</script> ")
    List<WorkflowTaskDateMes> idByTaskId(String taskId);

    @Select("<script>SELECT " +
            "mes.*," +
            "hi.id As Did, su.NAME AS name," +
            "hi.field_value AS hifieldValue," +
            "fhi.id AS fhiFieldId," +
            "fhi.field_hint AS fhiFieldHint," +
            "fhi.field_nm AS fhiFieldNm," +
            "fhi.field_order AS fhiFieldOrder," +
            "fhi.field_tp AS fhiFieldTp," +
            "fhi.expand AS fhiExpand," +
            "pm.type_process AS pmTypeProcess," +
            "pm.version AS pmVersion, " +
            "pm.type_template AS typeTemplate " +
            "FROM " +
            "workflow_task_date_mes mes " +
            "LEFT JOIN workflow_task_data_hi hi ON mes.id = hi.task_data_mes_id " +
            "LEFT JOIN workflow_template_form_field_hi fhi ON hi.field_id = fhi.id " +
            "LEFT JOIN process_mid pm on pm.process_id = mes.process_id " +
            "LEFT JOIN ACT_HI_PROCINST act ON mes.process_id  = act.PROC_INST_ID_ " +
            "LEFT JOIN s_user su ON su.BUSINESS_ID = mes.create_person " +
            "where  pm.jz_message_id = #{jzId} " +
            "order by  mes.create_time DESC ,pm.type_process desc , pm.version desc , fhi.field_order asc </script>")
    @ResultMap("BaseResultMap")
    List<WorkflowTaskDateMes> getMessDataHiByJZMesId(@Param("jzId") String jzId);

    @Select("<script> select * from workflow_task_date_mes " +
            "where process_id = #{processId} " +
            "ORDER BY create_time desc LIMIT 0,1 " +
            "</script>")
    @ResultMap("BaseResultMap")
    WorkflowTaskDateMes getMessDataHiByProcessId(String processId);

    @Select("<script>SELECT workflow_task_date_mes.*,s_user.NAME AS name  " +
            "FROM workflow_task_date_mes  " +
            "LEFT JOIN process_mid ON workflow_task_date_mes.process_id = process_mid.process_id  " +
            "LEFT JOIN s_user ON s_user.BUSINESS_ID = workflow_task_date_mes.create_person " +
            "WHERE process_mid.process_id = (SELECT PROC_INST_ID_ FROM ACT_HI_ACTINST WHERE ACT_HI_ACTINST.TASK_ID_ = #{taskId}) " +
            "ORDER BY workflow_task_date_mes.create_time DESC</script>")
    @ResultMap("BaseResultMap")
    List<WorkflowTaskDateMes> getRegionStrBytaskId(@Param("taskId") String taskId);

    @Select("<script>SELECT workflow_task_date_mes.*,workflow_template_form_field_hi.expand AS fhiexpand,workflow_template_form_field_hi.field_nm AS fhiFieldNm,workflow_task_data_hi.field_value AS hifieldValue,workflow_task_data_hi.field_id AS fhiFieldId,workflow_template_form_field_hi.field_tp AS fhiFieldTp " +
            "FROM workflow_task_date_mes LEFT JOIN workflow_task_data_hi ON workflow_task_data_hi.task_data_mes_id = workflow_task_date_mes.id  " +
            "LEFT JOIN workflow_template_form_field_hi ON workflow_template_form_field_hi.id = workflow_task_data_hi.field_id " +
            "WHERE workflow_task_date_mes.process_id = (SELECT ACT_HI_ACTINST.PROC_INST_ID_ FROM ACT_HI_ACTINST WHERE ACT_HI_ACTINST.TASK_ID_ = #{taskId}) " +
            /*taskid 条件未加  2019-8-20*/
            " and  workflow_task_date_mes.task_id = #{taskId}" +
            "ORDER BY workflow_task_date_mes.create_time DESC , workflow_template_form_field_hi.field_order asc</script>")
    @ResultMap("BaseResultMap")
       List<WorkflowTaskDateMes> workflowTaskDateMess(@Param("taskId") String taskId);
}

