package org.rcisoft.business.processDesign.dao;

import org.apache.ibatis.annotations.Param;
import org.rcisoft.business.processDesign.entity.WorkflowTemplateFormFieldHi;
import org.rcisoft.business.processDesign.entity.WorkflowTemplateHi;
import org.rcisoft.core.base.CyBaseMapper;
import org.apache.ibatis.annotations.ResultMap;
import org.apache.ibatis.annotations.Select;
import org.springframework.stereotype.Repository;


import java.util.List;
import java.util.Map;

/**
 * Created with cy on 2019-7-26 16:12:11.
 */
@Repository
public interface WorkflowTemplateFormFieldHiRepository extends CyBaseMapper<WorkflowTemplateFormFieldHi> {

    /**
     * 分页查询 workflowTemplateFormFieldHi
     */
    @Select("<script>select * from workflow_template_form_field_hi where 1=1 "
            + "</script>")
    @ResultMap(value = "BaseResultMap")
    List<WorkflowTemplateFormFieldHi> queryWorkflowTemplateFormFieldHis(WorkflowTemplateFormFieldHi workflowTemplateFormFieldHi);

    @Select("<script>select * from workflow_template_form_field_hi where template_id=#{template}</script>")
    @ResultMap(value = "BaseResultMap")
    List<WorkflowTemplateFormFieldHi> fieldHiBytemplate(String template);

    @Select("<script>select * from workflow_template_form_field_hi where template_id=#{id}</script>")
    @ResultMap(value = "BaseResultMap")
    List<WorkflowTemplateFormFieldHi> allFieldHiBytemplateHi(WorkflowTemplateHi workflowTemplateHi);

    @Select("<script>SELECT " +
            "workflow_template_form_field_hi.*, workflow_template_permission_hi.if_write AS ifWrite, " +
            "workflow_template_permission_hi.permission AS permission " +
            "FROM " +
            "workflow_template_form_field_hi " +
            "LEFT JOIN workflow_template_permission_hi ON workflow_template_form_field_hi.id = workflow_template_permission_hi.field_id " +
            "WHERE " +
            "workflow_template_permission_hi.activity_id = ( " +
            "SELECT " +
            "workflow_template_process_file.start_usertask " +
            "FROM " +
            "workflow_template_process_file " +
            "WHERE " +
            "workflow_template_process_file.template_id = ( " +
            "SELECT " +
            "workflow_template.id " +
            "FROM " +
            "workflow_template " +
            "WHERE " +
            "workflow_template.type_template = #{typeTemplate} " +
            ") " +
            ") " +
            "AND workflow_template_form_field_hi.template_id = ( " +
            "SELECT " +
            "id " +
            "FROM " +
            "workflow_template_hi " +
            "WHERE " +
            "workflow_template_hi.type_template = #{typeTemplate} " +
            "AND workflow_template_hi.version = ( " +
            "SELECT " +
            "Max(cast(version as UNSIGNED INTEGER)) " +
            "FROM " +
            "workflow_template_hi " +
            "WHERE " +
            "type_template = #{typeTemplate} " +
            ") " +
            ") order by workflow_template_form_field_hi.field_order asc</script>")
    @ResultMap(value = "BaseResultMap")
    List<WorkflowTemplateFormFieldHi> getFieldMes(@Param("typeTemplate") String typeTemplate);

    @Select("<script>SELECT " +
            "workflow_template_form_field_hi.*," +
            "workflow_task_data.field_value AS fieldValue, " +
            "workflow_template_permission_hi.permission AS permission, " +
            "workflow_template_permission_hi.if_write AS ifWrite " +
            "FROM " +
            "workflow_template_form_field_hi " +
            "LEFT JOIN workflow_template_permission_hi " +
            "ON workflow_template_form_field_hi.id = workflow_template_permission_hi.field_id " +
            "LEFT JOIN workflow_task_data " +
            "ON workflow_template_form_field_hi.id=workflow_task_data.field_id " +
            "WHERE " +
            "workflow_template_form_field_hi.template_id = workflow_template_permission_hi.template_id " +
            " AND workflow_task_data.process_id = ( " +
            "SELECT " +
            "ACT_HI_ACTINST.PROC_INST_ID_ " +
            "FROM " +
            "ACT_HI_ACTINST " +
            "WHERE " +
            "ACT_HI_ACTINST.TASK_ID_ =  #{taskId} " +
            ")" +
            "AND workflow_template_permission_hi.template_id = ( " +
            "SELECT " +
            "process_mid.template_id " +
            "FROM " +
            "process_mid " +
            "WHERE " +
            "process_mid.process_id = ( " +
            "SELECT " +
            "ACT_HI_ACTINST.PROC_INST_ID_ " +
            "FROM " +
            "ACT_HI_ACTINST " +
            "WHERE " +
            "ACT_HI_ACTINST.TASK_ID_ = #{taskId} " +
            ") " +
            ") " +
            "AND workflow_template_permission_hi.activity_id = ( " +
            "SELECT " +
            "ACT_HI_ACTINST.ACT_ID_ " +
            "FROM " +
            "ACT_HI_ACTINST " +
            "WHERE " +
            "ACT_HI_ACTINST.TASK_ID_ = #{taskId} " +
            ") order by workflow_template_form_field_hi.field_order asc</script>")
    @ResultMap(value = "BaseResultMap")
    List<WorkflowTemplateFormFieldHi> getFieldMesByTaskId(@Param("taskId") String taskId);

    @Select("<script>SELECT " +
            " h.*," +
            "dh.field_value AS fieldValue," +
            " dm.json_str AS jsonStr, " +
            " dm.process_id AS processId " +
            "FROM " +
            "workflow_template_form_field_hi h " +
            "LEFT JOIN workflow_task_data_hi dh ON h.id = dh.field_id " +
            "LEFT JOIN workflow_task_date_mes dm on dh.task_data_mes_id = dm.id " +
            "where dm.task_id = #{taskId} </script>")
    @ResultMap(value = "BaseResultMap")
   List<WorkflowTemplateFormFieldHi> getMesByTaskId(@Param("taskId") String taskId);


    /*查询当前任务id对应的流程Id*/
    @Select("<script>SELECT PROC_INST_ID_ from ACT_HI_TASKINST WHERE ID_ = #{taskId}</script>")
    List<String> getProcessIdsByTaskId(@Param("taskId") String taskId);
}

