package org.rcisoft.business.processDesign.dao;

import org.apache.ibatis.annotations.ResultMap;
import org.apache.ibatis.annotations.Select;
import org.rcisoft.business.processDesign.entity.WorkflowTemplate;
import org.rcisoft.business.processDesign.entity.WorkflowTemplateHi;
import org.rcisoft.core.base.CyBaseMapper;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * Created with cy on 2019-7-25 9:18:25.
 */
@Repository
public interface WorkflowTemplateHiRepository extends CyBaseMapper<WorkflowTemplateHi> {

    /**
     * 分页查询 workflowTemplate
     */
    @Select("<script>select * from workflow_template_hi where 1=1 " +
            "<if test=\"phone != null and phone != '' \">and phone=#{phone}</if>" +
            "<if test=\"ifEnable != null and ifEnable != '' \">and if_enable=#{ifEnable}</if>" +
            "and version=(select MAX(version) from workflow_template_hi)"
            + "</script>")
    @ResultMap(value = "BaseResultMap")
    List<WorkflowTemplateHi> queryWorkflowTemplates(WorkflowTemplateHi workflowTemplateHi);


    @Select("<script>select * from workflow_template_hi where type_template=#{typeTemplate} and version = (select MAX(version) from workflow_template_hi where type_template=#{typeTemplate})</script>")
    @ResultMap(value = "BaseResultMap")
    WorkflowTemplateHi startProcess(String typeTemplate);

    //根据模板id查询模板
   /* @Select("<script>select * from workflow_template_hi where id = #{id}</script>")
    @ResultMap(value = "BaseResultMap")
    WorkflowTemplateHi templateHiByTemplateId(WorkflowTemplateHi workflowTemplateHi);*/


}

