package org.rcisoft.business.processDesign.dao;

import org.apache.ibatis.annotations.Insert;
import org.rcisoft.business.processDesign.entity.WorkflowTemplate;
import org.rcisoft.business.processDesign.entity.WorkflowTemplateHi;
import org.rcisoft.core.base.CyBaseMapper;
import org.apache.ibatis.annotations.ResultMap;
import org.apache.ibatis.annotations.Select;
import org.springframework.stereotype.Repository;


import java.util.List;

/**
 * Created with cy on 2019-7-25 9:18:25.
 */
@Repository
public interface WorkflowTemplateRepository extends CyBaseMapper<WorkflowTemplate> {

    /**
     * 分页查询 workflowTemplate
     */
    @Select("<script>select * from workflow_template where 1=1 " +
            "<if test=\"phone != null and phone != '' \">and phone=#{phone}</if>" +
            "<if test=\"ifEnable != null and ifEnable != '' \">and if_enable=#{ifEnable}</if>"
            + "</script>")
    @ResultMap(value = "BaseResultMap")
    List<WorkflowTemplate> queryWorkflowTemplates(WorkflowTemplate workflowTemplate);

    WorkflowTemplate selectByTaskId(String taskId);

    WorkflowTemplate selectBytypetemplate(String typeTemplate);

    //从历史模板表拿出的数据放入操作表
    @Insert("<script>insert into workflow_template values (#{id},#{templateNm},#{typeTemplate},#{workTpId},#{phone},#{createRoles}," +
            "#{manager_roles},#{templateExplain},#{ifEnable},#{iconImage},#{create_time},now())</script>")
    int insertTemplateHi(WorkflowTemplateHi workflowTemplateHi);
}

