package org.rcisoft.business.processDesign.entity;

import lombok.*;

import org.rcisoft.core.entity.CyIdNotDataEntity;
import javax.persistence.*;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.io.Serializable;
import java.util.Date;
import java.util.List;

/**
* Created with cy on 2019-7-26 16:12:11.
*/
@Entity
@Data
@NoArgsConstructor
@AllArgsConstructor
@Table(name = "workflow_task")
public class WorkflowTask  extends CyIdNotDataEntity<WorkflowTask> {


     /**
     * @desc 工单主键
     * @column work_id
     * @default 
     */
     private String workId;
     /**
     * @desc 工单号
     * @column work_no
     * @default 
     */
     private String workNo;
     /**
      * @desc 状态（0：已修改 1 已发布）
      * @column work_no
      * @default
      */
     private String status;
     /**
     * @desc 工单模板主键
     * @column template_id
     * @default 
     */
     private String templateId;
     /**
     * @desc 工单主题
     * @column work_subject
     * @default 
     */
     private String workSubject;
     /**
     * @desc 工单描述内容
     * @column work_content
     * @default 
     */
     private String workContent;
     /**
     * @desc 优先级
     * @column priority
     * @default 
     */
     private String priority;
     /**
     * @desc 时效
     * @column aging
     * @default 
     */
     private Integer aging;
     /**
     * @desc 创建时间
     * @column create_time
     * @default 
     */
     private Date createTime;
     /**
     * @desc 更新时间
     * @column update_time
     * @default 
     */
     private Date updateTime;
     /**
     * @desc 
     * @column cutoff_time
     * @default 
     */
     private Date cutoffTime;
     /**
     * @desc 工单进度
     * @column schedule
     * @default 
     */
     private String schedule;
     /**
     * @desc 工单状态（0：草稿 1：执行中 2：审批中 3：已完成 4：中止）
     * @column work_status
     * @default 
     */
     private String workStatus;
     /**
     * @desc 
     * @column create_person
     * @default 
     */
     private String createPerson;
     /**
     * @desc 
     * @column apply_dept
     * @default 
     */
     private String applyDept;
     /**
     * @desc 是否发送消息
     * @column if_send
     * @default 
     */
     private String ifSend;
     /*
     * @desc 类型
     * @column work_type_id
     * */
     private String workTypeId;
     @Transient
     private String workTypeName;

}

