package org.rcisoft.business.processDesign.service.impl;

import org.rcisoft.business.processDesign.dao.ProcessMidRepository;
import org.rcisoft.business.processDesign.dao.WorkflowTemplateHiRepository;
import org.rcisoft.business.processDesign.entity.ProcessMid;
import org.rcisoft.business.processDesign.entity.WorkflowTemplateHi;
import org.rcisoft.business.processDesign.service.ProcessMidService;
import org.rcisoft.core.util.CyIdGenUtil;
import org.rcisoft.core.model.CyPersistModel;
import org.rcisoft.core.service.CyBaseService;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Isolation;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;


import lombok.extern.slf4j.Slf4j;

/**
 * Created by cy on 2019-7-26 16:12:11.
 */
@Service
@Transactional(readOnly = true,propagation = Propagation.NOT_SUPPORTED)
@Slf4j
public class ProcessMidServiceImpl extends CyBaseService  implements ProcessMidService {

    @Autowired
    private ProcessMidRepository processMidRepository;
    @Autowired
    private WorkflowTemplateHiRepository workflowTemplateHiRepository;


    /**
     * 保存
     *
     * @param processMid
     * @return
     */
    @Transactional(propagation = Propagation.REQUIRED, isolation = Isolation.DEFAULT)
    @Override
    public CyPersistModel save(ProcessMid processMid) {
        int i = processMidRepository.insertProcessMid(processMid);
        return new CyPersistModel(i);
    }
}