
package org.rcisoft.business.processDesign.service.impl;

import lombok.extern.slf4j.Slf4j;
import org.activiti.engine.TaskService;
import org.activiti.engine.task.Task;
import org.activiti.model.CyPIAndTaskModel;
import org.activiti.service.impl.CyWfServiceImpl;
import org.rcisoft.business.jzmessage.common.StartProcessHelper;
import org.rcisoft.business.jzmessage.common.TypeEnum;
import org.rcisoft.business.jzmessage.dao.JzMessageRepository;
import org.rcisoft.business.jzmessage.entity.JzMessage;
import org.rcisoft.business.processDesign.dao.*;
import org.rcisoft.business.processDesign.entity.*;
import org.rcisoft.business.processDesign.service.ProcessService;
import org.rcisoft.common.BaseStationStatus;
import org.rcisoft.common.ProcessMapBpmn;
import org.rcisoft.common.StateTypeTemplateMD;
import org.rcisoft.common.StateTypeTemplateTT;
import org.rcisoft.core.model.CyPersistModel;
import org.rcisoft.core.util.CyIdGenUtil;
import org.rcisoft.core.util.CyUserUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;

import static org.rcisoft.business.jzmessage.common.StartProcessHelper.APPROVALPENDING;


/**
 * @Author: jiangpengpeng
 * @Description:
 * @Date: Created in 13:36  2019/7/29
 * @Modified By:
 */
@Slf4j
@Service

public class ProcessServiceImpl implements ProcessService {
    @Autowired
    WorkflowTemplateHiRepository workflowTemplateHiRepository;
    @Autowired
    WorkflowTemplateFormFieldHiRepository workflowTemplateFormFieldHiRepository;
    @Autowired
    WorkflowTemplatePermissionHiRepository workflowTemplatePermissionHiRepository;
    @Autowired
    WorkflowTemplateApproveHiRepository workflowTemplateApproveHiRepository;
    @Autowired
    JzMessageRepository jzMessageRepository;
    @Autowired
    StartProcessHelper helper;
    @Autowired
    CyWfServiceImpl cyWfServiceImpl;
    @Autowired
    TaskService taskService;
    @Autowired
    ProcessMidRepository processMidRepository;
    @Autowired
    WorkflowTaskDateMesRepository workflowTaskDateMesRepository;
    @Autowired
    WorkflowTaskDataHiRepository workflowTaskDataHiRepository;
    @Autowired
    WorkflowTaskDataRepository workflowTaskDataRepository;
    private static final String value = null;
    private static final String message = "通过";
    private static final List<String> taskIdS = new ArrayList<>();

    //开始流程返回页面信息
    @Transactional
    @Override
    public List<WorkflowTemplateFormFieldHi> startProcess(String typeTemplate) {
        List<WorkflowTemplateFormFieldHi> getFieldMes = workflowTemplateFormFieldHiRepository.getFieldMes(typeTemplate);
        return getFieldMes;
    }

    //拆站流程返回信息交维前或交维后
    @Transactional
    @Override
    public List<WorkflowTemplateFormFieldHi> czStartProcess(String jzMessageId) {
        JzMessage jzMessage = jzMessageRepository.jzmessageByBusinessId(jzMessageId);
        if (jzMessage.getJzType().equals(TypeEnum.DJ.getkey())) {
            return startProcess(ProcessMapBpmn.BS_MAINTANCE_DOWN.getTypeTemplate());
        } else if (jzMessage.getJzType().equals(TypeEnum.TT.getkey())) {
            if (Integer.parseInt(jzMessage.getJzState()) > Integer.parseInt(BaseStationStatus.IT_WAIT_MAINTAIN.getCode())) {
                return startProcess(ProcessMapBpmn.BS_MAINTANCE_DOWN.getTypeTemplate());
            }
        } else if (jzMessage.getJzType().equals(TypeEnum.YD.getkey())) {
            if (Integer.parseInt(jzMessage.getJzState()) > Integer.parseInt(BaseStationStatus.MC_WAIT_MAINTAIN.getCode())) {
                return startProcess(ProcessMapBpmn.BS_MAINTANCE_DOWN.getTypeTemplate());
            }
        }
        return startProcess(ProcessMapBpmn.BS_STAND_DOWN.getTypeTemplate());
    }

    /**
     * 金蝶自动走流程
     *//*
    public void runProcess(JzMessage jzMessage) {
        //判断如果基站是移动执行移动流程
        if (jzMessage.getJzType().equals(TypeEnum.YD.getkey())) {
            //遍历移动流程
            StateTypeTemplateMD[] MDvalues = StateTypeTemplateMD.values();
            for (int i = 0; i < MDvalues.length; i++) {
                //根据流程状态判断当前属于哪个流程
                if (jzMessage.getJzState().equals(MDvalues[i]) && !jzMessage.getJzState().equals(StateTypeTemplateMD.MC_WAIT_MAINTAIN.getState())) {
                    //如果存在当前状态执行流程接口
                    this.processRun(jzMessage, MDvalues[i].getKey(), MDvalues[i].getTemplate(), MDvalues[i].getState());
                    //设置流程状态为下一节点状态
                    jzMessage.setJzState(MDvalues[i + 1].getState());
                } else {
                    log.debug("移动该状态不能执行流程");
                    //设置流程进行标志位为 1
                    jzMessage.setIsCanRunProcess("1");
                    jzMessageRepository.updateByPrimaryKeySelective(jzMessage);
                    return;
                }

            }
        } else if (jzMessage.getJzType().equals(TypeEnum.TT.getkey())) {
            //遍历铁塔
            StateTypeTemplateTT[] TTvalues = StateTypeTemplateTT.values();
            for (int i = 0; i < TTvalues.length; i++) {
                //根据流程状态判断当前属于哪个流程
                if (jzMessage.getJzState().equals(TTvalues[i]) && !jzMessage.getJzState().equals(StateTypeTemplateMD.MC_WAIT_MAINTAIN.getState())) {
                    //如果存在当前状态执行流程接口
                    this.processRun(jzMessage, TTvalues[i].getKey(), TTvalues[i].getTemplate(), TTvalues[i].getState());
                    //设置流程状态为下一节点状态
                    jzMessage.setJzState(TTvalues[i + 1].getState());
                } else {
                    log.debug("铁塔该状态不能执行流程");
                    //设置流程进行标志位为 1
                    jzMessage.setIsCanRunProcess("1");
                    jzMessageRepository.updateByPrimaryKeySelective(jzMessage);
                    return;
                }

            }
        }

    }
*/
   /* *//**
     * 重复完成任务
     *//*

    public List<String> complateTasks(String processInstanceId, HashMap variables, HashMap variablesLocal) {
        //完成任务
        Task task = taskService.createTaskQuery().processInstanceId(processInstanceId).singleResult();
        taskIdS.add(task.getId());
        //如果当前流程不存在正在执行的任务结束方法
        if (task == null) {
            return taskIdS;
        }
        cyWfServiceImpl.completeTask(task.getId(), variables, variablesLocal);
        return complateTasks(processInstanceId, variables, variablesLocal);
    }
*/
  /*  ;

    *//**
     * 实现流程接口
     *//*
    @Transactional
    public void processRun(JzMessage jzMessage, String businessKey, String templateType, String state) {
        //通过基站类型获取模板
        List<WorkflowTemplateFormFieldHi> workflowTemplateFormFieldHis = this.startProcess(templateType);
        //设置流程变量
        jzMessage.setTransition(message);
        //设置类型
        jzMessage.setTypeTemplate(templateType);
        JzMessage jzMessage1 = helper.setVariables(jzMessage);
        //设置状态为待审批
        jzMessage1.setJzProState(APPROVALPENDING);
        //修改状态为待审批
        jzMessageRepository.updateJzMessage(jzMessage1);
        CyPIAndTaskModel cyPIAndTaskModel = cyWfServiceImpl.startProcessByKey(businessKey, jzMessage1.getBusinessId(), jzMessage1.getVariables(), true, jzMessage.getVariablesLocal());
        //重复完成任务
        List<String> tasks = this.complateTasks(cyPIAndTaskModel.getProcessInstance().getId(), jzMessage1.getVariables(), jzMessage1.getVariablesLocal());
        //插入到中间表
        ProcessMid processMid = new ProcessMid();
        processMid.setTypeProcess(state);
        processMid.setTemplateid(workflowTemplateFormFieldHis.get(0).getTemplateId());
        processMid.setBusinessId(CyIdGenUtil.uuid());
        processMid.setProcessid(cyPIAndTaskModel.getProcessInstance().getId());
        processMid.setJzMessageId(jzMessage.getBusinessId());
        processMid.setVersion("1");
        processMid.setTypeTemplate(templateType);
        processMidRepository.insertSelective(processMid);
        //插入mes表
        List<WorkflowTaskDateMes>  WorkflowTaskDateMess = new ArrayList<>();
        WorkflowTaskDateMes workflowTaskDateMes = new WorkflowTaskDateMes();
        workflowTaskDateMes.setTransition("通过");
        workflowTaskDateMes.setCreateTime(new Date());
        workflowTaskDateMes.setRemarks(value);
        workflowTaskDateMes.setCreatePerson(value);
        workflowTaskDateMes.setRegionStr(value);
        workflowTaskDateMes.setJsonStr(value);
        workflowTaskDateMes.setProcessId(cyPIAndTaskModel.getProcessInstance().getId());
        for (String task :tasks){
            workflowTaskDateMes.setTaskId(task);
            workflowTaskDateMes.setId(CyIdGenUtil.uuid());
            WorkflowTaskDateMess.add(workflowTaskDateMes);
            workflowTaskDateMesRepository.insertSelective(workflowTaskDateMes);
        }

        //插入到data_hi
       List<WorkflowTaskDataHi> WorkflowTaskDataHis=new ArrayList<>();
        //遍历mes数据获取mes表businessid
        for (WorkflowTaskDateMes workflowTaskDateMes1 : WorkflowTaskDateMess) {
            WorkflowTaskDataHi workflowTaskDataHi = new WorkflowTaskDataHi();
            workflowTaskDataHi.setId(CyIdGenUtil.uuid());
            workflowTaskDataHi.setTaskDataMesId(workflowTaskDateMes1.getId());
            for (WorkflowTemplateFormFieldHi workflowTemplateFormFieldHi:workflowTemplateFormFieldHis){
                workflowTaskDataHi.setFieldId(workflowTemplateFormFieldHi.getId());
                workflowTaskDataHi.setFieldValue(value);
                WorkflowTaskDataHis.add(workflowTaskDataHi);
            }

        }
        if (WorkflowTaskDataHis.size()>0){
            workflowTaskDataHiRepository.insertList(WorkflowTaskDataHis);
        }

        //插入到data
        List<WorkflowTaskData> workflowTaskDatas = new ArrayList<>();
       for (WorkflowTemplateFormFieldHi workflowTemplateFormFieldHi:workflowTemplateFormFieldHis){
           WorkflowTaskData workflowTaskData = new WorkflowTaskData();
           workflowTaskData.setId(CyIdGenUtil.uuid());
           workflowTaskData.setFieldId(workflowTemplateFormFieldHi.getId());
           workflowTaskData.setIsFirst("0");
           workflowTaskData.setFieldValue(value);
           workflowTaskData.setProcessId(cyPIAndTaskModel.getProcessInstance().getId());
           workflowTaskDatas.add(workflowTaskData);
       }
       if (workflowTaskDatas.size()>0){
           workflowTaskDataRepository.insertList(workflowTaskDatas);
       }

    }*/

}

