package org.rcisoft.business.querytask.controller;

import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.rcisoft.business.querytask.entity.CompletedTask;
import org.rcisoft.business.querytask.service.impl.QueryTasksServiceImpl;
import org.rcisoft.core.model.CyGridModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import org.rcisoft.core.controller.CyPaginationController;


@Controller
@RequestMapping("/querycompleted")
@Slf4j
public class QueryCompletedTaskController extends CyPaginationController<CompletedTask>{

    @Autowired
    QueryTasksServiceImpl queryTasksServiceImpl;

    @ApiOperation(value="分页查询已办任务", notes="分页查询已办任务")
    @GetMapping("/tasks")
    @ResponseBody
    public CyGridModel completedTasksByPagination(CompletedTask completedTask) {
        queryTasksServiceImpl. findCompletedTasksByPagination(getPaginationUtility(),completedTask);
        return getGridModelResponse();
    }
}
