package org.rcisoft.business.querytask.controller;

import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.lang3.StringUtils;
import org.rcisoft.business.jzmessage.util.FindSon;
import org.rcisoft.business.querytask.entity.ToDoTask;
import org.rcisoft.business.querytask.service.QueryTasksService;
import org.rcisoft.business.querytask.service.impl.QueryTasksServiceImpl;
import org.rcisoft.business.sdictionary.entity.SDictionary;
import org.rcisoft.business.sdictionary.service.SDictionaryService;
import org.rcisoft.business.sdictionary.service.impl.SDictionaryServiceImpl;
import org.rcisoft.core.model.CyGridModel;
import org.rcisoft.core.util.CyUserUtil;
import org.rcisoft.sys.dept.entity.SysDept;
import org.rcisoft.sys.dept.service.SysDeptService;
import org.rcisoft.sys.dept.service.impl.SysDeptServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import org.rcisoft.core.controller.CyPaginationController;

import java.util.ArrayList;
import java.util.List;


@Controller
@RequestMapping("/querytodo")
@Slf4j
public class QueryTaskController extends CyPaginationController<ToDoTask>{

    @Autowired
    QueryTasksService queryTasksServiceImpl;
    @Autowired
    SysDeptService sysDeptServiceImpl;
    @Autowired
    SDictionaryService sDictionaryServiceImpl;

    @ApiOperation(value="分页查询待办任务", notes="分页查询待办任务")
    @GetMapping("/tasks")
    @ResponseBody
    public CyGridModel toDoTasksByPagination(ToDoTask toDoTask) {
        SysDept sysDept = new SysDept();
        sysDept.setNormal();
        /**
         * 由于分页的原因这段不能写在services里
         */
        String deptCode = CyUserUtil.getAuthenDeptCode();//获取当前部门编号
        List<String> deptIds = new ArrayList<>();//存放要查询部门的businessId
        List<SysDept> sysDepts = sysDeptServiceImpl.findAll(sysDept);//查询所有部门信息
        String id = null; //当前部门id
        String parentsId = null; //当前父节点id
        //这个循环用来获得当前部门的上级部门id和自己的id
        for(SysDept item : sysDepts){ //遍历部门列表
            if(item.getCode().equals(deptCode)){//查询当前部门信息
                parentsId = item.getParentId();//上级部门id
                id = item.getBusinessId();//当前部门id
                break;
            }
        }
        if (SDictionaryServiceImpl.whb.containsValue(deptCode)){//如果是维护部
            //属于广厦有限股份公司的维护部
            String companyId = FindSon.FindCompany(id,id,sysDepts);
            if (SDictionaryServiceImpl.deptForGswl.containsValue(companyId)){
                for (String s : SDictionaryServiceImpl.deptForGswl.keySet()) {
                    deptIds.addAll(FindSon.FindSons(SDictionaryServiceImpl.deptForGswl.get(s), sysDepts));
                    deptIds.add(SDictionaryServiceImpl.deptForGswl.get(s));
                }
            }else{
                deptIds = FindSon.FindSons(companyId,sysDepts);
                //放入当前部门
                deptIds.add(companyId);
            }
        }else if (SDictionaryServiceImpl.hgb.containsValue(deptCode)){//如果是合规部
            //放入同级部门下所有部门
            deptIds = FindSon.FindSons(parentsId,sysDepts);
        }else{
            //放入当前部门
            deptIds.add(id);
            //放入当前部门子部门
            deptIds.addAll(FindSon.FindSons(id,sysDepts));
        }
        queryTasksServiceImpl. findTodoTasksByPagination(getPaginationUtility(),toDoTask,deptIds);
        return getGridModelResponse();
    }
}
