package org.rcisoft.business.querytask.dao;
import org.apache.ibatis.annotations.ResultMap;
import org.apache.ibatis.annotations.Select;
import org.rcisoft.business.querytask.entity.CompletedTask;
import org.rcisoft.core.base.CyBaseMapper;
import org.springframework.stereotype.Repository;

import java.util.List;


@Repository
public interface QueryCompletedTaskRepository extends CyBaseMapper<CompletedTask> {

    /**
     * 分页查询已办任务
     */
    @Select("<script>SELECT " +
            " m.jz_code AS jz_code, " +//基站号
            " m.jz_name AS jz_name, " +//基站名
            " m.jz_project_id AS projectId," +
            " m.business_line AS jz_line, " +//业务线
            " sdi2.name as ywxName," + //业务线名称
            " sdi.name AS jz_qy, " +//区域
            " m.jz_type AS jz_type, " +//基站类型
            " sd.name AS jz_dept, " +//基站所属部门
            " pm.type_process AS jz_state, " +//基站状态
            " m.create_date AS jz_creat_date, " +//基站创建时间

            " aht.id_ AS task_id, " +//任务id
            " m.business_id AS jz_business_key,  " +//基站 businessidId
            " aht.assignee_ AS assignee," +//人
            " aht.name_ AS task_name, " +//任务名
            " pm.type_template AS type_template," +//jz_state
            " sdi3.name as yysDjName," +
            " sdi4.name as yysYdName," +
            " sdi5.name as yysTtName," +
            " sdi6.name as upperYdName," +
            " sdi7.name as upperTtName" +
            " FROM " +
            " jz_message m " +

            " LEFT JOIN s_dept sd ON m.jz_cur_dept = sd.business_id " +//连表查询部门名称，区域名称，运营商名称
            " LEFT JOIN s_dictionary sdi ON m.jz_qy = sdi.value AND sdi.type = 'JZ_QY' " +
            " left join s_dictionary sdi2 on m.business_line = sdi2.`value` and sdi2.type = 'JZ_YWX'" +
            " left join s_dictionary sdi3 on m.jz_yys = sdi3.`value` and sdi3.type = 'JZ_DJ_YYS'  " +
            " left join s_dictionary sdi4 on m.jz_yys = sdi4.`value` and sdi4.type = 'JZ_YD_YYS'  " +
            " left join s_dictionary sdi5 on m.jz_yys = sdi5.`value` and sdi5.type = 'JZ_TT_YYS'  " +
            " left join s_dictionary sdi6 on m.jz_up_custom = sdi6.`value` and sdi6.type = 'JZ_YD_UPPER' " +
            " left join s_dictionary sdi7 on m.jz_up_custom = sdi7.`value` and sdi7.type = 'JZ_TT_UPPER' " +

            " LEFT JOIN `ACT_HI_PROCINST` ahp ON m.business_id = ahp.business_key_ " +//jz_mess
            " LEFT JOIN process_mid pm ON pm.process_id = ahp.id_ " +
            " LEFT JOIN `ACT_HI_TASKINST` aht ON aht.proc_inst_id_ = ahp.id_ AND aht.assignee_ =#{assignee} " +//任务处理人

            " WHERE aht.end_time_ IS NOT NULL AND m.flag = 1 AND m.del_flag = 0   " +//

            "<if test = \"jzYys !=null and jzYys != '' and sDicYysType.toString() eq 'JZ_DJ_YYS'.toString() \"> and sdi3.value = #{jzYys} </if>" +
            "<if test = \"jzYys !=null and jzYys != '' and sDicYysType.toString() eq 'JZ_YD_YYS'.toString() \"> and sdi4.value = #{jzYys} </if>" +
            "<if test = \"jzYys !=null and jzYys != '' and  sDicYysType.toString() eq 'JZ_TT_YYS'.toString() \"> and sdi5.value = #{jzYys} </if>" +
            "<if test = \"jzUpCustom !=null and jzUpCustom != '' and  sDicUpperType.toString() eq 'JZ_YD_UPPER'.toString() \"> and sdi6.value = #{jzUpCustom} </if>" +
            "<if test = \"jzUpCustom !=null and jzUpCustom != '' and  sDicUpperType.toString() eq 'JZ_TT_UPPER'.toString() \"> and sdi7.value = #{jzUpCustom} </if>" +
            "<if test = \"jzQy !=null and jzQy != ''\"> and m.jz_qy = #{jzQy} </if>" +//条件查询
            "<if test=\"jzName !=null and jzName != '' \">and m.jz_name like concat('%',#{jzName},'%') </if> "+
            "<if test=\"jzCode !=null and jzCode != '' \">and m.jz_code like concat('%',#{jzCode},'%') </if> "+
            "<if test=\"projectCode !=null and projectCode != '' \">and m.project_code like concat('%',#{projectCode},'%') </if> "+
            "<if test=\"businessLine !=null and businessLine != '' \">and m.business_line = #{businessLine} </if> "+
            "<if test=\"jzState !=null and jzState != '' \">and jz_state = #{jzState} </if> "+
            "<if test=\"jzType !=null and jzType != '' \">and jz_type = #{jzType} </if> "+

            "</script>")
    @ResultMap(value = "BaseResultMap")
    List<CompletedTask> queryCompletedTaskLists(CompletedTask completedTask);
}
