package org.rcisoft.business.querytask.dao;


import org.apache.ibatis.annotations.ResultMap;
import org.apache.ibatis.annotations.Select;
import org.rcisoft.business.querytask.entity.ToDoTask;
import org.rcisoft.core.base.CyBaseMapper;
import org.springframework.stereotype.Repository;

import java.util.List;


@Repository
public interface QueryTasksRepository extends CyBaseMapper<ToDoTask> {

    /**
     * 分页查询待办任务
     */
   /* @Select("<script>select * from v_todotasklist where " +
            "assignee = #{assignee} or candidate = #{assignee} " +
            "order by jz_create_date desc" +
            "</script>")
    @ResultMap(value = "BaseResultMap")
    List<ToDoTask> queryToDoTaskLists(ToDoTask toDoTask);
*/
    @Select("<script>SELECT " +
            "    m.jz_code AS jz_code," +
            "    m.jz_name AS jz_name," +
            "    m.jz_project_id AS projectId," +
            "    m.business_line AS jz_line," +
            "    sdi.name AS jz_qy," +
            "    sdi2.name as ywxName," +
            "    m.jz_type AS jz_type," +
            "    sd.name AS jz_dept," +
            "    pm.type_process AS jz_state," +
            "    m.jz_pro_state AS jz_pro_state," +
            "    m.create_date AS jz_create_date," +
            "    v.task_id AS task_id," +
            "    v.businessKey AS jz_business_key," +
            "    v.assignee AS assignee," +
            "    v.candidate AS candidate," +
            "    v.act_name AS task_name," +
            "    pm.type_template AS type_template," +
            "   sdi3.name as yysDjName," +
            "   sdi4.name as yysYdName," +
            "   sdi5.name as yysTtName," +
            "   sdi6.name as upperYdName," +
            "   sdi7.name as upperTtName" +
            "  FROM" +
            "    jz_message m " +
            "  LEFT JOIN v_act_waittasklist v " +
            "      ON m.BUSINESS_ID = v.businessKey AND (v.assignee = #{assignee} OR v.candidate IN " +//
            "      <foreach collection=\"roleList\" item=\"item\" open =\"(\" separator=\",\" close=\")\"> " +
            "      #{item} " +
            "      </foreach> " +
            ")" +

            " left join s_dictionary sdi2 on m.business_line = sdi2.`value` and sdi2.type = 'JZ_YWX'" +

            "    LEFT JOIN s_dept sd " +
            "      ON m.jz_cur_dept = sd.business_id " +
            "    LEFT JOIN s_dictionary sdi " +
            "      ON m.jz_qy = sdi.value " +
            "      AND sdi.type = 'JZ_QY' " +
            " left join s_dictionary sdi3 on m.jz_yys = sdi3.`value` and sdi3.type = 'JZ_DJ_YYS'  " +
            " left join s_dictionary sdi4 on m.jz_yys = sdi4.`value` and sdi4.type = 'JZ_YD_YYS'  " +
            " left join s_dictionary sdi5 on m.jz_yys = sdi5.`value` and sdi5.type = 'JZ_TT_YYS'  " +
            " left join s_dictionary sdi6 on m.jz_up_custom = sdi6.`value` and sdi6.type = 'JZ_YD_UPPER' " +
            " left join s_dictionary sdi7 on m.jz_up_custom = sdi7.`value` and sdi7.type = 'JZ_TT_UPPER' " +

           "    LEFT JOIN process_mid pm " +
            "      ON pm.process_id = v.proc_inst_id " +
            "  WHERE v.businessKey is not null " +
            " and m.jz_cur_dept in " +
            " <foreach collection =\"deptIdList\" item=\"item\" open=\"(\" separator=\",\" close =\")\">  #{item} </foreach> " +
            "<if test = \"jzYys !=null and jzYys != '' and sDicYysType.toString() eq 'JZ_DJ_YYS'.toString() \"> and sdi3.value = #{jzYys} </if>" +
            "<if test = \"jzYys !=null and jzYys != '' and sDicYysType.toString() eq 'JZ_YD_YYS'.toString() \"> and sdi4.value = #{jzYys} </if>" +
            "<if test = \"jzYys !=null and jzYys != '' and  sDicYysType.toString() eq 'JZ_TT_YYS'.toString() \"> and sdi5.value = #{jzYys} </if>" +
            "<if test = \"jzUpCustom !=null and jzUpCustom != '' and  sDicUpperType.toString() eq 'JZ_YD_UPPER'.toString() \"> and sdi6.value = #{jzUpCustom} </if>" +
            "<if test = \"jzUpCustom !=null and jzUpCustom != '' and  sDicUpperType.toString() eq 'JZ_TT_UPPER'.toString() \"> and sdi7.value = #{jzUpCustom} </if>" +

            "<if test = \"jzQy !=null and jzQy != ''\"> and m.jz_qy = #{jzQy} </if>" +
            "<if test=\"jzName !=null and jzName != '' \">and m.jz_name like concat('%',#{jzName},'%') </if> "+
            "<if test=\"jzCode !=null and jzCode != '' \">and m.jz_code like concat('%',#{jzCode},'%') </if> "+
            "<if test=\"projectCode !=null and projectCode != '' \">and m.project_code like concat('%',#{projectCode},'%') </if> "+
            "<if test=\"businessLine !=null and businessLine != '' \">and m.business_line = #{businessLine} </if> "+
            "<if test=\"jzState !=null and jzState != '' \">and jz_state = #{jzState} </if> "+
            "<if test=\"jzType !=null and jzType != '' \">and jz_type = #{jzType} </if> "+
            "</script>")
    @ResultMap(value = "BaseResultMap")
    List<ToDoTask> queryToDoTaskLists(ToDoTask toDoTask);

}
