package org.rcisoft.business.sdictionary.service;

import org.rcisoft.business.sdictionary.entity.SDictionary;
import org.rcisoft.core.model.CyPersistModel;
import org.rcisoft.core.aop.CyPageUtil;

import java.util.List;

/**
 * Created by lpy on 2019-7-30 12:51:26.
 */
public interface SDictionaryService {

    /**
    * 保存 数据字典
    * @param sDictionary
    * @return
    */
    CyPersistModel save(SDictionary sDictionary);

    /**
    * 删除 数据字典
    * @param sDictionary
    * @return
    */
    CyPersistModel remove(SDictionary sDictionary);
    /**
    * 逻辑删除 数据字典
    * @param sDictionary
    * @return
    */
    CyPersistModel removeLogical(SDictionary sDictionary);
    /**
    * 修改 数据字典
    * @param sDictionary
    * @return
    */
    CyPersistModel merge(SDictionary sDictionary);

    /**
    * 根据id查询 数据字典
    * @param id
    * @return
    */
    SDictionary findById(String id);

    /**
    * 分页查询 数据字典
    * @param sDictionary
    * @return
    */
    List<SDictionary> findAllByPagination(CyPageUtil<SDictionary> paginationUtility,
                                          SDictionary sDictionary);


    /**
    * 查询list 数据字典
    * @param sDictionary
    * @return
    */
    List<SDictionary> findAll(SDictionary sDictionary);

    /**
     * 查询白名单
     */
    void whiteList();

    /**
     * 导出Excel模板用的
     * @param sDictionary
     * @return
     */
    List<SDictionary> selectDjYsByType(SDictionary sDictionary);
    List<SDictionary> selectTtYsByType(SDictionary sDictionary);
    List<SDictionary> selectYdYsByType(SDictionary sDictionary);
    List<SDictionary> selectQYByType(SDictionary sDictionary);
    List<SDictionary> selectYWXByType(SDictionary sDictionary);
    List<SDictionary> selectYdUpperByType(SDictionary sDictionary);
    List<SDictionary> selectTtUpperByType(SDictionary sDictionary);
    List<SDictionary> selectBuildByType(SDictionary sDictionary);

    /**
     *查询是否属于合规部
     */
    List<SDictionary> selectHGBByCode(SDictionary sDictionary);

    /**
     *查询是否属于维护部
     */
    List<SDictionary> selectWHBByCode(SDictionary sDictionary);


}
