package org.rcisoft.business.sdictionary.service.impl;

import org.rcisoft.business.jzmessage.common.DictionaryMap;
import org.rcisoft.core.util.CyUserUtil;
import org.rcisoft.core.aop.CyPageUtil;
import org.rcisoft.core.model.CyPersistModel;
import org.rcisoft.business.sdictionary.dao.SDictionaryRepository;
import org.rcisoft.business.sdictionary.entity.SDictionary;
import org.rcisoft.business.sdictionary.service.SDictionaryService;
import org.rcisoft.core.service.CyBaseService;

import org.rcisoft.sys.dictionary.service.DictionaryService;
import org.rcisoft.sys.dictionary.service.impl.DictionaryServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Isolation;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;


import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import lombok.extern.slf4j.Slf4j;

/**
 * Created by lpy on 2019-7-30 12:51:26.
 */
@Service
@Transactional(readOnly = true,propagation = Propagation.NOT_SUPPORTED)
@Slf4j
public class SDictionaryServiceImpl extends CyBaseService  implements SDictionaryService {

    @Autowired
    private SDictionaryRepository sDictionaryRepository;

    public static HashMap<String ,String> specialRole = new HashMap<>();
    public static HashMap<String ,String> specialDept = new HashMap<>();
    public static HashMap<String ,String> salesman = new HashMap<>();
    public static HashMap<String ,String> assistant = new HashMap<>();
    public static HashMap<String ,String> admin = new HashMap<>();
    public static HashMap<String ,String> importAdmin = new HashMap<>();
    public static HashMap<String ,String> exportAdmin = new HashMap<>();
    //三级经理
    public static HashMap<String ,String> manager = new HashMap<>();
    public static HashMap<String ,String> maintManager = new HashMap<>();//维护部经理
    public static HashMap<String ,String> jzQy = new HashMap<>();
    public static HashMap<String ,String> jzDjYys = new HashMap<>();
    public static HashMap<String ,String> jzTtYys = new HashMap<>();
    public static HashMap<String ,String> jzYdYys = new HashMap<>();
    public static HashMap<String ,String> deptForGswl = new HashMap<>(); //所属部门为广厦网络股份有限公司
    public static HashMap<String ,String> hgb = new HashMap<>(); //合规部
    public static HashMap<String ,String> whb = new HashMap<>(); //业务部
    public static HashMap<String ,String> deptForShort = new HashMap<>(); //分公司
    //多部门查看(数据字典name=一级经理可以多查看【网络事业部，广东分公司，深圳网创通信】
    // name=全业务事业部一级经理  可以多查看【全业务事业部】
    public static HashMap<String ,String> rallyManager = new HashMap<>(); //业务部
    public static HashMap<String ,String> companyDept = new HashMap<>(); //可以查看本公司所有部门数据
    public static HashMap<String ,String> kingDeeUserMap = new HashMap<>(); //业务部
    public static HashMap<String ,String> kingDeeDeptMap = new HashMap<>(); //可以查看本公司所有部门数据
    //优化查询
    public static HashMap<String ,String> optimizekingDeeDeptMap = new HashMap<>(); //优化 区域
    public static HashMap<String ,String> optimizekingDeeUserMap = new HashMap<>(); //优化 区域
    public static HashMap<String ,String> optimizeJzQy = new HashMap<>(); //优化 区域
    public static HashMap<String ,String> optimizeJzYwx = new HashMap<>(); //优化 业务线
    public static HashMap<String ,String> optimizeJzDjYys = new HashMap<>();//优化dj运营商
    public static HashMap<String ,String> optimizeJzTtYys = new HashMap<>();//优化铁塔运营商
    public static HashMap<String ,String> optimizeJzYdYys = new HashMap<>();//优化移动运营商
    public static HashMap<String ,String> optimizeJzTtUpper = new HashMap<>();//优化铁塔上游客户
    public static HashMap<String ,String> optimizeJzYdUpper = new HashMap<>();//优化移动上游客户
    public static HashMap<String ,String> optimizeJzBuild = new HashMap<>();//优化移动上游客户

    /**
    * 保存 数据字典
    * @param sDictionary
    * @return
    */
    @Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT)
    @Override
    public CyPersistModel save(SDictionary sDictionary){
        //增加操作
        CyUserUtil.setCurrentPersistOperation(sDictionary);
        int line = sDictionaryRepository.insertSelective(sDictionary);
        this.dbInfo(CyUserUtil.getAuthenUsername()+"新增了ID为"+
sDictionary.getBusinessId()+"的数据字典信息","新增数据字典");
        log.info(CyUserUtil.getAuthenUsername()+"新增了ID为"+
            sDictionary.getBusinessId()+"的数据字典信息");
        return new CyPersistModel(line);
    }

    /**
    * 删除 数据字典
    * @param sDictionary
    * @return
    */
    @Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT)
    @Override
    public CyPersistModel remove(SDictionary sDictionary){
        int line = sDictionaryRepository.deleteByPrimaryKey(sDictionary.getBusinessId());
        this.dbInfo(CyUserUtil.getAuthenUsername()+"删除了ID为"+
sDictionary.getBusinessId()+"的数据字典信息","删除数据字典");
        log.info(CyUserUtil.getAuthenUsername()+"删除了ID为"+
            sDictionary.getBusinessId()+"的数据字典信息");
        return new CyPersistModel(line);
    }
    /**
    * 逻辑删除 数据字典
    * @param sDictionary
    * @return
    */
    @Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT)
    @Override
    public CyPersistModel removeLogical(SDictionary sDictionary){
        CyUserUtil.setCurrentMergeOperation(sDictionary);
        sDictionary.setDeleted();
        int line = sDictionaryRepository.logicalDelete(sDictionary);
        this.dbInfo(CyUserUtil.getAuthenUsername()+"逻辑删除了ID为"+
sDictionary.getBusinessId()+"的数据字典信息","逻辑删除数据字典");
        log.info(CyUserUtil.getAuthenUsername()+"逻辑删除了ID为"+
            sDictionary.getBusinessId()+"的数据字典信息");

        return new CyPersistModel(line);
    }
    /**
    * 修改 数据字典
    * @param sDictionary
    * @return
    */
    @Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT)
    @Override
    public CyPersistModel merge(SDictionary sDictionary){
        CyUserUtil.setCurrentMergeOperation(sDictionary);
        int line = sDictionaryRepository.updateByPrimaryKeySelective(sDictionary);
        this.dbInfo(CyUserUtil.getAuthenUsername()+"修改了ID为"+
sDictionary.getBusinessId()+"的数据字典信息","修改数据字典");
        log.info(CyUserUtil.getAuthenUsername()+"修改了ID为"+
            sDictionary.getBusinessId()+"的数据字典信息");
        return new CyPersistModel(line);
    }

    /**
    * 根据id查询 数据字典
    * @param id
    * @return
    */
    @Override
    public SDictionary findById(String id){
        return sDictionaryRepository.selectByPrimaryKey(id);
    }

    /**
    * 分页查询 数据字典
    * @param sDictionary
    * @return
    */
    @Override
    public List<SDictionary> findAllByPagination(CyPageUtil<SDictionary> paginationUtility,
        SDictionary sDictionary){
        sDictionary.setNormal();
        return sDictionaryRepository.querySDictionarys(sDictionary);
    }
    /**
    * 查询list 数据字典
    * @param sDictionary
    * @return
    */
    @Override
    public List<SDictionary> findAll(SDictionary sDictionary){
        sDictionary.setNormal();
        return sDictionaryRepository.querySDictionarys(sDictionary);
    }

    /**
     * 查询白名单
     */
    public void whiteList(){
        SDictionary sDictionary = new SDictionary();
        List<SDictionary> sDictionaries = this.findAll(sDictionary);
        for (SDictionary item : sDictionaries){
            if(item.getType().equals(DictionaryMap.jzMapRole)){
                specialRole.put(item.getName(),item.getValue());
            } else if(item.getType().equals(DictionaryMap.jzMapDept)){
                specialDept.put(item.getName(),item.getValue()); //放入特殊部门
            } else if(item.getType().equals(DictionaryMap.jzYwy)){
                salesman.put(item.getName(),item.getValue());
            } else if(item.getType().equals(DictionaryMap.jzZl)){
                assistant.put(item.getName(),item.getValue());
            } else if(item.getType().equals(DictionaryMap.admin)){
                admin.put(item.getName(),item.getValue());
            } else if(item.getType().equals(DictionaryMap.importAdmin)){
                importAdmin.put(item.getName(),item.getValue());  //导入管理员
            }else if(item.getType().equals(DictionaryMap.exportAdmin)){
                exportAdmin.put(item.getName(),item.getValue()); //导出管理员
            } else if(item.getType().equals(DictionaryMap.manager)){
                manager.put(item.getName(),item.getValue());
            } else if(item.getType().equals(DictionaryMap.jzLocation)){
                jzQy.put(item.getName(),item.getValue());
                optimizeJzQy.put(item.getValue(),item.getName()); //区域  value - name
            } else if(item.getType().equals(DictionaryMap.jzDjYys)){
                jzDjYys.put(item.getName(),item.getValue());
                optimizeJzDjYys.put(item.getValue(),item.getName()); //代缴运营商  value - name
            } else if(item.getType().equals(DictionaryMap.jzTtYys)){
                jzTtYys.put(item.getName(),item.getValue());
                optimizeJzTtYys.put(item.getValue(),item.getName()); //铁塔运营商  value - name
            } else if(item.getType().equals(DictionaryMap.jzYdYys)){
                jzYdYys.put(item.getName(),item.getValue());
                optimizeJzYdYys.put(item.getValue(),item.getName()); //移动运营商  value - name
            }else if (item.getType().equals(DictionaryMap.deptForGswl)){
                deptForGswl.put(item.getName(),item.getValue());  //放入所属广厦网络股份有限公司的所有部门
            }else if (item.getType().equals(DictionaryMap.hgb)){
                hgb.put(item.getName(),item.getValue()); //所有合规部
            }else if (item.getType().equals(DictionaryMap.whb)){
                whb.put(item.getName(),item.getValue()); //所有维护部
            }else if (item.getType().equals(DictionaryMap.deptForShort)){
                deptForShort.put(item.getValue(),item.getName()); //所有分公司（除广厦有限分公司外 ）
            }else if (item.getType().equals(DictionaryMap.maintManager)){
                maintManager.put(item.getName(),item.getValue()); //获取维护部二级经理
            }else if (item.getType().equals(DictionaryMap.rallyManager)){
                rallyManager.put(item.getName(),item.getValue()); //多部门查看
            }else if (item.getType().equals(DictionaryMap.companyDept)){
                companyDept.put(item.getName(),item.getValue()); //此部门可查看本公司所有数据
            }else if (item.getType().equals(DictionaryMap.kingDeeUserMap)){
                kingDeeUserMap.put(item.getName(),item.getValue()); //用户
                optimizekingDeeUserMap.put(item.getValue(),item.getName());
            }else if (item.getType().equals(DictionaryMap.kingDeeDeptMap)){
                kingDeeDeptMap.put(item.getName(),item.getValue()); //组织
                optimizekingDeeDeptMap.put(item.getValue(),item.getName());
            }
            //优化
           else if (item.getType().equals(DictionaryMap.jzYwx)){
                optimizeJzYwx.put(item.getValue(),item.getName()); //业务线  value - name
            }else if (item.getType().equals(DictionaryMap.jzTtUpper)){
                optimizeJzTtUpper.put(item.getValue(),item.getName()); //铁塔上游客户  value - name
            }else if (item.getType().equals(DictionaryMap.jzYdUpper)){
                optimizeJzYdUpper.put(item.getValue(),item.getName()); //移动上游客户  value - name
            }else if (item.getType().equals(DictionaryMap.jzBuild)){
                optimizeJzBuild.put(item.getValue(),item.getName()); //移动上游客户  value - name
            }


        }
        log.info(admin.toString());
    }
   /*    @Override
    public void whiteList(){
        SDictionary sDictionary = new SDictionary();
        List<SDictionary> sDictionaries = this.findAll(sDictionary);
        for (SDictionary item : sDictionaries){
            if(item.getType().equals(DictionaryMap.jzMapRole)){
                specialRole.put(item.getBusinessId(),item.getValue());
            } else if(item.getType().equals(DictionaryMap.jzMapDept)){
                specialDept.put(item.getBusinessId(),item.getValue()); //放入特殊部门
            } else if(item.getType().equals(DictionaryMap.jzYwy)){
                salesman.put(item.getBusinessId(),item.getValue());
            } else if(item.getType().equals(DictionaryMap.jzZl)){
                assistant.put(item.getBusinessId(),item.getValue());
            } else if(item.getType().equals(DictionaryMap.admin)){
                admin.put(item.getBusinessId(),item.getValue());
            } else if(item.getType().equals(DictionaryMap.importAdmin)){
                importAdmin.put(item.getBusinessId(),item.getValue());  //导入管理员
            }else if(item.getType().equals(DictionaryMap.exportAdmin)){
                exportAdmin.put(item.getBusinessId(),item.getValue()); //导出管理员
            } else if(item.getType().equals(DictionaryMap.manager)){
                manager.put(item.getName(),item.getValue());
            } else if(item.getType().equals(DictionaryMap.jzLocation)){
                jzQy.put(item.getName(),item.getValue());
            } else if(item.getType().equals(DictionaryMap.jzDjYys)){
                jzDjYys.put(item.getName(),item.getValue());
            } else if(item.getType().equals(DictionaryMap.jzTtYys)){
                jzTtYys.put(item.getName(),item.getValue());
            } else if(item.getType().equals(DictionaryMap.jzYdYys)){
                jzYdYys.put(item.getName(),item.getValue());
            }else if (item.getType().equals(DictionaryMap.deptForGswl)){
                deptForGswl.put(item.getName(),item.getValue());  //放入所属广厦网络股份有限公司的所有部门
            }else if (item.getType().equals(DictionaryMap.hgb)){
                hgb.put(item.getName(),item.getValue()); //所有合规部
            }else if (item.getType().equals(DictionaryMap.whb)){
                whb.put(item.getName(),item.getValue()); //所有维护部
            }else if (item.getType().equals(DictionaryMap.deptForShort)){
                deptForShort.put(item.getValue(),item.getName()); //所有分公司（除广厦有限分公司外 ）
            }else if (item.getType().equals(DictionaryMap.maintManager)){
                maintManager.put(item.getBusinessId(),item.getValue()); //获取维护部二级经理
            }else if (item.getType().equals(DictionaryMap.rallyManager)){
                rallyManager.put(item.getName(),item.getValue()); //多部门查看
            }else if (item.getType().equals(DictionaryMap.companyDept)){
                companyDept.put(item.getName(),item.getValue()); //此部门可查看本公司所有数据
            }
        }
        log.info(admin.toString());
    }*/

    @Override
    public List<SDictionary> selectDjYsByType(SDictionary sDictionary) {
        sDictionary.setNormal();
        List<String> typeList = new ArrayList();
        typeList.add(DictionaryMap.jzDjYys);
        sDictionary.setTypeList(typeList);
        return sDictionaryRepository.queryByType(sDictionary);
    }

    @Override
    public List<SDictionary> selectTtYsByType(SDictionary sDictionary) {
        sDictionary.setNormal();
        List<String> typeList = new ArrayList();
        typeList.add(DictionaryMap.jzTtYys);
        sDictionary.setTypeList(typeList);
        return sDictionaryRepository.queryByType(sDictionary);
    }
    @Override
    public List<SDictionary> selectYdYsByType(SDictionary sDictionary) {
        sDictionary.setNormal();
        List<String> typeList = new ArrayList();
        typeList.add(DictionaryMap.jzYdYys);
        typeList.add(DictionaryMap.jzYdYys);
        sDictionary.setTypeList(typeList);
        return sDictionaryRepository.queryByType(sDictionary);
    }
    @Override
    public List<SDictionary> selectQYByType(SDictionary sDictionary) {
        sDictionary.setNormal();
        List<String> typeList = new ArrayList();
        typeList.add(DictionaryMap.jzLocation);
        sDictionary.setTypeList(typeList);
        return sDictionaryRepository.queryByType(sDictionary);
    }
    @Override
    public List<SDictionary> selectYWXByType(SDictionary sDictionary) {
        sDictionary.setNormal();
        List<String> typeList = new ArrayList();
        typeList.add(DictionaryMap.jzYwx);
        sDictionary.setTypeList(typeList);
        return sDictionaryRepository.queryByType(sDictionary);
    }
    @Override
    public List<SDictionary> selectYdUpperByType(SDictionary sDictionary) {
        sDictionary.setNormal();
        List<String> typeList = new ArrayList();
        typeList.add(DictionaryMap.jzYdUpper);
        sDictionary.setTypeList(typeList);
        return sDictionaryRepository.queryByType(sDictionary);
    }
    @Override
    public List<SDictionary> selectTtUpperByType(SDictionary sDictionary) {
        sDictionary.setNormal();
        List<String> typeList = new ArrayList();
        typeList.add(DictionaryMap.jzTtUpper);
        sDictionary.setTypeList(typeList);
        return sDictionaryRepository.queryByType(sDictionary);
    }
    @Override
    public List<SDictionary> selectBuildByType(SDictionary sDictionary){
        sDictionary.setNormal();
        List<String> typeList = new ArrayList();
        typeList.add(DictionaryMap.jzBuild);
        sDictionary.setTypeList(typeList);
        return sDictionaryRepository.queryByType(sDictionary);
    }
    /**
     *查询是否属于合规部
     */
    @Override
    public List<SDictionary> selectHGBByCode(SDictionary sDictionary){
        sDictionary.setNormal();
        List<String> typeList = new ArrayList();
        typeList.add(DictionaryMap.hgb);
        sDictionary.setTypeList(typeList);
        return sDictionaryRepository.queryByType(sDictionary);

    }

    /**
     *查询是否属于维护部
     */
    @Override
    public List<SDictionary> selectWHBByCode(SDictionary sDictionary){
        sDictionary.setNormal();
        List<String> typeList = new ArrayList();
        typeList.add(DictionaryMap.whb);
        sDictionary.setTypeList(typeList);
        return sDictionaryRepository.queryByType(sDictionary);
    }

}
