package org.rcisoft.business.suser.dao;

import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.ResultMap;
import org.apache.ibatis.annotations.Select;
import org.rcisoft.business.suser.entity.KingdeeUserDto;
import org.rcisoft.business.suser.entity.SUser;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * @Author: jiangpengpeng
 * @Description:
 * @Date: Created in 14:47  2019/10/28
 * @Modified By:
 */
@Repository
public interface KingdeeUserRepository {

    /**
     * 查询当前阶段负责人和任务id
     */
    @Select("<script>SELECT " +
            "s_user.BUSINESS_ID, " +
            "s_user.LOGIN_NAME, " +
            "s_user.DEPT_ID, " +
            "s_user_role.ROLE_ID, " +
            "ACT_RU_IDENTITYLINK.TASK_ID_ AS TASK_ID_, " +
            "( " +
            "SELECT " +
            "jz_message.jz_cur_dept " +
            "FROM " +
            "jz_message " +
            "WHERE " +
            "jz_message.project_code = #{projectCode} " +
            "AND jz_message.del_flag = '0' " +
            "AND jz_message.flag = '1' " +
            ") AS JZ_DEPT_ID " +
            "FROM " +
            "s_user " +
            "LEFT JOIN s_user_role ON s_user.BUSINESS_ID = s_user_role.USER_ID " +
            "LEFT JOIN ACT_RU_IDENTITYLINK ON s_user_role.ROLE_ID = ACT_RU_IDENTITYLINK.GROUP_ID_ " +
            "WHERE " +
            "1 = 1 " +
            "AND s_user.DEL_FLAG = '0' " +
            "AND s_user.FLAG = '1' " +
            "AND ACT_RU_IDENTITYLINK.TASK_ID_ = ( " +
            "SELECT " +
            "ACT_RU_TASK.ID_ " +
            "FROM " +
            "ACT_RU_TASK " +
            "WHERE " +
            "PROC_INST_ID_ = ( " +
            "SELECT " +
            "pd.process_id " +
            "FROM " +
            "process_mid pd " +
            "WHERE " +
            "pd.type_template = #{templateType} " +
            "AND pd.jz_message_id = ( " +
            "SELECT " +
            "jm.business_id " +
            "FROM " +
            "jz_message jm " +
            "WHERE " +
            "jm.project_code = #{projectCode} " +
            ") " +
            "AND pd.version = ( " +
            "SELECT " +
            "MAX(version) " +
            "FROM " +
            "process_mid pd1 " +
            "WHERE " +
            "pd1.type_template = #{templateType} " +
            "AND pd1.jz_message_id = ( " +
            "SELECT " +
            "business_id " +
            "FROM " +
            "jz_message jm1 " +
            "WHERE " +
            "jm1.project_code = #{projectCode} " +
            ") " +
            ") " +
            ") " +
            ")</script>")
    @ResultMap(value = "BaseResultMap")
    List<KingdeeUserDto> toDOTaskUser(@Param("projectCode")String projectCode, @Param("templateType")String templateType);
}
