package org.rcisoft.business.suser.dao;

import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.ResultMap;
import org.apache.ibatis.annotations.Update;
import org.rcisoft.business.suser.entity.SDept;
import org.rcisoft.business.suser.entity.SUserRole;
import org.rcisoft.core.base.CyBaseMapper;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public interface SDeptSYNRepo extends CyBaseMapper<SDept> {

    @Insert("<script>insert into s_dept(business_id," +
            "parent_id," +
            "name," +
            "case_count," +
            "sort," +
            "code," +
            "create_by," +
            "create_date," +
            "update_by," +
            "update_date," +
            "del_flag," +
            "flag) value " +
            "<foreach collection =\"sDepts\" item=\"item\"  separator=\",\" > " +
            "(" +
            "#{item.businessId}, " +
            "#{item.parentId}, " +
            "#{item.name}, " +
            "#{item.caseCount}, " +
            "#{item.sort}," +
            "#{item.code}," +
            "#{item.createBy}," +
            "#{item.createDate}," +
            "#{item.updateBy}," +
            "#{item.updateDate}," +
            "#{item.delFlag}," +
            "#{item.flag}" +
            ")" +
            "</foreach></script>")
    @ResultMap(value = "BaseResultMap" )
    int saveDeptSYN(@Param("sDepts") List<SDept> sDepts);

    @Update("delete from s_dept where 1=1")
    @ResultMap(value = "BaseResultMap" )
    void removeAll();
}
