package org.rcisoft.business.suser.entity;

import lombok.*;

import org.rcisoft.core.entity.CyIdEntity;
import javax.persistence.*;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.io.Serializable;
import java.util.Date;
import java.util.List;

/**
* Created with cy on 2019-8-5 15:25:03.
*/
@Entity
@Data
@NoArgsConstructor
@AllArgsConstructor
@Table(name = "s_user")
public class SUser  extends CyIdEntity<SUser> {



     /**
     * @desc 用户名
     * @column LOGIN_NAME
     * @default 
     */
     private String loginName;

     /**
     * @desc 密码
     * @column PASSWORD
     * @default 
     */
     private String password;

     /**
     * @desc 姓名
     * @column NAME
     * @default 
     */
     private String name;

     /**
     * @desc 性别（0：男，1：女）
     * @column SEX
     * @default 
     */
     private String sex;

     /**
     * @desc 手机号码
     * @column PHONE
     * @default 
     */
     private String phone;

     /**
     * @desc 部门表id
     * @column DEPT_ID
     * @default 
     */
     private String deptId;

     /**
     * @desc 邮箱
     * @column EMAIL
     * @default 
     */
     private String email;

     /**
      * @desc 备注
      * @column REMARKS
      * @default
      */
     private String remarks;
     /**
      * @desc 维护部部门id
      */
     @Transient
     private List<String> maintainList;

     /**
      * @desc 二级维护经理role_id
      */
     @Transient
     private List<String> mainRoleList;

     /**
      * @desc business_id list
      */
     @Transient
     private List<String> businessIds;

     /**
      * @desc 角色编号
      */
     @Transient
     private String roleCode;

     /**
      * @desc 角色标识
      */
     @Transient
     private String selectTab;

     /**
      * 任务id
      */
     @Transient
     private String taskId;
     @Transient
     private String roleId;
     @Transient
     private String jzdeptId;
}

