package org.rcisoft.business.userwarning.dao;

import org.apache.ibatis.annotations.*;
import org.omg.CORBA.StringHolder;
import org.rcisoft.core.base.CyBaseMapper;
import org.rcisoft.business.userwarning.entity.UserWarning;
import org.springframework.security.core.parameters.P;
import org.springframework.stereotype.Repository;


import javax.annotation.ParametersAreNonnullByDefault;
import java.util.List;

/**
* Created with cy on 2019-7-30 14:54:13.
*/
@Repository
public interface UserWarningRepository extends CyBaseMapper<UserWarning> {

    /**
    * 分页查询 userWarning
    *
    */
   /* @Select("<script>select uw.*, " +
            "jm.jz_project_id as jzProjectId, " +
            "jm.jz_name as jzName," +
            "jm.jz_type as jzType, " +
            "jm.business_line as businessLine, " +
            "sd.name as ywxName, " +
            "jm.jz_yys as jzYys, " +
            "jm.jz_qy as jzQy  " +
            "from user_warning uw " +
            "left join jz_message jm on uw.jz_id = jm.business_id " +
            "left join s_dictionary sd on jm.business_line = sd.value and sd.type = 'JZ_YWX' " +
            "where 1=1 "
            + "<if test=\"userId !=null and userId != '' \">and uw.user_id = #{userId} </if> "
            + "and uw.del_flag = '0' "
            + "and uw.flag = '1'"
            + "and jm.del_flag = '0' "
            + "and jm.flag = '1' "
            + "and uw.warning_status = '0' "
            + " order by uw.create_date desc "
            + "</script>")
    @ResultMap(value = "BaseResultMap" )
    List<UserWarning> queryUserWarnings(UserWarning userWarning);*/


    /**
     * 分页查询 userWarning
     *
     */
    @Select("<script>select uw.*, " +
            "(select jz_project_id  from jz_message jz where jz.business_id = uw.jz_id and del_flag = '0' and flag = '1' ) AS jzProjectId , " +
            "(select jz_type    from jz_message jz where jz.business_id = uw.jz_id and del_flag = '0' and flag = '1' ) AS jzType , " +
            "(select jz_name from jz_message jz where jz.business_id = uw.jz_id and del_flag = '0' and flag = '1' )  AS jzName , " +
            "(select business_line   from jz_message jz where jz.business_id = uw.jz_id and del_flag = '0' and flag = '1' ) AS businessLine , " +
            "(select jz_yys   from jz_message jz where jz.business_id = uw.jz_id and del_flag = '0' and flag = '1' ) AS jzYys , " +
            "(select jz_qy  from jz_message jz where jz.business_id = uw.jz_id and del_flag = '0' and flag = '1' ) AS jzQy " +
            "from user_warning uw " +
            "where 1=1 "
            + "<if test=\"userId !=null and userId != '' \">and uw.user_id = #{userId} </if> "
            + "and uw.del_flag = '0' "
            + "and uw.flag = '1'"
            + "and uw.warning_status = '0' "
            + " order by uw.create_date desc "
            + "</script>")
    @ResultMap(value = "BaseResultMap" )
    List<UserWarning> queryUserWarnings(UserWarning userWarning);

    /**
     * 批量添加未在指定时间内完成任务的业务员
     * @param userWarnings
     * @return
     */
    @Insert("<script>" +
            "INSERT INTO user_warning (business_id, create_by, create_date, update_by, update_date, del_flag, flag, remarks, jz_id, user_id, type, message, warning_status, jz_status ) " +
            "VALUES " +
            "<foreach collection = 'list' index='index' item='id' open='' separator=',' close=''>" +
            "(#{id.businessId}, #{id.createBy}, #{id.createDate}, #{id.updateBy}, #{id.updateDate}, #{id.delFlag}, #{id.flag}, #{id.remarks}, #{id.jzId}, #{id.userId}, #{id.type}, #{id.message}, #{id.warningStatus}, #{id.jzStatus})" +
            "</foreach>" +
            "</script>")
    int addMoreWarningUser(@Param("list") List<UserWarning> userWarnings);

    /**
     *  查询未处理的业务员的数量
     * @param userWarning
     * @return
     */
    @Select("<script>select count(0) from user_warning where 1=1 "
            + "<if test=\"delFlag !=null and delFlag != '' \">and del_flag = #{delFlag} </if> "
            + "<if test=\"flag !=null and flag != '' \">and flag = #{flag} </if> "
            + "<if test=\"userId !=null and userId != '' \">and user_id = #{userId} </if> "
            + "and warning_status = '0' "
            + "</script>")
    int queryUserWarningNumbers(UserWarning userWarning);

    /**
     * 查询警告中的未处理的业务员
     * @param userWarning
     * @return
     */
    @Select("<script>select * from user_warning where 1=1 "
            + "<if test=\"delFlag !=null and delFlag != '' \">and del_flag = #{delFlag} </if> "
            + "<if test=\"flag !=null and flag != '' \">and flag = #{flag} </if> "
            + "and warning_status = '0' and type = '0'"
            + "</script>")
    @ResultMap(value = "BaseResultMap" )
    List<UserWarning> queryUserWarningsMoreThanDate (UserWarning userWarning);

    /**
     * 根据业务员的userId 和 要查的角色名 来查询同一部门中的 其他角色的 userId
     * @param userId
     * @param code
     * @return
     */
    @Select("<script> SELECT su.BUSINESS_ID FROM s_user AS su " +
            "JOIN s_user_role AS sur ON su.BUSINESS_ID = sur.USER_ID " +
            "JOIN s_role AS sr ON sur.ROLE_ID = sr.BUSINESS_ID " +
            "WHERE 1=1 " +
            "AND su.DEL_FLAG = 0 " +
            "AND su.FLAG = 1 " +
            "AND sr.FLAG = 1 " +
            "AND sr.DEL_FLAG = 0 " +
            "AND su.DEPT_ID = (SELECT DEPT_ID FROM s_user WHERE BUSINESS_ID = #{userId})  " +
            "AND sr.CODE = #{code} " +
            "</script>")
    List<String> queryManagerByUserId(@Param("userId") String userId, @Param("code") String code);

    /**
     * 根据基站阶段名称去查询时长限制
     * @param value
     * @return
     */
    @Select("<script>select name " +
            "from s_dictionary " +
            "where 1=1 " +
            "AND del_flag = 0 "
            + "AND flag = 1 " +
            "AND value = #{value} " +
            "AND type = #{jzDeadline} "
            + "</script>")
    String queryDeadlineFromsDictionary(@Param("value") String value, @Param("jzDeadline") String jzDeadline);
    /**
     *
     */
    @Update("<script> " +
            "UPDATE user_warning " +
            "SET warning_status = '1' " +
            "WHERE 1 = 1 " +
            "<if test=\"delFlag !=null and delFlag != '' \">and del_flag = #{delFlag} </if> " +
            "<if test=\"flag !=null and flag != '' \">and flag = #{flag} </if> " +
            "AND warning_status = '0' " +
            "AND jz_status = #{jzStatus} " +
            "AND jz_id = #{jzId}" +
            "</script>")
    int updateWarning(UserWarning userWarning);

    @Update("<script> " +
            "UPDATE user_warning " +
            "SET warning_status = '1' " +
            "WHERE 1 = 1 " +
            "<if test=\"delFlag !=null and delFlag != '' \">and del_flag = #{delFlag} </if> " +
            "<if test=\"flag !=null and flag != '' \">and flag = #{flag} </if> " +
            "AND warning_status = '0' " +
            "AND jz_id = #{jzId}" +
            "</script>")
    int updateAllWarning(UserWarning userWarning);


    //查询预警状态
    @Select("<script>select * from user_warning where warning_status = '0' " +
            "<if test=\"delFlag !=null and delFlag != '' \">and del_flag = #{delFlag} </if> " +
            "<if test=\"flag !=null and flag != '' \">and flag = #{flag} </if> " +
            "and jz_id = #{jzId} and user_id = #{userId} " +
            "</script>")
    @ResultMap(value = "BaseResultMap" )
    List<UserWarning> queryIsWaring(UserWarning userWarning);
}

