package org.rcisoft.business.userwarning.entity;

import lombok.*;

import org.rcisoft.core.entity.CyIdEntity;
import javax.persistence.*;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.io.Serializable;
import java.util.Date;
import java.util.List;

/**
* Created with cy on 2019-7-30 14:54:13.
*/
@Entity
@Data
@NoArgsConstructor
@AllArgsConstructor
@Table(name = "user_warning")
public class UserWarning  extends CyIdEntity<UserWarning> {
     /**
     * @desc 基站编号
     * @column jz_id
     * @default 
     */
     private String jzId;

     /**
     * @desc 业务员编号
     * @column user_id
     * @default 
     */
     private String userId;

     /**
     * @desc 类型（0：业务员看的信息 1：经理看的信息）
     * @column type
     * @default 
     */
     private String type;

     /**
     * @desc 信息
     * @column message
     * @default 
     */
     private String message;

     /**
      * @desc 警告处理状态(0：未处理 1：已处理)
      * @column warning_status
      * @default
      */
     private String warningStatus;

     /**
      * 基站的状态 （待选址之类的-----）
      */
     private String jzStatus;

     /**
      * 基站名称
      */
     @Transient
     private String jzName;

     /**
      * 项目Id
      */
     @Transient
     private String jzProjectId;

     /**
      * 基站类型
      */
     @Transient
     private String jzType;

     /**
      * 业务线
      */
     @Transient
     private String businessLine;

     /**
      * 运营商
      */
     @Transient
     private String jzYys;

     /**
      * 区域
      */
     @Transient
     private String jzQy;

     /**
      * 类型名称
      */
     @Transient
     private String typeName;
     /**
      * 业务线名称
      */
     @Transient
     private String ywxName;


}

