package org.rcisoft.business.userwarning.service;

import org.rcisoft.business.userwarning.entity.UserWarning;
import org.rcisoft.core.model.CyPersistModel;
import org.rcisoft.core.aop.CyPageUtil;

import java.util.List;

/**
 * Created by cy on 2019-7-30 14:54:13.
 */
public interface UserWarningService {

    /**
    * 保存 
    * @param userWarning
    * @return
    */
    CyPersistModel save(UserWarning userWarning);

    /**
    * 删除 
    * @param userWarning
    * @return
    */
    CyPersistModel remove(UserWarning userWarning);
    /**
    * 逻辑删除 
    * @param userWarning
    * @return
    */
    CyPersistModel removeLogical(UserWarning userWarning);
    /**
    * 修改 
    * @param userWarning
    * @return
    */
    CyPersistModel merge(UserWarning userWarning);

    /**
    * 根据id查询 
    * @param id
    * @return
    */
    UserWarning findById(String id);

    /**
    * 分页查询 
    * @param userWarning
    * @return
    */
    List<UserWarning> findAllByPagination(CyPageUtil<UserWarning> paginationUtility,
                                          UserWarning userWarning);


    /**
    * 查询list
    * @param userWarning
    * @return
    */
    List<UserWarning> findAll(UserWarning userWarning);

    /**
     * 查询未处理的业务员的数量
     * @param userWarning
     * @return
     */
    int queryUserWarningNumbers(UserWarning userWarning);

    /**
     * 查询警告中的未处理的业务员
     * @param userWarning
     * @return
     */
    List<UserWarning> queryUserWarningsMoreThanDate (UserWarning userWarning);

    /**
     * 处理警告
     * @param userWarning
     * @return
     */
    int dealWarning(UserWarning userWarning);

    /**
     * 处理全部警告
     * @param userWarning
     * @return
     */
    int dealAllWarning(UserWarning userWarning);
}