package org.rcisoft.business.xgjzmessage.dao;

import org.apache.ibatis.annotations.Param;
import org.rcisoft.core.base.CyBaseMapper;
import org.rcisoft.business.xgjzmessage.entity.XgJzMessage;
import org.apache.ibatis.annotations.ResultMap;
import org.apache.ibatis.annotations.Select;
import org.springframework.stereotype.Repository;


import java.util.List;

/**
* Created with lpy on 2019-7-26 15:45:51.
*/
@Repository
public interface XgJzMessageRepository extends CyBaseMapper<XgJzMessage> {

    /**
    * 分页查询 xgJzMessage
    *
    */
    @Select("<script>select * from xg_jz_message where 1=1 "
            + "<if test=\"delFlag !=null and delFlag != '' \">and del_flag = #{delFlag} </if> "
            + "<if test=\"flag !=null and flag != '' \">and flag = #{flag} </if> "
            + "</script>")
    @ResultMap(value = "BaseResultMap" )
    List<XgJzMessage> queryXgJzMessages(XgJzMessage xgJzMessage);

    @Select("<script>select jz.*," +
            "sde1. NAME AS curDeptName, " +
            "su1. NAME AS curUserName, " +
            "su3. NAME AS projectOwner, " +
            "sdi2. NAME AS yysName, " +
            "sdi. NAME jzLocationName, " +
            "sdi3. NAME AS ywxName," +
            "su4.NAME AS updateName " +
            " from xg_jz_message jz " +
            "left join s_user su4 on jz.update_by = su4.BUSINESS_ID" +
            " left join s_dept sde1 on jz.jz_cur_dept = sde1.BUSINESS_ID" +
            " left join s_user su1 on jz.jz_cur_user = su1.BUSINESS_ID" +
            " left join s_user su3 on jz.jz_project_owner = su3.BUSINESS_ID" +
            " left join s_dictionary sdi on jz.jz_qy = sdi.`value` and sdi.type = 'JZ_QY'" +
            " left join s_dictionary sdi3 on jz.business_line = sdi3.`value` and sdi3.type = 'JZ_YWX'" +
            " left join s_dictionary sdi2 on jz.jz_yys = sdi2.`value` and sdi2.type = 'JZ_YYS'" +
            " where jz.business_id = #{jzMessageId} " +
            " ORDER BY jz.update_date DESC" +
            "</script>")
    @ResultMap(value = "BaseResultMap" )
    List<XgJzMessage> XgJzMessages(@Param("jzMessageId") String jzMessageId);

}

