package org.rcisoft.common;

import javafx.stage.Stage;
import org.rcisoft.business.sdictionary.entity.SDictionary;
import org.rcisoft.core.result.CyResultCode;
import org.rcisoft.core.result.CyResultExceptionEnum;

import java.beans.ConstructorProperties;

public enum ResultServiceExceptionEnums implements CyResultExceptionEnum {

    START_PROCESS_ERROR(4005, "启动流程错误"),

    JZ_CODE_ERROR(4006, "项目编号不能重复"),

    SDictionary_NULL_ERROR(4007, "数据字典不存在"),
    NOT_CUR_USER(4009, "非当前业务员"),

    JZ_UNAUTHORIZED(CyResultCode.UNAUTHORIZED.getCode(),"权限不足"),

    JZMESSAGE_NULL(4008,"基站信息为空"),

    STAGE_LEADER_CHANGE_INPROCESS(4010,"该基站已在流程中，请勿重复启动流程");



    private Integer code;
    private String message;

    public Integer getCode() {
        return this.code;
    }

    public String getMessage() {
        return this.message;
    }

    private ResultServiceExceptionEnums() {
    }

    @ConstructorProperties({"code", "message"})
    private ResultServiceExceptionEnums(Integer code, String message) {
        this.code = code;
        this.message = message;
    }
}